datablock AudioProfile(BR55Test1Sound)
{
   filename    = "./test1.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(BR55Fire2Sound)
{
   filename    = "./test2.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(BR55Test3Sound)
{
   filename    = "./test3.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(BR55Fire1Sound)
{
   filename    = "./fire1.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(BR55Fire2Sound)
{
   filename    = "./fire2.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(BR55clipIn1Sound)
{
   filename    = "./clipIn1.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(BR55clipOut1Sound)
{
   filename    = "./clipOut1.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(BR55clipIn_e1Sound)
{
   filename    = "./clipIn_e1.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(BR55clipIn2Sound)
{
   filename    = "./clipIn2.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(BR55clipOut2Sound)
{
   filename    = "./clipOut2.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(BR55clipIn_e2Sound)
{
   filename    = "./clipIn_e2.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(BR55Use1Sound)
{
   filename    = "./use1.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(BR55Use2Sound)
{
   filename    = "./use2.wav";
   description = AudioClose3d;
   preload = true;
};

//shell
datablock DebrisData(BR55Casing)
{
	shapeFile = "./MA5Cshell.dts";
	lifetime = 2.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};

//Effects
//Flash
datablock ParticleData(BR55flashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "./brMuzFlare";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.5 0.5 0.5 0.9";
	colors[1]     = "0.5 0.5 0.5 0.0";
	sizes[0]      = 1.0;
	sizes[1]      = 2.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(BR55FlashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 25;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "BR55flashParticle";

   uiName = "BR55 Flash";
};

//bullet trail effects
datablock ParticleData(BR55bulletTrailParticle)
{
	dragCoefficient      = 10;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 1.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 525;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.3 0.3 0.0 0.8";
	colors[1]     = "0.3 0.3 0.0 0.6";
	colors[2]     = "0.3 0.3 0.0 0.0";
	sizes[0]      = 0.06;
	sizes[1]      = 0.06;
	sizes[2]	  = 0.01;
	times[0]      = 0.0;
	times[1]	  = 0.9;
	times[2]      = 1.0;

	useInvAlpha = false;
};

AddDamageType("BR55",   '<bitmap:add-ons/Weapon_The_New_Halo_Pack/BR55/CI_BR55> %1',    '%2 <bitmap:add-ons/Weapon_The_New_Halo_Pack/BR55/CI_BR55> %1',0.2,1);
datablock ProjectileData(BR55Projectile)
{
   projectileShapeName = "./bullet.dts";
   directDamage        = 20;
   directDamageType    = $DamageType::BR55;
   radiusDamageType    = $DamageType::BR55;

   brickExplosionRadius = 2;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 1;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 5;
   verticalImpulse	  = 0;
   explosion           = gunExplosion;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 0;

   hasLight    = true;
   lightRadius = 5.0;
   lightColor  = "0.5 0.5 0";

   uiName = "BR55 Bullet";
};

//////////
// item //
//////////
datablock ItemData(BR55Item)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./BR55_Ground.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "BR55 Battle Rifle";
	iconName = "./UI_BR55";
	doColorShift = true;
	colorShiftColor = "0.5 0.5 0.5 1.000";

	 // Dynamic properties defined by the scripts
	image = BR55Image;
	canDrop = true;

	maxAmmo = 36;
	canReload = 1;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(BR55Image)
{
   // Basic Item properties
   shapeFile = "./BR55.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = "0.45 1.3 -0.40"; //"0.7 1.2 -0.5"; -Left +Right, -Back +Front, -Down +Up
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BR55Item;
   ammo = " ";
   projectile = BR55Projectile;
   projectileType = Projectile;
   
	casing = BR55Casing;
	shellExitDir        = "2.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 25.0;	
	shellVelocity       = 10.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = BR55Item.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.
   // Initial start up state
	stateName[0]                     	= "Activate";
	stateTimeoutValue[0]             	= 0.53;
	stateTransitionOnTimeout[0]       	= "LoadCheckA";
	//stateSound[0]				= BR55UseSound;
	stateSequence[0]			= "use";
	stateScript[0]				= "onUse";

	stateName[1]                     	= "Ready";
	stateTransitionOnNoAmmo[1]       	= "Reload";
	stateTransitionOnTriggerDown[1]  	= "Fire1";
	stateAllowImageChange[1]         	= true;

	
	//Burst Sector ---------------------------------------------------------------------
	
	stateName[19]                    	= "Fire1";
	stateTransitionOnTimeout[19]     	= "Fire2";
	stateTimeoutValue[19]            	= 0.07;
	stateFire[19]                    	= true;
	stateAllowImageChange[19]        	= false;
	stateSequence[19]                	= "fire";
	stateScript[19]                  	= "onFire";
	stateEjectShell[19]       	  	= true;
	stateEmitter[19]				= BR55FlashEmitter;
	stateEmitterTime[19]			= 0.05;
	stateEmitterNode[19]			= "muzzleNode";
	stateWaitForTimeout[19]			= true;
	//stateSound[19]				= BR551Sound;
	
	stateName[21]                    	= "Fire2";
	stateTransitionOnTimeout[21]     	= "Fire3";
	stateTimeoutValue[21]            	= 0.07;
	stateFire[21]                    	= true;
	stateAllowImageChange[21]        	= false;
	stateSequence[21]                	= "fire";
	stateScript[21]                  	= "onFire";
	stateEjectShell[21]       	  	= true;
	stateEmitter[21]				= BR55FlashEmitter;
	stateEmitterTime[21]			= 0.05;
	stateEmitterNode[21]			= "muzzleNode";
	stateWaitForTimeout[21]			= true;
	//stateSound[21]				= BR551Sound;
	
	stateName[20]                    	= "Fire3";
	stateTransitionOnTimeout[20]     	= "Delay";
	stateTimeoutValue[20]            	= 0.1;
	stateFire[20]                    	= true;
	stateAllowImageChange[20]        	= false;
	stateSequence[20]                	= "fire";
	stateScript[20]                  	= "onFire";
	stateEjectShell[20]       	  	= true;
	stateEmitter[20]				= BR55FlashEmitter;
	stateEmitterTime[20]			= 0.05;
	stateEmitterNode[20]			= "muzzleNode";
	stateWaitForTimeout[20]			= true;
	//stateSound[20]				= BR551Sound;
	
	//End Burst---------------------------------------------------------------------
	
	stateName[18]="Ready2";
	stateTransitionOnTriggerUp[18]="Ready";
	
	stateName[3]				= "Delay";
	stateTransitionOnTimeout[3]     	= "FireLoadCheckA";
	stateTimeoutValue[3]            	= 0.20;
	
	stateName[8]				= "LoadCheckA";
	stateScript[8]				= "onLoadCheck";
	stateTimeoutValue[8]			= 0.01;
	stateTransitionOnTimeout[8]		= "LoadCheckB";
	
	stateName[9]				= "LoadCheckB";
	stateTransitionOnAmmo[9]		= "Ready2";
	stateTransitionOnNoAmmo[9]		= "ReloadE";

	stateName[10]				= "Reload";
	stateTimeoutValue[10]			= 0.76;
	stateScript[10]				= "onReloadStart";
	stateTransitionOnTimeout[10]		= "Wait";
	stateWaitForTimeout[10]			= true;
	stateSequence[10]			= "clipOut";
	//stateSound[10]				= BR55MagOutSound;
	
	stateName[11]				= "Wait";
	stateTimeoutValue[11]			= 1.20;
	//stateSound[11]				= BR55MagInSound;
	stateScript[11]				= "onReloadWait";
	stateSequence[11]			= "clipIn";
	stateTransitionOnTimeout[11]		= "Reloaded";
	
	stateName[12]				= "FireLoadCheckA";
	stateScript[12]				= "onLoadCheck";
	stateTimeoutValue[12]			= 0.01;
	stateTransitionOnTimeout[12]		= "FireLoadCheckB";
	
	stateName[13]				= "FireLoadCheckB";
	stateTransitionOnAmmo[13]		= "Smoke";
	stateTransitionOnNoAmmo[13]		= "ReloadSmoke";
	
	stateName[14] 				= "Smoke";
	stateTransitionOnTimeout[14]		= "Ready2";
	
	stateName[15] 				= "ReloadSmoke";
	stateTimeoutValue[15]			= 0.001;
	stateTransitionOnTimeout[15]		= "ReloadE";
	
	stateName[22]				= "Reloaded";
	stateTimeoutValue[22]			= 0.01;
	stateScript[22]				= "onReloaded";
	stateTransitionOnTimeout[22]		= "Ready";
	
	//empty reload states
	stateName[23]				= "ReloadE";
	stateTimeoutValue[23]			= 0.56;
	stateScript[23]				= "onEmptyReloadStart";
	stateTransitionOnTimeout[23]		= "WaitE";
	stateWaitForTimeout[23]			= true;
	stateSequence[23]			= "clipOut_e";
	//stateSound[23]				= BR55MagOutSound;
	
	stateName[24]				= "WaitE";
	stateTimeoutValue[24]			= 1;
	//stateSound[24]				= BR55MagIn_eSound;
	stateScript[24]				= "onEmptyReloadWait";
	stateSequence[24]			= "clipIn_e";
	stateTransitionOnTimeout[24]		= "Reloaded";
};

function BR55Image::onFire(%this,%obj,%slot)
{

   %pos = %obj.getTransform();
   %random = getRandom(1,2);
   switch(%random)
   {
      case 1:
         serverplay3d(BR55Fire1Sound,%pos);
      case 2:
         serverplay3d(BR55Fire2Sound,%pos);
      default:
         echo("Error on BR55");
   }

	%obj.toolAmmo[%obj.currTool]--;
	%obj.AmmoSpent[%obj.currTool]++;

			commandToClient(%obj.client,'bottomPrint',"<just:right><font:ds-digital:64><color:4577ab>" @ %obj.toolAmmo[%obj.currTool] @ "<font:ds-digital:24><color:004080> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
	Parent::onFire(%this,%obj,%slot);
}

function BR55Image::onUse(%this,%obj,%slot)
{
   %pos = %obj.getTransform();
   %random = getRandom(1,2);
   switch(%random)
   {
      case 1:
         serverplay3d(BR55Use1Sound,%pos);
      case 2:
         serverplay3d(BR55Use2Sound,%pos);
      default:
         echo("Error on BR55");
   }
}

function BR55Image::onReloadWait(%this,%obj,%slot)
{
   %pos = %obj.getTransform();
   %random = getRandom(1,2);
   switch(%random)
   {
      case 1:
         serverplay3d(BR55clipIn1Sound,%pos);
      case 2:
         serverplay3d(BR55clipIn2Sound,%pos);
      default:
         echo("Error on BR55");
   }
			commandToClient(%obj.client,'bottomPrint',"<just:right><font:ds-digital:64><color:4577ab>" @ %obj.toolAmmo[%obj.currTool] @ "<font:ds-digital:24><color:004080> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
}

function BR55Image::onEmptyReloadWait(%this,%obj,%slot)
{
   %pos = %obj.getTransform();
   %random = getRandom(1,2);
   switch(%random)
   {
      case 1:
         serverplay3d(BR55clipIn_e1Sound,%pos);
      case 2:
         serverplay3d(BR55clipIn_e2Sound,%pos);
      default:
         echo("Error on BR55");
   }
			commandToClient(%obj.client,'bottomPrint',"<just:right><font:ds-digital:64><color:4577ab>" @ %obj.toolAmmo[%obj.currTool] @ "<font:ds-digital:24><color:004080> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
}


function BR55Image::onLoadCheck(%this,%obj,%slot)
{
	if(%obj.toolAmmo[%obj.currTool] <= 0)
		%obj.setImageAmmo(%slot,0);
	else
		%obj.setImageAmmo(%slot,1);
}

function BR55Image::onReloadStart(%this,%obj,%slot)
{
	 %pos = %obj.getTransform();
   %random = getRandom(1,2);
   switch(%random)
   {
      case 1:
         serverplay3d(BR55clipOut1Sound,%pos);
      case 2:
         serverplay3d(BR55ClipOut2Sound,%pos);
      default:
         echo("Error on BR55");
   }
				commandToClient(%obj.client,'bottomPrint',"<just:right><font:ds-digital:64><color:4577ab>" @ %obj.toolAmmo[%obj.currTool] @ "<font:ds-digital:24><color:004080> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
}

function BR55Image::onEmptyReloadStart(%this,%obj,%slot)
{
	 %pos = %obj.getTransform();
   %random = getRandom(1,2);
   switch(%random)
   {
      case 1:
         serverplay3d(BR55clipOut1Sound,%pos);
      case 2:
         serverplay3d(BR55ClipOut2Sound,%pos);
      default:
         echo("Error on BR55");
   }
				commandToClient(%obj.client,'bottomPrint',"<just:right><font:ds-digital:64><color:4577ab>" @ %obj.toolAmmo[%obj.currTool] @ "<font:ds-digital:24><color:004080> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
}

function BR55Image::onReloaded(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool] = %this.item.maxAmmo;
	%obj.AmmoSpent[%obj.currTool] = 0;
	%obj.setImageAmmo(%slot,1);
			commandToClient(%obj.client,'bottomPrint',"<just:right><font:ds-digital:64><color:4577ab>" @ %obj.toolAmmo[%obj.currTool] @ "<font:ds-digital:24><color:004080> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
	return;
}


function BR55Image::onMount(%this,%obj,%slot)
{
  %obj.hidenode("RHand");
        %obj.hidenode("LHand");
		   Parent::onMount(%this,%obj,%slot);
					commandToClient(%obj.client,'bottomPrint',"<just:right><font:ds-digital:64><color:4577ab>" @ %obj.toolAmmo[%obj.currTool] @ "<font:ds-digital:24><color:004080> " @ %this.item.maxAmmo @ "", 1,2,3,4); 

}

function BR55Image::onUnMount(%this,%obj,%slot)
{
  %obj.unhidenode("RHand");
        %obj.unhidenode("LHand");
		%obj.playThread(2, root);
}
