//GravityHammer.cs
datablock AudioProfile(GravityHammerUseSound)
{
   filename    = "./use.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(GravityHammerFire1Sound)
{
   filename    = "./fire1.wav";
   description = AudioClose3d;
   preload = true;
};datablock AudioProfile(GravityHammerFire2Sound)

{
   filename    = "./fire2.wav";
   description = AudioClose3d;
   preload = true;
};datablock AudioProfile(GravityHammerFire3Sound)

{
   filename    = "./fire3.wav";
   description = AudioClose3d;
   preload = true;
};datablock AudioProfile(GravityHammerFire4Sound)

{
   filename    = "./fire4.wav";
   description = AudioClose3d;
   preload = true;
};

datablock ParticleData(GravityHammerExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 10;
	textureName          = "./plasmaLines";
	spinSpeed		= 10.0;
	spinRandomMin		= -100.0;
	spinRandomMax		= 100.0;
	colors[0]     = "1 1 1 0.9";
	colors[1]     = "0.9 0.9 0.9 0.0";
	sizes[0]      = 0;
	sizes[1]      = 5;

	useInvAlpha = false;
};
datablock ParticleEmitterData(GravityHammerExplosionEmitter)
{
	lifeTimeMS = 1000;

   ejectionPeriodMS = 100;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 0.0;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "GravityHammerExplosionRingParticle";

   uiName = "Gravity Hammer Plasma Lines";
};


datablock ParticleData(GravityHammerExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 10;
	textureName          = "./plasmaRing";
	spinSpeed		= 10.0;
	spinRandomMin		= -100.0;
	spinRandomMax		= 100.0;
	colors[0]     = "1 1 1 0.9";
	colors[1]     = "0.9 0.9 0.9 0.0";
	sizes[0]      = 0;
	sizes[1]      = 5;

	useInvAlpha = false;
};
datablock ParticleEmitterData(GravityHammerExplosionRingEmitter)
{
	lifeTimeMS = 1000;

   ejectionPeriodMS = 100;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 0.0;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "GravityHammerExplosionRingParticle";

   uiName = "Gravity Hammer Arcs";
};

datablock ParticleData(GravityHammerExplosionCenterParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 100;
	lifetimeVarianceMS   = 10;
	textureName          = "./impactFlash";
	spinSpeed		= 10.0;
	spinRandomMin		= -250.0;
	spinRandomMax		= 250.0;
	colors[0]     = "1 1 1 1";
	colors[1]     = "0.9 0.9 0.9 0.0";
	sizes[0]      = 3;
	sizes[1]      = 5;

	useInvAlpha = false;
};
datablock ParticleEmitterData(GravityHammerExplosionCenterEmitter)
{
	lifeTimeMS = 200;

   ejectionPeriodMS = 4;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 0.0;
   ejectionOffset   = 2;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "GravityHammerExplosionCenterParticle";

   uiName = "Gravity Hammer Inner Flash";
};


datablock ExplosionData(GravityHammerExplosion)
{
   //explosionShape = "";
   explosionShape = "./explosionSphere1.dts";
	soundProfile = GravityHammerImpactSound;

   lifeTimeMS = 150;

   particleEmitter = GravityHammerExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   emitter[0] = GravityHammerExplosionRingEmitter;
   emitter[1] = GravityHammerExplosionCenterEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "3.0 10.0 3.0";
   camShakeDuration = 0.5;
   camShakeRadius = 20.0;

   // Dynamic light
   lightStartRadius = 5;
   lightEndRadius = 20;
   lightStartColor = "1 1 1 1";
   lightEndColor = "0 0 0 0";

   damageRadius = 4;
   radiusDamage = 100;

   impulseRadius = 6;
   impulseForce = 2000;
};



//projectile
AddDamageType("GravityHammer",   '<bitmap:add-ons/Weapon_GravityHammer/CI_GravityHammer> %1',    '%2 <bitmap:add-ons/Weapon_GravityHammer/CI_GravityHammer> %1',0.75,1);
datablock ProjectileData(GravityHammerProjectile)
{

   projectileShapeName = "./empty.dts";
   directDamage        = 500;
   directDamageType  = $DamageType::GravityHammer;
   radiusDamageType  = $DamageType::GravityHammer;
   explosion           = GravityHammerExplosion;
   impactImpulse	     = 1000;
   verticalImpulse	  = 0;
   
   brickExplosionRadius = 7;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 100;
   brickExplosionMaxVolume = 14;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 28;  //max volume of bricks that we can destroy if they aren't connected to the ground

   muzzleVelocity      = 75;
   velInheritFactor    = 2;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   explodeOnDeath = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0.5 1.2";
   
   damageRadius = 1;
   radiusDamage = 100;
   
   impulseRadius = 5;
   impulseForce = 1000;

   uiName = "Gravity Hammer Impact";
};


//////////
// item //
//////////
datablock ItemData(GravityHammerItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./GravityHammer_Ground.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Gravity Hammer";
	iconName = "./UI_GravityHammer";
	doColorShift = true;
	colorShiftColor = "0.471 0.471 0.471 1.000";

	 // Dynamic properties defined by the scripts
	image = GravityHammerImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(GravityHammerImage)
{
   // Basic Item properties
   shapeFile = "./GravityHammer.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = "0.5 1.2 -0.25"; //0 -Left +Right, -Back +Front, -Down +Up

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = GravityHammerItem;
   ammo = " ";
   projectile = GravityHammerProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = true;
   colorShiftColor = "0.471 0.471 0.471 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     	= "Activate";
	stateTimeoutValue[0]             	= 0.0;
	stateTransitionOnTimeout[0]       	= "activeWait";
	stateSound[0]				= GravityHammerUseSound;
	stateSequence[0]			= "use";
	
	stateName[1]                     	= "activeWait";
	stateTimeoutValue[1]             	= 0.7;
	stateTransitionOnTimeout[1]       	= "Ready";

	stateName[2]                     	= "Ready";
	stateTransitionOnTriggerDown[2]  	= "preFire";
	stateAllowImageChange[2]         	= true;

	stateName[3]="preFire";
	stateTimeoutValue[3]=0;
	stateTransitionOnTimeout[3]="preFire2";
	stateScript[3]                  = "onFire";
	stateFire[3]                    = true;
	
	stateName[4]="preFire2";
	stateTransitionOnTimeout[4]="Fire";
	stateScript[4]                  = "onSwing";
	
	stateName[5]="Ready2";
	stateTransitionOnTriggerUp[5]="Ready";
	
	stateName[6]                    	= "Fire";
	stateTransitionOnTimeout[6]     	= "Delay";
	stateTimeoutValue[6]            	= 0.00;
	stateAllowImageChange[6]        	= false;
	stateSequence[6]                	= "fire";
	stateWaitForTimeout[6]			= true;

	stateName[7]				= "Delay";
	stateTransitionOnTimeout[7]     	= "Ready";
	stateTimeoutValue[7]            	= 1;


};


function GravityHammerImage::onSwing(%this,%obj,%slot)
{

%pos = %obj.getTransform();
   %random = getRandom(1,4);
   switch(%random)
   {
      case 1:
         serverplay3d(GravityHammerFire1Sound,%pos);
      case 2:
         serverplay3d(GravityHammerFire2Sound,%pos);
      case 3:
         serverplay3d(GravityHammerFire3Sound,%pos);
	  case 4:
         serverplay3d(GravityHammerFire4Sound,%pos);
      default:
         echo("Error on Gravity Hammer");
   }

}

function GravityHammerImage::onMount(%this,%obj,%slot)
{
  
  %obj.hidenode("RHand");
        %obj.hidenode("LHand");
}

function GravityHammerImage::onUnMount(%this,%obj,%slot)
{
  
  %obj.unhidenode("RHand");
        %obj.unhidenode("LHand");
		%obj.playThread(2, root);
}


