datablock AudioProfile(M6D_MagnumFire1Sound)
{
   filename    = "./fire1.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(M6D_MagnumFire2Sound)
{
   filename    = "./fire2.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(M6D_MagnumclipInSound)
{
   filename    = "./clipIn.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(M6D_MagnumclipOutSound)
{
   filename    = "./clipOut.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(M6D_MagnumUseSound)
{
   filename    = "./use.wav";
   description = AudioClose3d;
   preload = true;
};

//shell
datablock DebrisData(M6D_MagnumCasing)
{
	shapeFile = "./shell.dts";
	lifetime = 2.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};

datablock ParticleData(M6D_MagnumExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 700;
	lifetimeVarianceMS   = 400;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.9 0.9 0.9 0.3";
	colors[1]     = "0.9 0.5 0.6 0.0";
	sizes[0]      = 0.25;
	sizes[1]      = 0.75;

	useInvAlpha = true;
};
datablock ParticleEmitterData(M6D_MagnumExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 2;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "M6D_MagnumExplosionParticle";

   useEmitterColors = true;
   uiName = "M6D_Magnum Hit Dust";
};


datablock ParticleData(M6D_MagnumExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 50;
	lifetimeVarianceMS   = 35;
	textureName          = "./impactFlash";
	spinSpeed		= 500.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 1 1 0.9";
	colors[1]     = "1 1 1 0.0";
	sizes[0]      = 1;
	sizes[1]      = 0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(M6D_MagnumExplosionRingEmitter)
{
	lifeTimeMS = 50;

   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "M6D_MagnumExplosionRingParticle";

   useEmitterColors = true;
   uiName = "M6D_Magnum Hit Flash";
};

datablock ExplosionData(M6D_MagnumExplosion)
{
   //explosionShape = "";
	soundProfile = bulletHitSound;

   lifeTimeMS = 150;

   particleEmitter = M6D_MagnumExplosionEmitter;
   particleDensity = 5;
   particleRadius = 0.2;

   emitter[0] = M6D_MagnumExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 2;
   lightStartColor = "0.3 0.6 0.7";
   lightEndColor = "0 0 0";
};

//Effects
//Flash
datablock ParticleData(M6D_MagnumflashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "./M6DFlash";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.5 0.5 0.5 0.9";
	colors[1]     = "0.5 0.5 0.5 0.0";
	sizes[0]      = 1.0;
	sizes[1]      = 2.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(M6D_MagnumflashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 25;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "M6D_MagnumflashParticle";

   uiName = "M6D Magnum Flash";
};

AddDamageType("M6D Magnum",   '<bitmap:add-ons/Weapon_The_New_Halo_Pack/M6D_Magnum/CI_M6D_Magnum> %1',    '%2 <bitmap:add-ons/Weapon_The_New_Halo_Pack/M6D_Magnum/CI_M6D_Magnum> %1',0.2,1);
datablock ProjectileData(M6D_MagnumProjectile)
{
   projectileShapeName = "./bullet.dts";
   directDamage        = 55;
   directDamageType    = $DamageType::M6D_Magnum;
   radiusDamageType    = $DamageType::M6D_Magnum;

   brickExplosionRadius = 2;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 2;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 25;
   verticalImpulse	  = 0;
   explosion           = M6D_MagnumExplosion;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 0.2;

   hasLight    = true;
   lightRadius = 5.0;
   lightColor  = "0.5 0 0";

   uiName = "M6D Magnum Bullet";
};

//////////
// item //
//////////
datablock ItemData(M6D_MagnumItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./M6D_Magnum_Ground.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "M6D Magnum";
	iconName = "./UI_M6D_Magnum";
	doColorShift = true;
	colorShiftColor = "0.5 0.5 0.5 1.000";

	 // Dynamic properties defined by the scripts
	image = M6D_MagnumImage;
	canDrop = true;

	maxAmmo = 12;
	canReload = 1;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(M6D_MagnumImage)
{
   // Basic Item properties
   shapeFile = "./M6D_Magnum.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = "0.25 1.2 -0.22"; //"0.7 1.3 -0.4"; -Left +Right, -Back +Front, -Down +Up
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = M6D_MagnumItem;
   ammo = " ";
   projectile = M6D_MagnumProjectile;
   projectileType = Projectile;

	casing = M6D_MagnumCasing;
	shellExitDir        = "2.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 25.0;	
	shellVelocity       = 10.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = M6D_MagnumItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.
   // Initial start up state
	stateName[0]                     	= "Activate";
	stateTimeoutValue[0]             	= 0.88;
	stateTransitionOnTimeout[0]       	= "LoadCheckA";
	stateSound[0]				= M6D_MagnumUseSound;
	stateSequence[0]			= "use";

	stateName[1]                     	= "Ready";
	stateTransitionOnNoAmmo[1]       	= "Reload";
	stateTransitionOnTriggerDown[1]  	= "preFire";
	stateAllowImageChange[1]         	= true;

	stateName[19]="preFire";
	stateTimeoutValue[19]=0;
	stateTransitionOnTimeout[19]="preFire2";
	stateScript[19]                  = "onFire";
	stateEjectShell[19]       	  = true;
	stateEmitter[19]					= M6D_MagnumFlashEmitter;
	stateEmitterTime[19]				= 0.05;
	stateEmitterNode[19]				= "muzzleNode";
	stateFire[19]                    = true;
	
	stateName[21]="preFire2";
	stateTransitionOnTimeout[21]="preFire3";
	stateScript[21]				= "onLoadCheck";
	
	stateName[20]="preFire3";
	stateTransitionOnNoAmmo[20]="Fire2";
	stateTransitionOnAmmo[20]="Fire";
	
	stateName[18]="Ready2";
	stateTransitionOnTriggerUp[18]="Ready";
	
	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Delay";
	stateTimeoutValue[2]            = 0.00;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateWaitForTimeout[2]			= true;
	//stateSound[2]				= M6D_MagnumFireSound;

	stateName[16]                    = "Fire2";
	stateTransitionOnTimeout[16]     = "Delay";
	stateTimeoutValue[16]            = 0.00;
	stateAllowImageChange[16]        = false;
	stateSequence[16]                = "Fire2";
	stateWaitForTimeout[16]			= true;
	//stateSound[16]				= M6D_MagnumFireSound;
	
	stateName[3]			= "Delay";
	stateTransitionOnTimeout[3]     = "FireLoadCheckA";
	stateTimeoutValue[3]            = 0.27;
	
	stateName[8]				= "LoadCheckA";
	stateScript[8]				= "onLoadCheck";
	stateTimeoutValue[8]			= 0.01;
	stateTransitionOnTimeout[8]		= "LoadCheckB";
	
	stateName[9]				= "LoadCheckB";
	stateTransitionOnAmmo[9]		= "Ready2";
	stateTransitionOnNoAmmo[9]		= "ReloadE";

	stateName[10]				= "Reload";
	stateTimeoutValue[10]			= 0.70;
	stateScript[10]				= "onReloadStart";
	stateTransitionOnTimeout[10]		= "Wait";
	stateWaitForTimeout[10]			= true;
	stateSequence[10]			= "clipOut";
	stateSound[10]				= M6D_MagnumclipOutSound;
	
	stateName[11]				= "Wait";
	stateTimeoutValue[11]			= 0.92;
	stateSound[11]				= M6D_MagnumclipInSound;
	stateScript[11]				= "onReloadWait";
	stateSequence[11]			= "clipIn";
	stateTransitionOnTimeout[11]		= "Reloaded";
	
	stateName[12]				= "FireLoadCheckA";
	stateScript[12]				= "onLoadCheck";
	stateTimeoutValue[12]			= 0.01;
	stateTransitionOnTimeout[12]		= "FireLoadCheckB";
	
	stateName[13]				= "FireLoadCheckB";
	stateTransitionOnAmmo[13]		= "Smoke";
	stateTransitionOnNoAmmo[13]		= "ReloadSmoke";
	
	stateName[14] 				= "Smoke";
	stateTransitionOnTimeout[14]		= "Ready2";
	stateTransitionOnTriggerDown[14]	= "preFire";
	
	stateName[15] 				= "ReloadSmoke";
	stateTimeoutValue[15]			= 0.2;
	stateTransitionOnTimeout[15]		= "ReloadE";
	
	stateName[22]				= "Reloaded";
	stateTimeoutValue[22]			= 0.01;
	stateScript[22]				= "onReloaded";
	stateTransitionOnTimeout[22]		= "Ready";
	
	//empty reload states
	stateName[23]				= "ReloadE";
	stateTimeoutValue[23]			= 0.56;
	stateScript[23]				= "onReloadStart";
	stateTransitionOnTimeout[23]		= "WaitE";
	stateWaitForTimeout[23]			= true;
	stateSequence[23]			= "clipOut_e";
	stateSound[23]				= M6D_MagnumclipOutSound;
	
	stateName[24]				= "WaitE";
	stateTimeoutValue[24]			= 0.81;
	stateSound[24]				= M6D_MagnumclipInSound;
	stateScript[24]				= "onReloadWait";
	stateSequence[24]			= "clipIn_e";
	stateTransitionOnTimeout[24]		= "Reloaded";
};

function M6D_MagnumImage::onFire(%this,%obj,%slot)
{

   %pos = %obj.getTransform();
   %random = getRandom(1,2);
   switch(%random)
   {
      case 1:
         serverplay3d(M6D_MagnumFire1Sound,%pos);
      case 2:
         serverplay3d(M6D_MagnumFire2Sound,%pos);
      default:
         echo("Error on M6D Magnum");
   }

	%obj.toolAmmo[%obj.currTool]--;
	%obj.AmmoSpent[%obj.currTool]++;

			commandToClient(%obj.client,'bottomPrint',"<just:right><font:ds-digital:64><color:4577ab>" @ %obj.toolAmmo[%obj.currTool] @ "<font:ds-digital:24><color:004080> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
	Parent::onFire(%this,%obj,%slot);
	
}


function M6D_MagnumImage::onReloadWait(%this,%obj,%slot)
{
			commandToClient(%obj.client,'bottomPrint',"<just:right><font:ds-digital:64><color:4577ab>" @ %obj.toolAmmo[%obj.currTool] @ "<font:ds-digital:24><color:004080> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
}

function M6D_MagnumImage::onLoadCheck(%this,%obj,%slot)
{
	if(%obj.toolAmmo[%obj.currTool] <= 0)
		%obj.setImageAmmo(%slot,0);
	else
		%obj.setImageAmmo(%slot,1);
}

function M6D_MagnumImage::onReloadStart(%this,%obj,%slot)
{
				commandToClient(%obj.client,'bottomPrint',"<just:right><font:ds-digital:64><color:4577ab>" @ %obj.toolAmmo[%obj.currTool] @ "<font:ds-digital:24><color:004080> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
}

function M6D_MagnumImage::onReloaded(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool] = %this.item.maxAmmo;
	%obj.AmmoSpent[%obj.currTool] = 0;
	%obj.setImageAmmo(%slot,1);
			commandToClient(%obj.client,'bottomPrint',"<just:right><font:ds-digital:64><color:4577ab>" @ %obj.toolAmmo[%obj.currTool] @ "<font:ds-digital:24><color:004080> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
	return;
}


function M6D_MagnumImage::onMount(%this,%obj,%slot)
{
  
  %obj.hidenode("RHand");
        %obj.hidenode("LHand");
		   Parent::onMount(%this,%obj,%slot);
					commandToClient(%obj.client,'bottomPrint',"<just:right><font:ds-digital:64><color:4577ab>" @ %obj.toolAmmo[%obj.currTool] @ "<font:ds-digital:24><color:004080> " @ %this.item.maxAmmo @ "", 1,2,3,4); 

}

function M6D_MagnumImage::onUnMount(%this,%obj,%slot)
{
  
  %obj.unhidenode("RHand");
        %obj.unhidenode("LHand");
		%obj.playThread(2, root);
}
