//M6Galilean.cs

//audio
datablock AudioProfile(M6GalileanFire1Sound)
{
   filename    = "./fire1.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(M6GalileanFire2Sound)
{
   filename    = "./fire2.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(M6GalileanFire3Sound)
{
   filename    = "./fire3.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(M6GalileanFire4Sound)
{
   filename    = "./fire4.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(M6GalileanUseSound)
{
   filename    = "./use.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(M6GalileanImpactSound)
{
   filename    = "./impact.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(M6GalileanChargeSound)
{
   filename    = "./charge.wav";
   description = AudioCloseLooping3d;
   preload = true;
};

datablock AudioProfile(M6GalileanCharge1Sound)
{
   filename    = "./newCharge1.wav";
   description = AudioCloseLooping3d;
   preload = true;
};

datablock AudioProfile(M6GalileanCharge2Sound)
{
   filename    = "./newCharge2.wav";
   description = AudioCloseLooping3d;
   preload = true;
};

datablock AudioProfile(M6GalileanCharge3Sound)
{
   filename    = "./newCharge3.wav";
   description = AudioCloseLooping3d;
   preload = true;
};

datablock AudioProfile(M6GalileanCharge4Sound)
{
   filename    = "./newCharge4.wav";
   description = AudioCloseLooping3d;
   preload = true;
};

datablock AudioProfile(M6GalileanChargeNullSound)
{
   filename    = "./nullSound.wav";
   description = AudioClose3d;
   preload = true;
};




//muzzle flash effects
datablock ParticleData(M6GalileanFlashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "./chargeFlare1";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 1 1 1";
	colors[1]     = "1 1 1 1";
	colors[2]     = "1 1 1 0";
	sizes[0]      = 0.5;
	sizes[1]      = 2.0;
	sizes[2]      = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(M6GalileanFlashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "M6GalileanFlashParticle";

   uiName = "M6 Galilean Flash";
};

//Charge effects
datablock ParticleData(M6GalileanCharge1Particle)
{
	dragCoefficient      = 0;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 100;
	lifetimeVarianceMS   = 15;
	textureName          = "./chargeFlare1";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 1 1 0.5";
	colors[1]     = "1 1 1 1";
	colors[2]     = "1 1 1 0";
	sizes[0]      = 0.3;
	sizes[1]      = 0.2;
	sizes[3]      = 0.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(M6GalileanCharge1Emitter)
{
   ejectionPeriodMS = 4;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 1.0;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "M6GalileanCharge1Particle";

   uiName = "M6 Galilean Charge 1";
};

datablock ParticleData(M6GalileanCharge2Particle)
{
	dragCoefficient      = 0;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 100;
	lifetimeVarianceMS   = 15;
	textureName          = "./chargeFlare1";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 1 1 0.5";
	colors[1]     = "1 1 1 1";
	colors[2]     = "1 1 1 0";
	sizes[0]      = 0.4;
	sizes[1]      = 0.3;
	sizes[3]      = 0.1;

	useInvAlpha = false;
};
datablock ParticleEmitterData(M6GalileanCharge2Emitter)
{
   ejectionPeriodMS = 4;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 1.0;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "M6GalileanCharge2Particle";

   uiName = "M6 Galilean Charge 2";
};

datablock ParticleData(M6GalileanCharge3Particle)
{
	dragCoefficient      = 0;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 100;
	lifetimeVarianceMS   = 15;
	textureName          = "./chargeFlare1";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 1 1 0.5";
	colors[1]     = "1 1 1 1";
	colors[2]     = "1 1 1 0";
	sizes[0]      = 0.6;
	sizes[1]      = 0.4;
	sizes[3]      = 0.2;

	useInvAlpha = false;
};
datablock ParticleEmitterData(M6GalileanCharge3Emitter)
{
   ejectionPeriodMS = 4;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 1.0;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "M6GalileanCharge3Particle";

   uiName = "M6 Galilean Charge 3";
};

datablock ParticleData(M6GalileanCharge4Particle)
{
	dragCoefficient      = 0;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 100;
	lifetimeVarianceMS   = 15;
	textureName          = "./chargeFlare1";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 1 1 0.5";
	colors[1]     = "1 1 1 1";
	colors[2]     = "1 1 1 0";
	sizes[0]      = 0.7;
	sizes[1]      = 0.5;
	sizes[3]      = 0.3;

	useInvAlpha = false;
};
datablock ParticleEmitterData(M6GalileanCharge4Emitter)
{
   ejectionPeriodMS = 4;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 1.0;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "M6GalileanCharge4Particle";

   uiName = "M6 Galilean Charge 4";
};

//Cooling Steam
datablock ParticleData(M6GalileanSteamParticle)
{
	dragCoefficient      = 4;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 525;
	lifetimeVarianceMS   = 55;
	textureName          = "./combinedSmoke";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.5 0.5 0.5 0.9";
	colors[1]     = "0.5 0.5 0.5 0.0";
	sizes[0]      = 0.15;
	sizes[1]      = 0.15;

	useInvAlpha = false;
};
datablock ParticleEmitterData(M6GalileanSteamEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "M6GalileanSteamParticle";

   uiName = "M6 Galilean Steam";
};


datablock ParticleData(M6GalileanExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 100;
	lifetimeVarianceMS   = 10;
	textureName          = "./chargeFlare1";
	spinSpeed		= 10.0;
	spinRandomMin		= -250.0;
	spinRandomMax		= 250.0;
	colors[0]     = "1 1 1 1";
	colors[1]     = "1 1 1 0.0";
	sizes[0]      = 3;
	sizes[1]      = 10;

	useInvAlpha = true;
};
datablock ParticleEmitterData(M6GalileanExplosionEmitter)
{
	lifeTimeMS = 200;

   ejectionPeriodMS = 4;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 0.0;
   ejectionOffset   = 2.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "M6GalileanExplosionParticle";

   uiName = "M6 Galilean Impact Flash";
};


datablock ParticleData(M6GalileanExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 35;
	textureName          = "./chargeFlare1";
	spinSpeed		= 500.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 1 1 1";
	colors[1]     = "1 1 1 0";
	sizes[0]      = 3;
	sizes[1]      = 7;

	useInvAlpha = false;
};
datablock ParticleEmitterData(M6GalileanExplosionRingEmitter)
{
	lifeTimeMS = 50;

   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "M6GalileanExplosionRingParticle";

   useEmitterColors = true;
   uiName = "M6 Galilean Impact Flash";
};

datablock ExplosionData(M6GalileanExplosion)
{
   //explosionShape = "";
	soundProfile = M6GalileanImpactSound;

   lifeTimeMS = 150;

   particleEmitter = M6GalileanExplosionEmitter;
   particleDensity = 5;
   particleRadius = 0.2;

   emitter[0] = M6GalileanExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "3 3 3";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 2;
   lightStartColor = "1 0 0";
   lightEndColor = "0 0 0";
};


AddDamageType("M6Galilean",   '<bitmap:add-ons/Weapon_The_New_Halo_Pack/M6Galilean/CI_M6Galilean> %1',    '%2 <bitmap:add-ons/Weapon_The_New_Halo_Pack/M6Galilean/CI_M6Galilean> %1',0.2,1);
datablock ProjectileData(M6GalileanProjectile)
{
   projectileShapeName = "./empty.dts"; //was tagLaser.dts, but it was visible ingame
   directDamage        = 9999;
   directDamageType    = $DamageType::M6Galilean;
   radiusDamageType    = $DamageType::M6Galilean;

   brickExplosionRadius = 5;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 40;
   brickExplosionMaxVolume = 85;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 100;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 500;
   verticalImpulse	  = 500;
   explosion           = M6GalileanExplosion;
   particleEmitter     = M6GalileanTrailEmitter; //bulletTrailEmitter;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 5000;
   fadeDelay           = 3500;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = true;
   lightRadius = 3.0;
   lightColor  = "1 0 0";

   uiName = "M6 Galilean Laser";
};

datablock ProjectileData(M6GalileanTargetPainter)
{
   projectileShapeName = "./targetPainter.dts";

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 0;
   brickExplosionMaxVolume = 0;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 0;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 0;
   verticalImpulse	  = 0;

   muzzleVelocity      = 1;
   velInheritFactor    = 0;

   armingDelay         = 00;
   lifetime            = 500;
   fadeDelay           = 0;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0;

   hasLight    = true;
   lightRadius = 3.0;
   lightColor  = "1 0 0";

   uiName = "M6 Galilean Target Painter";
};

datablock ProjectileData(M6GalileanFlashProjectile)
{
   projectileShapeName = "./laserRayBlast.dts"; //was tagLaser.dts, but it was visible ingame
   
   impactImpulse	     = 0;
   verticalImpulse	  = 0;

   muzzleVelocity      = 0.1;
   velInheritFactor    = 0;

   armingDelay         = 00;
   lifetime            = 400;
   fadeDelay           = 400;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = true;
   lightRadius = 3.0;
   lightColor  = "1 0 0";

   uiName = "M6 Galilean Laser Flash";
};


//////////
// item //
//////////
datablock ItemData(M6GalileanItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./M6Galilean_Ground.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "M6 Galilean";
	iconName = "./UI_M6Galilean";
	doColorShift = true;
	colorShiftColor = "0.25 0.25 0.25 1.000";

	 // Dynamic properties defined by the scripts
	image = M6GalileanImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(M6GalileanImage)
{

	raycastWeaponRange			= 1000;				
	raycastWeaponTargets		= ($TypeMasks::FxBrickObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::StaticObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::VehicleObjectType);
	raycastDirectDamage			= 999;
	raycastDirectDamageType		= $DamageType::M6Galilean;		
	raycastExplosionProjectile	= M6GalileanProjectile;			
	raycastExplosionSound		= M6GalileanImpactSound;

   // Basic Item properties
   shapeFile = "./M6Galilean.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = "0.6 1.0 0"; // -Left +Right, -Back +Front, -Down +Up
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = M6GalileanProjectile;
   projectileType = Projectile;

	//casing = M6GalileanShellDebris;
	//shellExitDir        = "1.0 -1.3 1.0";
	//shellExitOffset     = "0 0 0";
	//shellExitVariance   = 15.0;	
	//shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = M6GalileanItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.95;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= M6GalileanUseSound;
	stateSequence[0]	= "use";

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Charge1";
	stateAllowImageChange[1]         = true;
	stateScript[1] = "onTriggerUp";
	stateSound[1]					= M6GalileanChargeNullSound;
	
	stateName[2]                     = "Charge";
	stateTransitionOnTimeout[2]     = "Fire";
	stateSequence[2]	= "chargeLaser";
	stateTimeoutValue[2]            = 2.72;
	stateEmitter[2]					= M6GalileanChargeEmitter;
	stateEmitterTime[2]				= 2.72; 
	stateEmitterNode[2]				= "muzzleNode";
	//stateSound[2]					= M6GalileanChargeSound;
	stateAllowImageChange[2]         = false;
	stateWaitForTimeout[2]			= true;
	
	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "Burst1";
	stateTimeoutValue[3]            = 0;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "fire";
	stateWaitForTimeout[3]			= false;
	stateEmitter[3]					= M6GalileanFlashEmitter;
	stateEmitterTime[3]				= 0.4;
	stateEmitterNode[3]				= "muzzleNode";
	//stateSound[3]					= M6GalileanFireSound;
	stateScript[3] = "onFire";
	
	stateName[14]                    = "Burst1";
	stateTransitionOnTimeout[14]     = "Burst2";
	stateTimeoutValue[14]            = 0.01;
	stateFire[14]                    = true;
	stateAllowImageChange[14]        = false;
	stateWaitForTimeout[14]			= true;
	stateScript[14] = "onFire";

	stateName[15]                    = "Burst2";
	stateTransitionOnTimeout[15]     = "Burst3";
	stateTimeoutValue[15]            = 0.01;
	stateFire[15]                    = true;
	stateAllowImageChange[15]        = false;
	stateWaitForTimeout[15]			= true;
	stateScript[15] = "onFire";

	stateName[16]                    = "Burst3";
	stateTransitionOnTimeout[16]     = "Burst4";
	stateTimeoutValue[16]            = 0.01;
	stateFire[16]                    = true;
	stateAllowImageChange[16]        = false;
	stateWaitForTimeout[16]			= true;
	stateScript[16] = "onFire";

	stateName[17]                    = "Burst4";
	stateTransitionOnTimeout[17]     = "Cool";
	stateTimeoutValue[17]            = 0.01;
	stateFire[17]                    = true;
	stateAllowImageChange[17]        = false;
	stateWaitForTimeout[17]			= true;
	stateScript[17] = "onFire";
  
  stateName[4] = "Cool";
	stateEmitter[4]					= M6GalileanSteamEmitter;
	stateEmitterTime[4]				= 2;
	stateEmitterNode[4]				= "steamPoint";
	stateTimeoutValue[4]            = 2;
	stateTransitionOnTimeout[4]     = "Ready";
	stateSequence[4]                = "cool";

	stateName[5]                    = "Charge1";
	stateTransitionOnTimeout[5]     = "TriggerChargeCheck1";
	stateTimeoutValue[5]            = 0.68;
	stateFire[5]                    = true;
	stateAllowImageChange[5]        = false;
	stateSequence[5]                = "charge1";
	stateWaitForTimeout[5]			= true;
	stateEmitter[5]					= M6GalileanCharge1Emitter;
	stateEmitterTime[5]				= 0.72;
	stateEmitterNode[5]				= "muzzleNode";
	//stateSound[5]					= M6GalileanCharge1Sound;
	stateScript[5] = "onChargeStart";

	stateName[6]                    = "Charge2";
	stateTransitionOnTimeout[6]     = "TriggerChargeCheck2";
	stateTimeoutValue[6]            = 0.68;
	stateAllowImageChange[6]        = false;
	stateSequence[6]                = "charge2";
	stateWaitForTimeout[6]			= true;
	stateEmitter[6]					= M6GalileanCharge2Emitter;
	stateEmitterTime[6]				= 0.72;
	stateEmitterNode[6]				= "muzzleNode";
	//stateSound[6]					= M6GalileanCharge2Sound;
	stateScript[6] = "onCharge";

	stateName[7]                    = "Charge3";
	stateTransitionOnTimeout[7]     = "TriggerChargeCheck3";
	stateTimeoutValue[7]            = 0.52;
	stateAllowImageChange[7]        = false;
	stateSequence[7]                = "charge3";
	stateWaitForTimeout[7]			= true;
	stateEmitter[7]					= M6GalileanCharge3Emitter;
	stateEmitterTime[7]				= 0.56;
	stateEmitterNode[7]				= "muzzleNode";
	//stateSound[7]					= M6GalileanCharge3Sound;
	stateScript[7] = "onCharge";

	stateName[8]                    = "Charge4";
	stateTransitionOnTimeout[8]     = "TriggerChargeCheck4";
	stateTimeoutValue[8]            = 0.68;
	stateAllowImageChange[8]        = false;
	stateSequence[8]                = "charge4";
	stateWaitForTimeout[8]			= true;
	stateEmitter[8]					= M6GalileanCharge4Emitter;
	stateEmitterTime[8]				= 0.72;
	stateEmitterNode[8]				= "muzzleNode";
	//stateSound[8]					= M6GalileanCharge4Sound;
	stateScript[8] = "onCharge";

	stateName[9]                    = "TriggerChargeCheck1";
	stateTransitionOnTimeout[9]     = "soundKill";
	stateTransitionOnTriggerDown[9]  	= "Charge2";
	stateWaitForTimeout[9]			= false;
	stateScript[8] = "onCharge";

	stateName[10]                    = "TriggerChargeCheck2";
	stateTransitionOnTimeout[10]     = "soundKill";
	stateTransitionOnTriggerDown[10]  	= "Charge3";
	stateWaitForTimeout[10]			= false;

	stateName[11]                    = "TriggerChargeCheck3";
	stateTransitionOnTimeout[11]     = "soundKill";
	stateTransitionOnTriggerDown[11]  	= "Charge4";
	stateWaitForTimeout[11]			= false;

	stateName[12]                    = "TriggerChargeCheck4";
	stateTransitionOnTimeout[12]     = "soundKill";
	stateTransitionOnTriggerDown[12]  	= "Fire";
	stateWaitForTimeout[12]			= false;
	
	stateName[13]                    = "soundKill";
	stateTransitionOnTimeout[13]     = "Ready";
	stateWaitForTimeout[13]			= false;
	stateScript[13] = "onChargeCancel";
	stateSound[13]					= M6GalileanChargeNullSound;

	
};


function M6GalileanImage::onFire(%this,%obj,%slot)
	{
	
	
%pos = %obj.getTransform();
   %random = getRandom(1,4);
   switch(%random)
   {
      case 1:
         %obj.playAudio(1, M6GalileanFire1Sound);
      case 2:
         %obj.playAudio(1, M6GalileanFire2Sound);
      case 3:
         %obj.playAudio(1, M6GalileanFire3Sound);
	  case 4:
         %obj.playAudio(1, M6GalileanFire4Sound);
      default:
         echo("Error on M6 Galilean");
   }
	
	
	
	if(%this.raycastWeaponRange > 0)
	{
		// Directional Math
		%fvec		= %obj.getForwardVector();
		%fX			= getWord(%fvec,0);
		%fY			= getWord(%fvec,1);
		
		%evec		= %obj.getEyeVector();
		%eX			= getWord(%evec,0);
		%eY			= getWord(%evec,1);
		%eZ			= getWord(%evec,2);
		
		%eXY		= mSqrt((%eX * %eX) + (%eY * %eY));
		%aimVec		= (%fX * %eXY) SPC (%fY * %eXY) SPC %eZ;
		
		// Range
		%range		= %this.raycastWeaponRange * getWord(%obj.getScale(), 2);
		
		if(%range >= 100)
		{
			%rangeRem = %range - 100;
			%range = 100;
		}
		
		// Raycast Parameters
		%start		= %obj.getEyePoint();
		%end[0]		= vectorAdd(%start, vectorScale(%aimVec, %range)); // [0] required for loop
		%targets	= %this.raycastWeaponTargets;
		
		// Raycasting
		%ray		= ContainerRayCast(%start, %end[0], %targets, %obj);
		%col		= getWord(%ray, 0);
		
		if(isObject(%col))
		{
			%pos	= posFromRaycast(%ray);
			%normal	= normalFromRaycast(%ray);
			%end[0]	= %pos;
			%colclass	= %col.getClassName();
			%objsHit++;
			
			%this.onHitObject(%obj, %slot, %col, %pos, %normal, %objsHit);
			
			if(%colclass $= "Player" || %colclass $= "AIPlayer")
			{
				if(%col.getState() $= "Dead")
				{
					%objsKilled++;
				}
			}
		}
		
		if(%rangeRem > 0)
		{
			for(%a = 1; %a <= 10 && %rangeRem > 0; %a++)
			{
				%range		= %rangeRem;
				
				if(%range >= 100)
				{
					%rangeRem = %range - 100;
					%range = 100;
				}
				
				%start[%a]	= %end[%a - 1];
				%end[%a]	= vectorAdd(%start[%a], vectorScale(%aimVec, %range)); 
				
				%ray		= ContainerRayCast(%start[%a], %end[%a], %targets, %obj);
				%col		= getWord(%ray, 0);
				
				if(isObject(%col))
				{
					%pos		= posFromRaycast(%ray);
					%normal		= normalFromRaycast(%ray);
					%end[%a]	= %pos;
					%colclass	= %col.getClassName();
					%objsHit++;
					
					%this.onHitObject(%obj, %slot, %col, %pos, %normal, %objsHit);
					
					if(%colclass $= "Player" || %colclass $= "AIPlayer")
					{
						if(%col.getState() $= "Dead")
						{
							%objsKilled++;
						}
					}
					
					if(%objsHit >= 9)
					{
						break;
					}
				}
			}
		}
		
		if(%objsKilled >= 2 && isObject(%client = %obj.client))
		{
			commandToClient(%client, 'bottomPrint', "<color:00ff00>Nice Shot! <color:ffffff>" @ %objsKilled @ " birds, one stone.", 5);
		}
	}
	else
	{
		return Parent::onFire(%this, %obj, %slot);
	}
	
	
	%projectile = "M6GalileanFlashProjectile";
	
	%vector = %obj.getMuzzleVector(%slot);
	%objectVelocity = %obj.getVelocity();
	%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
	%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	
	%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
	};
	
	%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
	};
	
	%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
	};
	
	%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
	};
	MissionCleanup.add(%p);
	return %p;
}

function M6GalileanImageScoped::onHitObject(%this, %obj, %slot, %col, %pos, %normal, %objsHit)
{ 
	if(%this.raycastDirectDamage > 0 && %col.getType() & ($TypeMasks::PlayerObjectType | $TypeMasks::VehicleObjectType))
	{
		if(miniGameCanDamage(%obj, %col) == 1 && !%col.getDatablock().indestructable)
		{
			if(%this.raycastDirectDamageType)
			{
				%damageType = %this.raycastDirectDamageType;
			}
			else
			{
				%damageType = $DamageType::Direct;
			}
			
			%scale			= %obj.getScale();
			%scaleFactor	= (getWord(%scale, 0) + getWord(%scale, 1) + getWord(%scale, 2)) / 3;
			%damFloat		= mClampF(%this.raycastDirectDamage, -100, 100);
			%directDamage	= (%damFloat * %scaleFactor) / %objsHit;
			
			%col.damage(%obj, %pos, %directDamage, %damageType);
		}
	}
	
	if(isObject(%this.raycastExplosionProjectile))
	{
		%scale			= %obj.getScale();
		%scaleFactor	= ((getWord(%scale, 0) + getWord(%scale, 1) + getWord(%scale, 2)) / 3) / %objsHit;
		
		%p = new Projectile()
		{
			dataBlock		= %this.raycastExplosionProjectile;
			initialPosition	= %pos;
			initialVelocity	= %normal;
			sourceObject	= %obj;
			client			= %obj.client;
			sourceSlot		= 0;
			originPoint		= %pos;
		};
		
		MissionCleanup.add(%p);
		%p.setScale(%scaleFactor SPC %scaleFactor SPC %scaleFactor);
		%p.explode();
	}
	
	if(isObject(%this.raycastExplosionSound))
	{
		serverplay3d(%this.raycastExplosionSound, %pos);
	}

}



function M6GalileanImage::onCharge(%this,%obj,%slot)
{
	%projectile = "M6GalileanTargetPainter";
	
	%vector = %obj.getMuzzleVector(%slot);
	%objectVelocity = %obj.getVelocity();
	%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
	%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	
	%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
	};
	MissionCleanup.add(%p);
	return %p;
}

function M6GalileanImage::onChargeStart(%this,%obj,%slot)
{

	//%obj.playAudio(1, M6GalileanCharge1Sound);
	
	%pos = %obj.getTransform();
   %random = getRandom(1,4);
   switch(%random)
   {
      case 1:
         %obj.playAudio(1, M6GalileanCharge1Sound);
      case 2:
         %obj.playAudio(1, M6GalileanCharge2Sound);
      case 3:
         %obj.playAudio(1, M6GalileanCharge3Sound);
	  case 4:
         %obj.playAudio(1, M6GalileanCharge4Sound);
      default:
         echo("Error on M6 Galilean");
   }


	%projectile = "M6GalileanTargetPainter";
	
	%vector = %obj.getMuzzleVector(%slot);
	%objectVelocity = %obj.getVelocity();
	%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
	%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	
	%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
	};
	MissionCleanup.add(%p);
	return %p;
}


function M6GalileanImage::onChargeCancel(%this, %obj, %slot)
{
	%obj.stopAudio(1);
}


//### Mount on player

datablock ShapeBaseImageData(M6GalileanBackImage)
{
  shapeFile = "./M6Galilean_Back.dts";
  emap = true;
  mountPoint = $BackSlot;
  offset = "-0.4 -0.35 0";
  eyeOffset = "0 0 10";
  rotation = eulerToMatrix("65 0 90");
  armReady = false;
  doColorShift = false;
};

function M6GalileanImage::onMount(%this,%obj,%slot)
{
  parent::onMount(%this,%obj,%slot);
  if(%obj.getMountedImage(1).getName() $= "M6GalileanBackImage") { %obj.unMountImage(1); }
  
  %obj.hidenode("RHand");
        %obj.hidenode("LHand");
}

function M6GalileanImage::onUnMount(%this,%obj,%slot)
{
  parent::onUnMount(%this,%obj,%slot);
  %obj.unMountImage(1);
  %obj.mountImage(M6GalileanBackImage,1);
  
  %obj.unhidenode("RHand");
        %obj.unhidenode("LHand");
}

function M6GalileanItem::onPickup(%this,%obj,%col,%a)
{
  for(%i=0;%i<%col.getdatablock().maxTools;%i++)
  {
    %item = %col.tool[%i];
    if(%item $= 0 || %item $= "")
    {
      %freeSlot = 1;
      break;
    }
  }
  if(%obj.canpickup && !isobject(%col.getmountedimage(1)) && %freeSlot) { %col.mountimage(M6GalileanBackImage,1); }
  parent::onPickup(%this,%obj,%col,%a);
}

package M6GalileanPackage
{
  function servercmdDropTool(%this,%slot)
  {
    if(isobject(%this.player.tool[%slot]) && %this.player.tool[%slot].getname() $= "M6GalileanItem")
    {
      parent::servercmdDropTool(%this,%slot);
      if(isobject(%this.player.getmountedimage(1)) && %this.player.getmountedimage(1).getname() $= "M6GalileanBackImage") { %this.player.schedule(5,unmountimage,1); }
      return;
    }
    parent::servercmdDropTool(%this,%slot);
  }
  
};
activatepackage(M6GalileanPackage);