

datablock AudioProfile(M739_LMGFire1Sound)
{
   filename    = "./fire1.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(M739_LMGFire2Sound)
{
   filename    = "./fire2.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(M739_LMGFire3Sound)
{
   filename    = "./fire3.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(M739_LMGFire4Sound)
{
   filename    = "./fire4.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(M739_LMGFire5Sound)
{
   filename    = "./fire5.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(M739_LMGclipInSound)
{
   filename    = "./clipIn.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(M739_LMGclipOutSound)
{
   filename    = "./clipOut.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(M739_LMGclipOut_eSound)
{
   filename    = "./clipOut_e.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(M739_LMGclipIn_eSound)
{
   filename    = "./clipIn_e.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(M739_LMGUseSound)
{
   filename    = "./use.wav";
   description = AudioClose3d;
   preload = true;
};


//shell
datablock DebrisData(M739_LMGCasing)
{
	shapeFile = "./M739_LMGshell.dts";
	lifetime = 2.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};

//Effects
//Flash
datablock ParticleData(M739_LMGflashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "./muzzle0";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.5 0.5 0.5 0.9";
	colors[1]     = "0.5 0.5 0.5 0.0";
	sizes[0]      = 2.0;
	sizes[1]      = 3.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(M739_LMGflashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 25;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "M739_LMGflashParticle";

   uiName = "M739 SAW LMG Flash";
};

datablock ExplosionData(M739_LMGMuzzleExplosion)
{

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "5.0 6.0 5.0";
   camShakeAmp = "2.0 6.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 4.0;

   // Dynamic light
   lightStartRadius = 5;
   lightEndRadius = 1;
   lightStartColor = "0.5 0.5 0 1";
   lightEndColor = "0.3 0.1 0.0 1";

   damageRadius = 0;
   radiusDamage = 0;

   impulseRadius = 0;
   impulseForce = 0;
};




AddDamageType("M739_LMG",   '<bitmap:add-ons/Weapon_The_New_Halo_Pack/M739_LMG/CI_M739_LMG> %1',    '%2 <bitmap:add-ons/Weapon_The_New_Halo_Pack/M739_LMG/CI_M739_LMG> mowed down %1',0.2,1);
datablock ProjectileData(M739_LMGProjectile)
{
   projectileShapeName = "./bullet_Tracer.dts";
   directDamage        = 4;
   directDamageType    = $DamageType::M739_LMG;
   radiusDamageType    = $DamageType::M739_LMG;

   brickExplosionRadius = 2;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 1;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 25;
   verticalImpulse	  = 0;
   explosion           = gunExplosion;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 0.2;

   hasLight    = true;
   lightRadius = 5.0;
   lightColor  = "0.5 0.5 0";

   uiName = "SAW M118 FMJ-AP Round";
};


datablock ProjectileData(M739_LMGTracerProjectile)
{
   projectileShapeName = "./bullet_Tracer.dts";
   directDamage        = 40;
   directDamageType    = $DamageType::M739_LMG;
   radiusDamageType    = $DamageType::M739_LMG;

   brickExplosionRadius = 2;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 1;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 25;
   verticalImpulse	  = 0;
   explosion           = gunExplosion;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 0.2;

   hasLight    = true;
   lightRadius = 5.0;
   lightColor  = "0.5 0.5 0";

   uiName = "SAW M118 FMJ-AP Tracer";
};




//////////
// item //
//////////
datablock ItemData(M739_LMGItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./M739_LMG_Ground.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "M739 SAW LMG";
	iconName = "./UI_M739_LMG";
	doColorShift = true;
	colorShiftColor = "0.5 0.5 0.5 1.000";

	 // Dynamic properties defined by the scripts
	image = M739_LMGImage;
	canDrop = true;

	maxAmmo = 72;
	canReload = 1;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(M739_LMGImage)
{
   // Basic Item properties
   shapeFile = "./M739_LMG.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = "0.35 0.7 -0.3"; //"0.7 1.2 -0.5"; -Left +Right, -Back +Front, -Down +Up
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = M739_LMGItem;
   ammo = " ";
   projectile = M739_LMGProjectile;
   projectileType = Projectile;
	
	
   raycastWeaponRange = 60;
   raycastWeaponTargets = $TypeMasks::FxBrickObjectType |	//Targets the weapon can hit: Raycasting Bricks
   				$TypeMasks::PlayerObjectType |	//AI/Players
   				$TypeMasks::StaticObjectType |	//Static Shapes
   				$TypeMasks::TerrainObjectType |	//Terrain
   				$TypeMasks::VehicleObjectType;	//Vehicles
   raycastWeaponPierceTargets = "";				//Gun cannot pierce
   raycastExplosionProjectile = M739_LMGProjectile;
   raycastExplosionSound = "bulletHitSound"; //sound played by exploding gunprojectile
   raycastDirectDamage = 32; //Varies based on range
   raycastDirectDamageType = $DamageType::M739_LMG;
   raycastSpreadCount = 1;
   raycastSpreadAmt = 0.003;
   raycastTracerProjectile = "M739_LMGTracerProjectile";
   raycastFromMuzzle = 0;
   raycastImpactImpulse = 25;
   raycastVerticalImpulse = 0;
   
   	casing = M739_LMGCasing;
	shellExitDir        = "2.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 25.0;	
	shellVelocity       = 10.0;
	

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = M739_LMGItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.
   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.7;
	stateSequence[0] = "use";
	stateTransitionOnTimeout[0]       = "LoadCheckA";
	stateSound[0]					= M739_LMGUseSound;

	stateName[1]                     = "Ready";
	stateTransitionOnNoAmmo[1]       = "Reload";
	stateTransitionOnTriggerDown[1]  = "preFire";
	stateAllowImageChange[1]         = true;
	
	stateName[19]="preFire";
	stateTimeoutValue[19]=0;
	stateTransitionOnTimeout[19]="preFire2";
	stateScript[19]                  = "onFire";
	stateEjectShell[19]       	  = true;
	stateEmitter[19]					= M739_LMGFlashEmitter;
	stateEmitterTime[19]				= 0.02;
	stateEmitterNode[19]				= "muzzleNode";
	stateFire[19]                    = true;
	
	stateName[21]="preFire2";
	stateTransitionOnTimeout[21]="preFire3";
	stateScript[21]				= "onLoadCheck";
	
	stateName[20]="preFire3";
	stateTransitionOnNoAmmo[20]="Fire2";
	stateTransitionOnAmmo[20]="Fire";
	
	stateName[18]="Ready2";
	stateTransitionOnTriggerUp[18]="Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Delay";
	stateTimeoutValue[2]            = 0.00;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateWaitForTimeout[2]			= true;
	//stateSound[2]					= M739_LMGFireSound;
	
	stateName[16]                    = "Fire2";
	stateTransitionOnTimeout[16]     = "Delay";
	stateTimeoutValue[16]            = 0.00;
	stateAllowImageChange[16]        = false;
	stateSequence[16]                = "Fire2";
	stateWaitForTimeout[16]			= true;
	//stateSound[16]					= M739_LMGFireSound;

	stateName[3]			= "Delay";
	stateTransitionOnTimeout[3]     = "FireLoadCheckA";
	stateTimeoutValue[3]            = 0.02;
	
	stateName[4]				= "LoadCheckA";
	stateScript[4]				= "onLoadCheck";
	stateTimeoutValue[4]			= 0.01;
	stateTransitionOnTimeout[4]		= "LoadCheckB";
	
	stateName[5]				= "LoadCheckB";
	stateTransitionOnAmmo[5]		= "Ready2";
	stateTransitionOnNoAmmo[5]		= "ReloadE";

	stateName[6]				= "Reload";
	stateTimeoutValue[6]			= 0.9;
	stateScript[6]				= "onReloadStart";
	stateTransitionOnTimeout[6]		= "Wait";
	stateWaitForTimeout[6]			= true;
	stateSequence[6]			= "clipOut";
	stateSound[6]				= M739_LMGclipOutSound;
	
	stateName[7]				= "Wait";
	stateTimeoutValue[7]			= 2.2;
	stateSound[7]				= M739_LMGclipInSound;
	stateScript[7]				= "onReloadWait";
	stateSequence[7]			= "clipIn";
	stateTransitionOnTimeout[7]		= "Reloaded";
	
	stateName[8]				= "FireLoadCheckA";
	stateScript[8]				= "onLoadCheck";
	stateTimeoutValue[8]			= 0.01;
	stateTransitionOnTimeout[8]		= "FireLoadCheckB";
	
	stateName[9]				= "FireLoadCheckB";
	stateTransitionOnAmmo[9]		= "Smoke";
	stateTransitionOnNoAmmo[9]		= "ReloadSmoke";
	
	stateName[10] 				= "Smoke";
	//stateTimeoutValue[10]			= 0.2;
	stateTransitionOnTimeout[10]		= "Ready2";
	stateTransitionOnTriggerDown[10]	= "preFire";
	
	stateName[11] 				= "ReloadSmoke";
	stateTimeoutValue[11]			= 0.2;
	stateTransitionOnTimeout[11]		= "ReloadE";
	
	stateName[12]				= "Reloaded";
	stateTimeoutValue[12]			= 0.01;
	stateScript[12]				= "onReloaded";
	stateTransitionOnTimeout[12]		= "Ready";
	
//empty reload states
	stateName[24]				= "ReloadE";
	stateTimeoutValue[24]			= 0.86;
	stateScript[24]				= "onReloadStart";
	stateTransitionOnTimeout[24]		= "WaitE";
	stateWaitForTimeout[24]			= true;
	stateSequence[24]			= "clipOut_e";
	stateSound[24]				= M739_LMGclipOut_eSound;
	
	stateName[22]				= "WaitE";
	stateTimeoutValue[22]			= 2.5;
	stateSound[22]				= M739_LMGclipIn_eSound;
	stateScript[22]				= "onReloadWait";
	stateSequence[22]			= "clipIn_e";
	stateTransitionOnTimeout[22]		= "Reloaded";
	
	stateName[23]				= "ReloadedE";
	stateTimeoutValue[23]			= 0.01;
	stateScript[23]				= "onReloaded";
	stateTransitionOnTimeout[23]		= "Ready";
};

function M739_LMGImage::onFire(%this,%obj,%slot)
{

%pos = %obj.getTransform();
   %random = getRandom(1,5);
   switch(%random)
   {
      case 1:
         serverplay3d(M739_LMGFire1Sound,%pos);
      case 2:
         serverplay3d(M739_LMGFire2Sound,%pos);
      case 3:
         serverplay3d(M739_LMGFire3Sound,%pos);
      case 4:
         serverplay3d(M739_LMGFire4Sound,%pos);
      case 5:
         serverplay3d(M739_LMGFire5Sound,%pos);
      default:
         echo("Error on M739 SAW LMG");
   }

	%obj.toolAmmo[%obj.currTool]--;
	%obj.AmmoSpent[%obj.currTool]++;

			commandToClient(%obj.client,'bottomPrint',"<just:right><font:ds-digital:64><color:4577ab>" @ %obj.toolAmmo[%obj.currTool] @ "<font:ds-digital:24><color:004080> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
	Parent::onFire(%this,%obj,%slot);
}

function M739_LMGImage::onReloadWait(%this,%obj,%slot)
{
			commandToClient(%obj.client,'bottomPrint',"<just:right><font:ds-digital:64><color:4577ab>" @ %obj.toolAmmo[%obj.currTool] @ "<font:ds-digital:24><color:004080> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
}

function M739_LMGImage::onLoadCheck(%this,%obj,%slot)
{
	if(%obj.toolAmmo[%obj.currTool] <= 0)
		%obj.setImageAmmo(%slot,0);
	else
		%obj.setImageAmmo(%slot,1);
}

function M739_LMGImage::onReloadStart(%this,%obj,%slot)
{
				commandToClient(%obj.client,'bottomPrint',"<just:right><font:ds-digital:64><color:4577ab>" @ %obj.toolAmmo[%obj.currTool] @ "<font:ds-digital:24><color:004080> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
}

function M739_LMGImage::onReloaded(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool] = %this.item.maxAmmo;
	%obj.AmmoSpent[%obj.currTool] = 0;
	%obj.setImageAmmo(%slot,1);
			commandToClient(%obj.client,'bottomPrint',"<just:right><font:ds-digital:64><color:4577ab>" @ %obj.toolAmmo[%obj.currTool] @ "<font:ds-digital:24><color:004080> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
	return;
}


function M739_LMGImage::onMount(%this,%obj,%slot)
{
  %obj.hidenode("RHand");
        %obj.hidenode("LHand");
		   Parent::onMount(%this,%obj,%slot);
					commandToClient(%obj.client,'bottomPrint',"<just:right><font:ds-digital:64><color:4577ab>" @ %obj.toolAmmo[%obj.currTool] @ "<font:ds-digital:24><color:004080> " @ %this.item.maxAmmo @ "", 1,2,3,4); 

}

function M739_LMGImage::onUnMount(%this,%obj,%slot)
{
  %obj.unhidenode("RHand");
        %obj.unhidenode("LHand");
		%obj.playThread(2, root);
}