datablock AudioProfile(M7CSMG_DualFire1Sound)
{
   filename    = "./fire1.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(M7CSMG_DualFire2Sound)
{
   filename    = "./fire2.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(M7CSMG_DualFire3Sound)
{
   filename    = "./fire3.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(M7CSMG_DualClipIn1Sound)
{
   filename    = "./clipIn1.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(M7CSMG_DualClipIn2Sound)
{
   filename    = "./clipIn2.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(M7CSMG_DualClipOutSound)
{
   filename    = "./clipOut.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(M7CSMG_DualUse1Sound)
{
   filename    = "./use1.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(M7CSMG_DualUse2Sound)
{
   filename    = "./use2.wav";
   description = AudioClose3d;
   preload = true;
};

//ejected magazine
datablock DebrisData(M7CSMG_DualCasing)
{
	shapeFile = "./M7_Mag.dts";
	lifetime = 5.0;
	minSpinSpeed = -20.0;
	maxSpinSpeed = 10.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = false;

	gravModifier = 2;
};


//Effects
//Flash
datablock ParticleData(M7CSMG_DualflashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "./M45Flash";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.5 0.5 0.5 0.9";
	colors[1]     = "0.5 0.5 0.5 0.0";
	sizes[0]      = 1.0;
	sizes[1]      = 2.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(M7CSMG_DualflashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 25;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "M7CSMG_DualflashParticle";

   uiName = "M7 CSMG Flash";
};

AddDamageType("M7CSMG_Dual",   '<bitmap:add-ons/Weapon_The_New_Halo_Pack/M7CSMG_Dual/CI_M7> %1',    '%2 <bitmap:add-ons/Weapon_The_New_Halo_Pack/M7CSMG_Dual/CI_M7> %1',0.2,1);
datablock ProjectileData(M7CSMG_DualProjectile)
{
   projectileShapeName = "./bullet.dts";
   directDamage        = 10;
   directDamageType    = $DamageType::M7CSMG_Dual;
   radiusDamageType    = $DamageType::M7CSMG_Dual;

   brickExplosionRadius = 2;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 1;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 25;
   verticalImpulse	  = 0;
   explosion           = gunExplosion;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 0.2;

   hasLight    = true;
   lightRadius = 5.0;
   lightColor  = "0.5 0.5 0";

   uiName = "M7 CSMG Bullet";
};

//////////
// item //
//////////
datablock ItemData(M7CSMG_DualItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./M7Dual_Ground.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "M7 CSMG Dual Wield";
	iconName = "./UI_M7";
	doColorShift = true;
	colorShiftColor = "0.5 0.5 0.5 1.000";

	 // Dynamic properties defined by the scripts
	image = M7CSMG_DualImage;
	canDrop = true;

	maxAmmo = 120;
	canReload = 1;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(M7CSMG_DualImage)
{
   // Basic Item properties
   shapeFile = "./M7Dual.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = "0.5 1.0 -0.22"; //"0.7 1.2 -0.5"; -Left +Right, -Back +Front, -Down +Up
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = M7CSMG_DualItem;
   ammo = " ";
   projectile = M7CSMG_DualProjectile;
   projectileType = Projectile;

   
      raycastWeaponRange = 45;
   raycastWeaponTargets = $TypeMasks::FxBrickObjectType |	//Targets the weapon can hit: Raycasting Bricks
   				$TypeMasks::PlayerObjectType |	//AI/Players
   				$TypeMasks::StaticObjectType |	//Static Shapes
   				$TypeMasks::TerrainObjectType |	//Terrain
   				$TypeMasks::VehicleObjectType;	//Vehicles
   raycastWeaponPierceTargets = "";				//Gun cannot pierce
   raycastExplosionProjectile = M7CSMG_DualProjectile;
   raycastExplosionSound = "bulletHitSound"; //sound played by exploding gunprojectile
   raycastDirectDamage = 10; //Varies based on range
   raycastDirectDamageType = $DamageType::M7CSMG_Dual;
   raycastSpreadCount = 1;
   raycastSpreadAmt = 0.007;
   raycastTracerProjectile = "M7CSMG_DualProjectile";
   raycastFromMuzzle = 0;
   raycastImpactImpulse = 25;
   raycastVerticalImpulse = 0;
   
   
	casing = M7CSMG_DualCasing;
	shellExitDir        = "-1.0 0.0 -0.5"; //x z y?
	shellExitOffset     = "-0.2 0 0";
	shellExitVariance   = 0.0;	
	shellVelocity       = 07.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = M7CSMG_DualItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.
   // Initial start up state
	stateName[0]                     	= "Activate";
	stateTimeoutValue[0]             	= 0.53;
	stateTransitionOnTimeout[0]       	= "LoadCheckA";
	//stateSound[0]				= M7CSMG_DualUseSound;
	stateSequence[0]			= "use";
	stateScript[0] = "onUse";

	stateName[1]                     	= "Ready";
	stateTransitionOnNoAmmo[1]       	= "Reload";
	stateTransitionOnTriggerDown[1]  	= "preFire";
	stateAllowImageChange[1]         	= true;

	
	//Right-------------------------------------------------------------
	stateName[19]="preFire";
	stateTimeoutValue[19]=0;
	stateTransitionOnTimeout[19]="preFire2";
	stateScript[19]                  = "onFire";
	stateEmitter[19]					= M7CSMG_DualFlashEmitter;
	stateEmitterTime[19]				= 0.01;
	stateEmitterNode[19]				= "muzzleNode";
	stateFire[19]                    = true;
	
	stateName[21]="preFire2";
	stateTransitionOnTimeout[21]="preFire3";
	stateScript[21]				= "onLoadCheck";
	
	stateName[20]="preFire3";
	stateTransitionOnNoAmmo[20]="Fire";
	stateTransitionOnAmmo[20]="Fire";
	
	stateName[18]="Ready2";
	stateTransitionOnTriggerUp[18]="Ready";
	
	stateName[2]                    	= "Fire";
	stateTransitionOnTimeout[2]     	= "Delay";
	stateTimeoutValue[2]            	= 0.0;
	stateAllowImageChange[2]        	= false;
	stateSequence[2]                	= "fire1";
	stateWaitForTimeout[2]			= true;
	
	
	//Left-------------------------------------------------------------
	stateName[3] = "preFireL";
	stateTimeoutValue[3] = 0;
	stateTransitionOnTimeout[3] = "preFire2L";
	stateScript[3]                  = "onFire";
	stateEmitter[3]					= M7CSMG_DualFlashEmitter;
	stateEmitterTime[3]				= 0.01;
	stateEmitterNode[3]				= "muzzleNode";
	stateFire[3]                    = true;
	
	stateName[4]="preFire2L";
	stateTransitionOnTimeout[4]="preFire3L";
	stateScript[4]				= "onLoadCheck";
	
	stateName[5]="preFire3L";
	stateTransitionOnNoAmmo[5]="FireL";
	stateTransitionOnAmmo[5]="FireL";
	
	stateName[6]="Ready3";
	stateTransitionOnTriggerUp[6]="Ready";
	
	stateName[24]                    	= "FireL";
	stateTransitionOnTimeout[24]     	= "DelayL";
	stateTimeoutValue[24]            	= 0.0;
	stateAllowImageChange[24]        	= false;
	stateSequence[24]                	= "fire2";
	stateWaitForTimeout[24]			= true;
	
	stateName[25]				= "DelayL";
	stateTransitionOnTimeout[25]     	= "FireLoadCheckAL";
	stateTimeoutValue[25]            	= 0.05;

	stateName[26]				= "FireLoadCheckAL";
	stateScript[26]				= "onLoadCheck";
	stateTimeoutValue[26]			= 0;
	stateTransitionOnTimeout[26]		= "FireLoadCheckBL";
	
	stateName[27]				= "FireLoadCheckBL";
	stateTransitionOnAmmo[27]		= "SmokeL";
	stateTransitionOnNoAmmo[27]		= "ReloadSmoke";
	
	stateName[28] 				= "SmokeL";
	stateTransitionOnTimeout[28]		= "Ready2";
	stateTransitionOnTriggerDown[28]	= "preFire";
	
	
	
	stateName[7]				= "Delay";
	stateTransitionOnTimeout[7]     	= "FireLoadCheckA";
	stateTimeoutValue[7]            	= 0.0005;
	
	stateName[8]				= "LoadCheckA";
	stateScript[8]				= "onLoadCheck";
	stateTimeoutValue[8]			= 0.01;
	stateTransitionOnTimeout[8]		= "LoadCheckB";
	
	stateName[9]				= "LoadCheckB";
	stateTransitionOnAmmo[9]		= "Ready2";
	stateTransitionOnNoAmmo[9]		= "Reload";

	stateName[10]				= "Reload";
	stateTimeoutValue[10]			= 0;
	stateScript[10]				= "onReloadStart";
	stateTransitionOnTimeout[10]		= "Ejection";
	stateWaitForTimeout[10]			= false;
	stateSequence[10]			= "clipOut";
	stateSound[10]				= M7CSMG_DualClipOutSound;
	
	stateName[23]				= "Ejection";
	stateTimeoutValue[23]			= 1;
	stateTransitionOnTimeout[23]		= "Ejection2";
	stateWaitForTimeout[23]			= true;
	
	stateName[22]				= "Ejection2";
	stateTimeoutValue[22]			= 0.85;
	stateTransitionOnTimeout[22]		= "wait";
	stateWaitForTimeout[22]			= true;
	//stateEjectShell[22]       	  	= true;
	stateSound[22]				= M7CSMG_DualClipIn1Sound;
	
	stateName[11]				= "Wait";
	stateTimeoutValue[11]			= 0.80;
	stateScript[11]				= "onReloadWait";
	stateSequence[11]			= "clipIn";
	stateTransitionOnTimeout[11]		= "Reloaded";
	stateSound[11]				= M7CSMG_DualClipIn2Sound;
	
	stateName[12]				= "FireLoadCheckA";
	stateScript[12]				= "onLoadCheck";
	stateTimeoutValue[12]			= 0;
	stateTransitionOnTimeout[12]		= "FireLoadCheckB";
	
	stateName[13]				= "FireLoadCheckB";
	stateTransitionOnAmmo[13]		= "Smoke";
	stateTransitionOnNoAmmo[13]		= "ReloadSmoke";
	
	stateName[14] 				= "Smoke";
	//stateTimeoutValue[14]			= 0.01;
	stateTransitionOnTimeout[14]		= "preFireL";
	//stateTransitionOnTriggerDown[14]	= "preFire";
	
	stateName[15] 				= "ReloadSmoke";
	stateTimeoutValue[15]			= 0.02;
	stateTransitionOnTimeout[15]		= "Reload";
	
	stateName[17]				= "Reloaded";
	stateTimeoutValue[17]			= 0.01;
	stateScript[17]				= "onReloaded";
	stateTransitionOnTimeout[17]		= "Ready";
};

function M7CSMG_DualImage::onUse(%this,%obj,%slot)
{
   %pos = %obj.getTransform();
   %random = getRandom(1,2);
   switch(%random)
   {
      case 1:
         serverplay3d(M7CSMG_DualUse1Sound,%pos);
      case 2:
         serverplay3d(M7CSMG_DualUse2Sound,%pos);
      default:
         echo("Error on M7CSMG_Dual");
   }
}

function M7CSMG_DualImage::onFire(%this,%obj,%slot)
{
   %pos = %obj.getTransform();
   %random = getRandom(1,3);
   switch(%random)
   {
      case 1:
         serverplay3d(M7CSMG_DualFire1Sound,%pos);
      case 2:
         serverplay3d(M7CSMG_DualFire2Sound,%pos);
      case 3:
         serverplay3d(M7CSMG_DualFire3Sound,%pos);
      default:
         echo("Error on M7CSMG_Dual");
   }
	
	%obj.toolAmmo[%obj.currTool]--;
	%obj.AmmoSpent[%obj.currTool]++;

			commandToClient(%obj.client,'bottomPrint',"<just:right><font:ds-digital:64><color:4577ab>" @ %obj.toolAmmo[%obj.currTool] @ "<font:ds-digital:24><color:004080> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
	Parent::onFire(%this,%obj,%slot);
}

function M7CSMG_DualImage::onMount(%this,%obj,%slot)
{
  
  %obj.hidenode("RHand");
        %obj.hidenode("LHand");
}

function M7CSMG_DualImage::onUnMount(%this,%obj,%slot)
{
  
  %obj.unhidenode("RHand");
        %obj.unhidenode("LHand");
}

function M7CSMG_DualImage::onReloadWait(%this,%obj,%slot)
{
			commandToClient(%obj.client,'bottomPrint',"<just:right><font:ds-digital:64><color:4577ab>" @ %obj.toolAmmo[%obj.currTool] @ "<font:ds-digital:24><color:004080> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
}

function M7CSMG_DualImage::onLoadCheck(%this,%obj,%slot)
{
	if(%obj.toolAmmo[%obj.currTool] <= 0)
		%obj.setImageAmmo(%slot,0);
	else
		%obj.setImageAmmo(%slot,1);
}

function M7CSMG_DualImage::onReloadStart(%this,%obj,%slot)
{
				commandToClient(%obj.client,'bottomPrint',"<just:right><font:ds-digital:64><color:4577ab>" @ %obj.toolAmmo[%obj.currTool] @ "<font:ds-digital:24><color:004080> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
}

function M7CSMG_DualImage::onReloaded(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool] = %this.item.maxAmmo;
	%obj.AmmoSpent[%obj.currTool] = 0;
	%obj.setImageAmmo(%slot,1);
			commandToClient(%obj.client,'bottomPrint',"<just:right><font:ds-digital:64><color:4577ab>" @ %obj.toolAmmo[%obj.currTool] @ "<font:ds-digital:24><color:004080> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
	return;
}