datablock AudioProfile(M7SCSMGFire1Sound)
{
   filename    = "./fire1.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(M7SCSMGFire2Sound)
{
   filename    = "./fire2.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(M7SCSMGFire3Sound)
{
   filename    = "./fire3.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(M7SCSMGMagInSound)
{
   filename    = "./clipIn.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(M7SCSMGMagOutSound)
{
   filename    = "./clipOut.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(M7SCSMGUse1Sound)
{
   filename    = "./use1.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(M7SCSMGUse2Sound)
{
   filename    = "./use2.wav";
   description = AudioClose3d;
   preload = true;
};

//ejected magazine
datablock DebrisData(M7SCSMGCasing)
{
	shapeFile = "./M7_Mag.dts";
	lifetime = 5.0;
	minSpinSpeed = -20.0;
	maxSpinSpeed = 10.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = false;

	gravModifier = 2;
};

AddDamageType("M7SCSMG",   '<bitmap:add-ons/Weapon_The_New_Halo_Pack/M7SCSMG/CI_M7S> %1',    '%2 <bitmap:add-ons/Weapon_The_New_Halo_Pack/M7SCSMG/CI_M7S> %1',0.2,1);
datablock ProjectileData(M7SCSMGProjectile)
{
   projectileShapeName = "./bullet.dts";
   directDamage        = 10;
   directDamageType    = $DamageType::M7SCSMG;
   radiusDamageType    = $DamageType::M7SCSMG;

   brickExplosionRadius = 2;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 1;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 25;
   verticalImpulse	  = 0;
   explosion           = gunExplosion;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 0.2;

   hasLight    = true;
   lightRadius = 5.0;
   lightColor  = "0.5 0.5 0";

   uiName = "M7S CSMG Bullet";
};

//////////
// item //
//////////
datablock ItemData(M7SCSMGItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./M7S_Ground.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "M7S CSMG";
	iconName = "./UI_M7";
	doColorShift = true;
	colorShiftColor = "0.5 0.5 0.5 1.000";

	 // Dynamic properties defined by the scripts
	image = M7SCSMGImage;
	canDrop = true;

	maxAmmo = 60;
	canReload = 1;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(M7SCSMGImage)
{
   // Basic Item properties
   shapeFile = "./M7S.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = "0.3 1.0 -0.22"; //"0.7 1.2 -0.5"; -Left +Right, -Back +Front, -Down +Up
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = M7SCSMGItem;
   ammo = " ";
   projectile = M7SCSMGProjectile;
   projectileType = Projectile;

         raycastWeaponRange = 45;
   raycastWeaponTargets = $TypeMasks::FxBrickObjectType |	//Targets the weapon can hit: Raycasting Bricks
   				$TypeMasks::PlayerObjectType |	//AI/Players
   				$TypeMasks::StaticObjectType |	//Static Shapes
   				$TypeMasks::TerrainObjectType |	//Terrain
   				$TypeMasks::VehicleObjectType;	//Vehicles
   raycastWeaponPierceTargets = "";				//Gun cannot pierce
   raycastExplosionProjectile = M7SCSMGProjectile;
   raycastExplosionSound = "bulletHitSound"; //sound played by exploding gunprojectile
   raycastDirectDamage = 10; //Varies based on range
   raycastDirectDamageType = $DamageType::M7SCSMG;
   raycastSpreadCount = 1;
   raycastSpreadAmt = 0.007;
   raycastTracerProjectile = "M7SCSMGProjectile";
   raycastFromMuzzle = 0;
   raycastImpactImpulse = 25;
   raycastVerticalImpulse = 0;
   
   
	casing = M7SCSMGCasing;
	shellExitDir        = "-1.0 0.0 -0.5"; //x z y?
	shellExitOffset     = "-0.2 0 0";
	shellExitVariance   = 0.0;	
	shellVelocity       = 07.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = M7SCSMGItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.
   // Initial start up state
	stateName[0]                     	= "Activate";
	stateTimeoutValue[0]             	= 0.53;
	stateTransitionOnTimeout[0]       	= "LoadCheckA";
	//stateSound[0]				= M7SCSMGUseSound;
	stateSequence[0]			= "use";
	stateScript[0] = "onUse";

	stateName[1]                     	= "Ready";
	stateTransitionOnNoAmmo[1]       	= "Reload";
	stateTransitionOnTriggerDown[1]  	= "preFire";
	stateAllowImageChange[1]         	= true;

	stateName[19]="preFire";
	stateTimeoutValue[19]=0;
	stateTransitionOnTimeout[19]="preFire2";
	stateScript[19]                  = "onFire";
	stateEmitter[19]					= gunSmokeEmitter;
	stateEmitterTime[19]				= 0.01;
	stateEmitterNode[19]				= "muzzleNode";
	stateFire[19]                    = true;
	
	stateName[21]="preFire2";
	stateTransitionOnTimeout[21]="preFire3";
	stateScript[21]				= "onLoadCheck";
	
	stateName[20]="preFire3";
	stateTransitionOnNoAmmo[20]="Fire2";
	stateTransitionOnAmmo[20]="Fire";
	
	stateName[18]="Ready2";
	stateTransitionOnTriggerUp[18]="Ready";
	
	stateName[2]                    	= "Fire";
	stateTransitionOnTimeout[2]     	= "Delay";
	stateTimeoutValue[2]            	= 0.0;
	stateAllowImageChange[2]        	= false;
	stateSequence[2]                	= "fire";
	stateWaitForTimeout[2]			= true;
	//stateSound[2]				= M7SCSMGFireSound;

	stateName[16]                    	= "Fire2";
	stateTransitionOnTimeout[16]     	= "Delay";
	stateTimeoutValue[16]            	= 0.0;
	stateAllowImageChange[16]        	= false;
	stateSequence[16]                	= "fire";
	stateWaitForTimeout[16]			= true;
	
	stateName[7]				= "Delay";
	stateTransitionOnTimeout[7]     	= "FireLoadCheckA";
	stateTimeoutValue[7]            	= 0.001;
	
	stateName[8]				= "LoadCheckA";
	stateScript[8]				= "onLoadCheck";
	stateTimeoutValue[8]			= 0.01;
	stateTransitionOnTimeout[8]		= "LoadCheckB";
	
	stateName[9]				= "LoadCheckB";
	stateTransitionOnAmmo[9]		= "Ready2";
	stateTransitionOnNoAmmo[9]		= "Reload";

	stateName[10]				= "Reload";
	stateTimeoutValue[10]			= 0;
	stateScript[10]				= "onReloadStart";
	stateTransitionOnTimeout[10]		= "Ejection";
	stateWaitForTimeout[10]			= false;
	stateSequence[10]			= "clipOut";
	stateSound[10]				= M7SCSMGMagOutSound;
	
	stateName[23]				= "Ejection";
	stateTimeoutValue[23]			= 0.2;
	stateTransitionOnTimeout[23]		= "Ejection2";
	stateWaitForTimeout[23]			= true;
	
	stateName[22]				= "Ejection2";
	stateTimeoutValue[22]			= 0.65;
	stateTransitionOnTimeout[22]		= "wait";
	stateWaitForTimeout[22]			= true;
	stateEjectShell[22]       	  	= true;
	
	stateName[11]				= "Wait";
	stateTimeoutValue[11]			= 0.80;
	stateSound[11]				= M7SCSMGMagInSound;
	stateScript[11]				= "onReloadWait";
	stateSequence[11]			= "clipIn";
	stateTransitionOnTimeout[11]		= "Reloaded";
	
	stateName[12]				= "FireLoadCheckA";
	stateScript[12]				= "onLoadCheck";
	stateTimeoutValue[12]			= 0.01;
	stateTransitionOnTimeout[12]		= "FireLoadCheckB";
	
	stateName[13]				= "FireLoadCheckB";
	stateTransitionOnAmmo[13]		= "Smoke";
	stateTransitionOnNoAmmo[13]		= "ReloadSmoke";
	
	stateName[14] 				= "Smoke";
	//stateTimeoutValue[14]			= 0.01;
	stateTransitionOnTimeout[14]		= "Ready2";
	stateTransitionOnTriggerDown[14]	= "preFire";
	
	stateName[15] 				= "ReloadSmoke";
	stateTimeoutValue[15]			= 0.02;
	stateTransitionOnTimeout[15]		= "Reload";
	
	stateName[17]				= "Reloaded";
	stateTimeoutValue[17]			= 0.01;
	stateScript[17]				= "onReloaded";
	stateTransitionOnTimeout[17]		= "Ready";
};

function M7SCSMGImage::onUse(%this,%obj,%slot)
{
   %pos = %obj.getTransform();
   %random = getRandom(1,2);
   switch(%random)
   {
      case 1:
         serverplay3d(M7SCSMGUse1Sound,%pos);
      case 2:
         serverplay3d(M7SCSMGUse2Sound,%pos);
      default:
         echo("Error on M7SCSMG");
   }
}

function M7SCSMGImage::onFire(%this,%obj,%slot)
{
   %pos = %obj.getTransform();
   %random = getRandom(1,3);
   switch(%random)
   {
      case 1:
         serverplay3d(M7SCSMGFire1Sound,%pos);
      case 2:
         serverplay3d(M7SCSMGFire2Sound,%pos);
      case 3:
         serverplay3d(M7SCSMGFire3Sound,%pos);
      default:
         echo("Error on M7SCSMG");
   }
	
	%obj.toolAmmo[%obj.currTool]--;
	%obj.AmmoSpent[%obj.currTool]++;

			commandToClient(%obj.client,'bottomPrint',"<just:right><font:ds-digital:64><color:4577ab>" @ %obj.toolAmmo[%obj.currTool] @ "<font:ds-digital:24><color:004080> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
	Parent::onFire(%this,%obj,%slot);
}

function M7SCSMGImage::onMount(%this,%obj,%slot)
{
  
  %obj.hidenode("RHand");
        %obj.hidenode("LHand");
}

function M7SCSMGImage::onUnMount(%this,%obj,%slot)
{
  
  %obj.unhidenode("RHand");
        %obj.unhidenode("LHand");
}

function M7SCSMGImage::onReloadWait(%this,%obj,%slot)
{
			commandToClient(%obj.client,'bottomPrint',"<just:right><font:ds-digital:64><color:4577ab>" @ %obj.toolAmmo[%obj.currTool] @ "<font:ds-digital:24><color:004080> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
}

function M7SCSMGImage::onLoadCheck(%this,%obj,%slot)
{
	if(%obj.toolAmmo[%obj.currTool] <= 0)
		%obj.setImageAmmo(%slot,0);
	else
		%obj.setImageAmmo(%slot,1);
}

function M7SCSMGImage::onReloadStart(%this,%obj,%slot)
{
				commandToClient(%obj.client,'bottomPrint',"<just:right><font:ds-digital:64><color:4577ab>" @ %obj.toolAmmo[%obj.currTool] @ "<font:ds-digital:24><color:004080> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
}

function M7SCSMGImage::onReloaded(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool] = %this.item.maxAmmo;
	%obj.AmmoSpent[%obj.currTool] = 0;
	%obj.setImageAmmo(%slot,1);
			commandToClient(%obj.client,'bottomPrint',"<just:right><font:ds-digital:64><color:4577ab>" @ %obj.toolAmmo[%obj.currTool] @ "<font:ds-digital:24><color:004080> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
	return;
}