datablock AudioProfile(MA5KFire1Sound)
{
   filename    = "./fire1.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(MA5KFire2Sound)
{
   filename    = "./fire2.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(MA5KFire3Sound)
{
   filename    = "./fire3.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(MA5KFire4Sound)
{
   filename    = "./fire4.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(MA5KFire5Sound)
{
   filename    = "./fire5.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(MA5KClipInSound)
{
   filename    = "./clipIn.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(MA5KClipOutSound)
{
   filename    = "./clipOut.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(MA5KUseSound)
{
   filename    = "./use.wav";
   description = AudioClose3d;
   preload = true;
};


datablock AudioProfile(MA5KClipIn_EmptySound)
{
   filename    = "./clipIn_e.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(MA5KClipOut_EmptySound)
{
   filename    = "./clipOut_e.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(MA5KClipThrowSound)
{
   filename    = "./clipThrow.wav";
   description = AudioClose3d;
   preload = true;
};
//shell
datablock DebrisData(MA5KCasing)
{
	shapeFile = "./MA5K_Mag.dts";
	lifetime = 2.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.4;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};

//Effects
//Flash
datablock ParticleData(MA5KflashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "./muzzle0";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.5 0.5 0.5 0.9";
	colors[1]     = "0.5 0.5 0.5 0.0";
	sizes[0]      = 2.0;
	sizes[1]      = 3.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(MA5KflashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 25;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "MA5KflashParticle";

   uiName = "MA5K Flash";
};

AddDamageType("MA5K",   '<bitmap:add-ons/Weapon_The_New_Halo_Pack/MA5K/CI_MA5K> %1',    '%2 <bitmap:add-ons/Weapon_The_New_Halo_Pack/MA5K/CI_MA5K> %1',0.2,1);
datablock ProjectileData(MA5KProjectile)
{
   projectileShapeName = "./bullet_tracer.dts";
   directDamage        = 15;
   directDamageType    = $DamageType::MA5K;
   radiusDamageType    = $DamageType::MA5K;

   brickExplosionRadius = 2;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 1;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 25;
   verticalImpulse	  = 0;
   explosion           = gunExplosion;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 0.2;

   hasLight    = true;
   lightRadius = 5.0;
   lightColor  = "0.5 0.5 0";

   uiName = "MA5K Bullet";
};

datablock ProjectileData(MA5KTracerProjectile)
{
   projectileShapeName = "./bullet_tracer.dts";
   directDamage        = 0;
   directDamageType    = $DamageType::MA5K;
   radiusDamageType    = $DamageType::MA5K;

   brickExplosionRadius = 2;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 1;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 25;
   verticalImpulse	  = 0;
   explosion           = gunExplosion;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 0.2;

   hasLight    = true;
   lightRadius = 5.0;
   lightColor  = "0.5 0.5 0";

   uiName = "MA5K Bullet";
};

//////////
// item //
//////////
datablock ItemData(MA5KItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./MA5K_Ground.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "MA5K Assault Carbine";
	iconName = "./UI_MA5K";
	doColorShift = true;
	colorShiftColor = "0.5 0.5 0.5 1.000";

	 // Dynamic properties defined by the scripts
	image = MA5KImage;
	canDrop = true;

	maxAmmo = 60;
	canReload = 1;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(MA5KImage)
{
   // Basic Item properties
   shapeFile = "./MA5K.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = "0.4 1.2 -0.4";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = MA5KItem;
   ammo = " ";
   projectile = MA5KProjectile;
   projectileType = Projectile;

	casing = MA5KCasing;
	shellExitDir        = "2.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 25.0;	
	shellVelocity       = 10.0;

	   raycastWeaponRange = 60;
   raycastWeaponTargets = $TypeMasks::FxBrickObjectType |	//Targets the weapon can hit: Raycasting Bricks
   				$TypeMasks::PlayerObjectType |	//AI/Players
   				$TypeMasks::StaticObjectType |	//Static Shapes
   				$TypeMasks::TerrainObjectType |	//Terrain
   				$TypeMasks::VehicleObjectType;	//Vehicles
   raycastWeaponPierceTargets = "";				//Gun cannot pierce
   raycastExplosionProjectile = MA5KProjectile;
   raycastExplosionSound = "bulletHitSound"; //sound played by exploding gunprojectile
   raycastDirectDamage = 32; //Varies based on range
   raycastDirectDamageType = $DamageType::MA5K;
   raycastSpreadCount = 1;
   raycastSpreadAmt = 0.003;
   raycastTracerProjectile = "MA5KTracerProjectile";
   raycastFromMuzzle = 0;
   raycastImpactImpulse = 25;
   raycastVerticalImpulse = 0;
   
   	casing = MA5KCasing;
	shellExitDir        = "2.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 25.0;	
	shellVelocity       = 10.0;
	
   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = MA5KItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.
   // Initial start up state
	stateName[0]                     	= "Activate";
	stateTimeoutValue[0]             	= 0.53;
	stateTransitionOnTimeout[0]       	= "LoadCheckA";
	stateSound[0]				= MA5KUseSound;
	stateSequence[0]			= "use";

	stateName[1]                     	= "Ready";
	stateTransitionOnNoAmmo[1]       	= "Reload";
	stateTransitionOnTriggerDown[1]  	= "preFire";
	stateAllowImageChange[1]         	= true;

	stateName[21]="preFire";
	stateTimeoutValue[21]=0;
	stateTransitionOnTimeout[21]="preFire2";
	stateScript[21]                  = "onFire";
	stateEmitter[21]					= MA5KFlashEmitter;
	stateEmitterTime[21]				= 0.05;
	stateEmitterNode[21]				= "muzzleNode";
	stateFire[21]                    = true;
	
	stateName[22]="preFire2";
	stateTransitionOnTimeout[22]="preFire3";
	stateScript[22]				= "onLoadCheck";
	
	stateName[23]="preFire3";
	stateTransitionOnNoAmmo[23]="Fire2";
	stateTransitionOnAmmo[23]="Fire";
	
	stateName[24]="Ready2";
	stateTransitionOnTriggerUp[24]="Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Delay";
	stateTimeoutValue[2]            = 0.00;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateWaitForTimeout[2]			= true;
	//stateSound[2]					= MA5KFireSound;
	
	stateName[25]                    = "Fire2";
	stateTransitionOnTimeout[25]     = "Delay";
	stateTimeoutValue[25]            = 0.00;
	stateAllowImageChange[25]        = false;
	stateSequence[25]                = "Fire2";
	stateWaitForTimeout[25]			= true;
	//stateSound[25]					= MA5KFireSound;

	stateName[7]				= "Delay";
	stateTransitionOnTimeout[7]     	= "FireLoadCheckA";
	stateTimeoutValue[7]            	= 0.05;
	stateEmitter[7]				= gunSmokeEmitter;
	stateEmitterTime[7]			= 0.01;
	stateEmitterNode[7]			= "muzzleNode";
	
	stateName[8]				= "LoadCheckA";
	stateScript[8]				= "onLoadCheck";
	stateTimeoutValue[8]			= 0.01;
	stateTransitionOnTimeout[8]		= "LoadCheckB";
	
	stateName[9]				= "LoadCheckB";
	stateTransitionOnAmmo[9]		= "Ready";
	stateTransitionOnNoAmmo[9]		= "Reload2";

	stateName[10]				= "Reload";
	stateTimeoutValue[10]			= 1.5;
	stateScript[10]				= "onReloadStart";
	stateTransitionOnTimeout[10]		= "Wait";
	stateWaitForTimeout[10]			= true;
	stateSequence[10]			= "clipOut";
	stateSound[10]				= MA5KClipOutSound;
	
	stateName[11]				= "Wait";
	stateTimeoutValue[11]			= 1.8;
	stateSound[11]				= MA5KClipInSound;
	stateScript[11]				= "onReloadWait";
	stateSequence[11]			= "clipIn";
	stateTransitionOnTimeout[11]		= "Reloaded";
	
	stateName[12]				= "FireLoadCheckA";
	stateScript[12]				= "onLoadCheck";
	stateTimeoutValue[12]			= 0.01;
	stateTransitionOnTimeout[12]		= "FireLoadCheckB";
	
	stateName[13]				= "FireLoadCheckB";
	stateTransitionOnAmmo[13]		= "Smoke";
	stateTransitionOnNoAmmo[13]		= "ReloadSmoke";
	
	stateName[14] 				= "Smoke";
	stateEmitter[14]			= gunSmokeEmitter;
	stateEmitterTime[14]			= 0.000000000000001;
	stateEmitterNode[14]			= "muzzleNode";
	stateTimeoutValue[14]			= 0.000000000000001;
	stateTransitionOnTimeout[14]		= "Ready";
	stateTransitionOnTriggerDown[14]	= "preFire";
	
	stateName[15] 				= "ReloadSmoke";
	stateEmitter[15]			= gunSmokeEmitter;
	stateEmitterTime[15]			= 0.000000000000001;
	stateEmitterNode[15]			= "muzzleNode";
	stateTimeoutValue[15]			= 0.000000000000001;
	stateTransitionOnTimeout[15]		= "Reload2";
	
	stateName[16]				= "Reloaded";
	stateTimeoutValue[16]			= 0.01;
	stateScript[16]				= "onReloaded";
	stateTransitionOnTimeout[16]		= "Ready";

	//empty reload states

	//Remove the Magazine...
	stateName[17]				= "Reload2";
	stateTimeoutValue[17]			= 0.76;
	stateScript[17]				= "onReloadStart";
	stateTransitionOnTimeout[17]		= "MagThrow";
	stateWaitForTimeout[17]			= true;
	stateSequence[17]			= "clipOut_e";
	stateSound[17]				= MA5KclipOut_EmptySound;
	
	//Throw the Empty Magazine Away!
	stateName[18]				= "MagThrow";
	stateTransitionOnTimeout[18]		= "Wait2";
	stateWaitForTimeout[18]			= true;
	stateEjectShell[18]       	  	= true;
	stateSound[18]				= MA5KclipThrowSound;
	stateTimeoutValue[18]			= 0.0000000000000000000000000000000000000000001;
	
	//Replace the Magazine...
	stateName[19]				= "Wait2";
	stateTimeoutValue[19]			= 1.8;
	stateSound[19]				= MA5KclipIn_EmptySound;
	stateScript[19]				= "onReloadWait";
	stateSequence[19]			= "clipIn_e";
	stateTransitionOnTimeout[19]		= "Reloaded";
	
	//Scripting Stuff and End
	stateName[20]				= "Reloaded2";
	stateTimeoutValue[20]			= 0.01;
	stateScript[20]				= "onReloaded";
	stateTransitionOnTimeout[20]		= "Ready";


};

function MA5KImage::onFire(%this,%obj,%slot)
{
	
   %pos = %obj.getTransform();
   %random = getRandom(1,5);
   switch(%random)
   {
      case 1:
         serverplay3d(MA5KFire1Sound,%pos);
      case 2:
         serverplay3d(MA5KFire2Sound,%pos);
      case 3:
         serverplay3d(MA5KFire3Sound,%pos);
	  case 4:
         serverplay3d(MA5KFire4Sound,%pos);
	  case 5:
         serverplay3d(MA5KFire5Sound,%pos);
		 
      default:
         echo("Error on MA5K");
   }
	
	%obj.toolAmmo[%obj.currTool]--;
	%obj.AmmoSpent[%obj.currTool]++;

			commandToClient(%obj.client,'bottomPrint',"<just:right><font:ds-digital:64><color:4577ab>" @ %obj.toolAmmo[%obj.currTool] @ "<font:ds-digital:24><color:004080> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
	Parent::onFire(%this,%obj,%slot);
}


function MA5KImage::onReloadWait(%this,%obj,%slot)
{
			commandToClient(%obj.client,'bottomPrint',"<just:right><font:ds-digital:64><color:4577ab>" @ %obj.toolAmmo[%obj.currTool] @ "<font:ds-digital:24><color:004080> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
}

function MA5KImage::onLoadCheck(%this,%obj,%slot)
{
	if(%obj.toolAmmo[%obj.currTool] <= 0)
		%obj.setImageAmmo(%slot,0);
	else
		%obj.setImageAmmo(%slot,1);
}

function MA5KImage::onReloadStart(%this,%obj,%slot)
{
				commandToClient(%obj.client,'bottomPrint',"<just:right><font:ds-digital:64><color:4577ab>" @ %obj.toolAmmo[%obj.currTool] @ "<font:ds-digital:24><color:004080> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
}

function MA5KImage::onReloaded(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool] = %this.item.maxAmmo;
	%obj.AmmoSpent[%obj.currTool] = 0;
	%obj.setImageAmmo(%slot,1);
			commandToClient(%obj.client,'bottomPrint',"<just:right><font:ds-digital:64><color:4577ab>" @ %obj.toolAmmo[%obj.currTool] @ "<font:ds-digital:24><color:004080> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
	return;
}


//### Mount on player

datablock ShapeBaseImageData(MA5KBackImage)
{
  shapeFile = "./MA5K_Back.dts";
  emap = true;
  mountPoint = $BackSlot;
  offset = "-0.4 -0.35 0";
  eyeOffset = "0 0 10";
  rotation = eulerToMatrix("65 0 90");
  armReady = false;
  doColorShift = false;
};

function MA5KImage::onMount(%this,%obj,%slot)
{
  parent::onMount(%this,%obj,%slot);
  if(%obj.getMountedImage(1).getName() $= "MA5KBackImage") { %obj.unMountImage(1); }
  
  %obj.hidenode("RHand");
        %obj.hidenode("LHand");
		   Parent::onMount(%this,%obj,%slot);
					commandToClient(%obj.client,'bottomPrint',"<just:right><font:ds-digital:64><color:4577ab>" @ %obj.toolAmmo[%obj.currTool] @ "<font:ds-digital:24><color:004080> " @ %this.item.maxAmmo @ "", 1,2,3,4); 

}

function MA5KImage::onUnMount(%this,%obj,%slot)
{
  parent::onUnMount(%this,%obj,%slot);
  %obj.unMountImage(1);
  %obj.mountImage(MA5KBackImage,1);
  
  %obj.unhidenode("RHand");
        %obj.unhidenode("LHand");
		%obj.playThread(2, root);
}

function MA5KItem::onPickup(%this,%obj,%col,%a)
{
  for(%i=0;%i<%col.getdatablock().maxTools;%i++)
  {
    %item = %col.tool[%i];
    if(%item $= 0 || %item $= "")
    {
      %freeSlot = 1;
      break;
    }
  }
  if(%obj.canpickup && !isobject(%col.getmountedimage(1)) && %freeSlot) { %col.mountimage(MA5KBackImage,1); }
  parent::onPickup(%this,%obj,%col,%a);
}

package MA5KPackage
{
  function servercmdDropTool(%this,%slot)
  {
    if(isobject(%this.player.tool[%slot]) && %this.player.tool[%slot].getname() $= "MA5KItem")
    {
      parent::servercmdDropTool(%this,%slot);
      if(isobject(%this.player.getmountedimage(1)) && %this.player.getmountedimage(1).getname() $= "MA5KBackImage") { %this.player.schedule(5,unmountimage,1); }
      return;
    }
    parent::servercmdDropTool(%this,%slot);
  }
};
activatepackage(MA5KPackage);