datablock AudioProfile(SRS99_AM1Sound)
{
   filename    = "./fire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(SRS99_AMClipInSound)
{
   filename    = "./clipIn.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(SRS99_AMClipOutSound)
{
   filename    = "./clipOut.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(SRS99_AMClipIn_eSound)
{
   filename    = "./clipIn_e.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(SRS99_AMBoltBSound)
{
   filename    = "./BoltB.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(SRS99_AMBoltFSound)
{
   filename    = "./BoltF.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(SRS99_AMUseSound)
{
   filename    = "./use.wav";
   description = AudioClose3d;
   preload = true;
};

//shell
datablock DebrisData(SRS99_AMCasing)
{
	shapeFile = "./SniperShell.dts";
	lifetime = 2.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};

datablock ParticleData(SRS99_AMTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 2;
	gravityCoefficient	= 0.01;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 3000;
	lifetimeVarianceMS	= 500;
	spinSpeed		= 0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= false;
	animateTexture		= false;
	//framesPerSec		= 1;
	textureName		= "base/data/particles/dot";
	colors[0]     = "1 1 1 1";
	colors[1]     = "1 1 1 0";
	sizes[0]	= 0.2;
	sizes[1]	= 0.0;
	times[0]	= 0.0;
	times[1]	= 1.0;
};
datablock ParticleEmitterData(SRS99_AMTrailEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = SRS99_AMTrailParticle;

   useEmitterColors = true;
   uiName = "";
};

//Effects
//Flash
datablock ParticleData(SRS99_AMflashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "./SniperMuzFlash";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.5 0.5 0.5 0.9";
	colors[1]     = "0.5 0.5 0.5 0.0";
	sizes[0]      = 2.0;
	sizes[1]      = 3.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(SRS99_AMflashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 25;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "SRS99_AMflashParticle";

   uiName = "SRS99 AM Flash";
};

datablock ExplosionData(SRS99_AMMuzzleExplosion)
{

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "3.0 10.0 3.0";
   camShakeDuration = 0.5;
   camShakeRadius = 5.0;

   // Dynamic light
   lightStartRadius = 10;
   lightEndRadius = 1;
   lightStartColor = "0.5 0.5 0 1";
   lightEndColor = "0.3 0.1 0.0 1";

   damageRadius = 0;
   radiusDamage = 0;

   impulseRadius = 0;
   impulseForce = 0;
};

AddDamageType("SRS99_AM",   '<bitmap:add-ons/Weapon_The_New_Halo_Pack/SRS99_AM/CI_SRS99_AM> %1',    '%2 <bitmap:add-ons/Weapon_The_New_Halo_Pack/SRS99_AM/CI_SRS99_AM> %1',0.2,1);
datablock ProjectileData(SRS99_AMTracerProjectile)
{
   projectileShapeName = "./bullet.dts";
   directDamage        = 200;
   directDamageType    = $DamageType::SRS99_AM;
   radiusDamageType    = $DamageType::SRS99_AM;

   brickExplosionRadius = 2;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 5;
   brickExplosionMaxVolume = 10;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 15;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 25;
   verticalImpulse	  = 0;
   particleEmitter     = "SRS99_AMTrailEmitter";
   explosion           = gunExplosion;

   muzzleVelocity      = 800;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 50;
   bounceFriction      = 0.01;
   isBallistic         = true;
   bounceAngle         = 0; 
   minStickVelocity    = 1000;
   bounceElasticity    = 1000;
   bounceFriction      = 0;
   gravityMod = 0;

   hasLight    = false;
   lightRadius = 5.0;
   lightColor  = "0.5 0.5 0";

   uiName = "SRS99 AM Tracer";
};

datablock ProjectileData(SRS99_AMMuzzleExplosionProjectile)
{
   projectileShapeName = "./empty.dts";
   directDamage        = 0;
   directDamageType    = $DamageType::SRS99_AM;
   radiusDamageType    = $DamageType::SRS99_AM;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 0;
   brickExplosionMaxVolume = 0;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 0;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 0;
   verticalImpulse	  = 0;
   explosion           = SRS99_AMMuzzleExplosion;

   muzzleVelocity      = 0;
   velInheritFactor    = 1;
   explodeOnDeath = true;

   armingDelay         = 0;
   lifetime            = 0;
   fadeDelay           = 0;
   bounceAngle         = 170;
   minStickVelocity    = 10;
   bounceElasticity    = 0.3;
   bounceFriction      = 0;   
   gravityMod = 0;

   hasLight    = false;
   lightRadius = 5.0;
   lightColor  = "0.5 0.5 0";

   uiName = "SRS99-AM Muzzle Explosion Projectile";
};

//////////
// item //
//////////
datablock ItemData(SRS99_AMItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./SRS99_AM_Ground.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "SRS99 AM";
	iconName = "./UI_SRS99_AM";
	doColorShift = true;
	colorShiftColor = "0.5 0.5 0.5 1.000";

	 // Dynamic properties defined by the scripts
	image = SRS99_AMImage;
	canDrop = true;

	maxAmmo = 4;
	canReload = 1;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(SRS99_AMImage)
{
   // Basic Item properties
   shapeFile = "./SRS99_AM.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = "0.4 1.2 -0.3"; //0 -Left +Right, -Back +Front, -Down +Up
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = SRS99_AMItem;
   ammo = " ";
   projectile = SRS99_AMTracerProjectile;
   projectileType = Projectile;

	casing = SRS99_AMCasing;
	shellExitDir        = "2.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 25.0;	
	shellVelocity       = 10.0;
	
	   raycastWeaponRange = 5000;
   raycastWeaponTargets = $TypeMasks::FxBrickObjectType |	//Targets the weapon can hit: Raycasting Bricks
   				$TypeMasks::PlayerObjectType |	//AI/Players
   				$TypeMasks::StaticObjectType |	//Static Shapes
   				$TypeMasks::TerrainObjectType |	//Terrain
   				$TypeMasks::VehicleObjectType;	//Vehicles
   raycastWeaponPierceTargets = "";				//Gun cannot pierce
   raycastExplosionPlayerSound = bulletHitSound;
   raycastExplosionBrickSound = bulletHitSound;
   raycastExplosionProjectile = GunProjectile;
   raycastExplosionSound = ""; //sound played by exploding gunprojectile
   raycastDirectDamage = 100;
   raycastDirectDamageType = $DamageType::SRS99_AM;
   //raycastCritDirectDamageType = $DamageType::SRS99_AMCRIT;
   raycastSpreadCount = 1;
   raycastSpreadAmt = 0;
   raycastTracerProjectile = SRS99_AMTracerProjectile;
   raycastFromMuzzle = true;


   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = SRS99_AMItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.
   // Initial start up state
	stateName[0]                     	= "Activate";
	stateTimeoutValue[0]             	= 1.23;
	stateTransitionOnTimeout[0]       	= "LoadCheckA";
	stateSound[0]				= SRS99_AMUseSound;
	stateSequence[0]			= "use";

	stateName[1]                     	= "Ready";
	stateTransitionOnNoAmmo[1]       	= "OutPrep";
	stateTransitionOnTriggerDown[1]  	= "Fire";
	stateAllowImageChange[1]         	= true;

	stateName[2]                    	= "Fire";
	stateTransitionOnTimeout[2]     	= "Delay";
	stateTimeoutValue[2]            	= 0.40;
	stateFire[2]                    	= true;
	stateAllowImageChange[2]        	= false;
	stateSequence[2]                	= "fire";
	stateScript[2]                  	= "onFire";
	stateEjectShell[2]       	  	= true;
	stateEmitter[2]				= SRS99_AMflashEmitter;
	stateEmitterTime[2]			= 0.05;
	stateEmitterNode[2]			= "muzzleNode";
	stateWaitForTimeout[2]			= true;
	stateSound[2]				= SRS99_AM1Sound;



	stateName[3]				= "OutPrep";
	stateTimeoutValue[3]			= 0.25;
	stateTransitionOnTimeout[3]		= "Reload";
	stateSequence[3]                	= "outPrep";
	
	stateName[4]				= "InPrep";
	stateTimeoutValue[4]			= 0.2;
	stateTransitionOnTimeout[4]		= "Wait";
	stateSequence[4]                	= "inPrep";
	
	stateName[5]				= "eOutPrep";
	stateTimeoutValue[5]			= 0.5;
	stateTransitionOnTimeout[5]		= "Reload2";
	stateSequence[5]                	= "eOutPrep";
	
	stateName[6]				= "eInPrep";
	stateTimeoutValue[6]			= 0.5;
	stateTransitionOnTimeout[6]		= "Wait2";
	stateSequence[6]                	= "eInPrep";



	stateName[7]				= "Delay";
	stateTransitionOnTimeout[7]     	= "FireLoadCheckA";
	stateTimeoutValue[7]            	= 0.04;
	stateEmitter[7]				= gunSmokeEmitter;
	stateEmitterTime[7]			= 0.04;
	stateEmitterNode[7]			= "muzzleNode";
	
	stateName[8]				= "LoadCheckA";
	stateScript[8]				= "onLoadCheck";
	stateTimeoutValue[8]			= 0.01;
	stateTransitionOnTimeout[8]		= "LoadCheckB";
	
	stateName[9]				= "LoadCheckB";
	stateTransitionOnAmmo[9]		= "Ready";
	stateTransitionOnNoAmmo[9]		= "eOutPrep";

	stateName[10]				= "Reload";
	stateTimeoutValue[10]			= 0.25;
	stateScript[10]				= "onReloadStart";
	stateTransitionOnTimeout[10]		= "InPrep";
	stateWaitForTimeout[10]			= true;
	stateSequence[10]			= "clipOut";
	stateSound[10]				= SRS99_AMClipOutSound;
	
	stateName[11]				= "Wait";
	stateTimeoutValue[11]			= 0.7;
	stateSound[11]				= SRS99_AMClipInSound;
	stateScript[11]				= "onReloadWait";
	stateSequence[11]			= "clipIn";
	stateTransitionOnTimeout[11]		= "Reloaded";
	
	stateName[12]				= "FireLoadCheckA";
	stateScript[12]				= "onLoadCheck";
	stateTimeoutValue[12]			= 0.01;
	stateTransitionOnTimeout[12]		= "FireLoadCheckB";
	
	stateName[13]				= "FireLoadCheckB";
	stateTransitionOnAmmo[13]		= "Smoke";
	stateTransitionOnNoAmmo[13]		= "ReloadSmoke";
	
	stateName[14] 				= "Smoke";
	stateEmitter[14]			= gunSmokeEmitter;
	stateEmitterTime[14]			= 0.05;
	stateEmitterNode[14]			= "muzzleNode";
	stateTimeoutValue[14]			= 0.05;
	stateTransitionOnTimeout[14]		= "Ready";
	stateTransitionOnTriggerDown[14]	= "Fire";
	
	stateName[15] 				= "ReloadSmoke";
	stateEmitter[15]			= gunSmokeEmitter;
	stateEmitterTime[15]			= 0.05;
	stateEmitterNode[15]			= "muzzleNode";
	stateTimeoutValue[15]			= 0.05;
	stateTransitionOnTimeout[15]		= "eOutPrep";
	
	stateName[16]				= "Reloaded";
	stateTimeoutValue[16]			= 0.01;
	stateScript[16]				= "onReloaded";
	stateTransitionOnTimeout[16]		= "Ready";
	
		//empty reload states
	stateName[17]				= "Reload2";
	stateTimeoutValue[17]			= 0.16;
	stateScript[17]				= "onReloadStart";
	stateTransitionOnTimeout[17]		= "eInPrep";
	stateWaitForTimeout[17]			= true;
	stateSequence[17]			= "clipOut_e";
	stateSound[17]				= SRS99_AMclipOutSound;
	
	stateName[18]				= "Wait2";
	stateTimeoutValue[18]			= 0.61;
	stateSound[18]				= SRS99_AMclipIn_eSound;
	stateScript[18]				= "onReloadWait";
	stateSequence[18]			= "clipIn_e";
	stateTransitionOnTimeout[18]		= "boltBack";
	
	stateName[19]				= "Reloaded2";
	stateTimeoutValue[19]			= 0.01;
	stateScript[19]				= "onReloaded";
	stateTransitionOnTimeout[19]		= "Ready";
	
	stateName[20]				= "boltBack";
	stateTimeoutValue[20]			= 0.15;
	stateTransitionOnTimeout[20]		= "boltFore";
	stateSequence[20]                	= "boltB";
	stateSound[20]				= SRS99_AMBoltBSound;
	
	stateName[21]				= "boltFore";
	stateTimeoutValue[21]			= 0.45;
	stateTransitionOnTimeout[21]		= "Reloaded2";
	stateSequence[21]                	= "boltF";
	stateSound[21]				= SRS99_AMBoltFSound;
};

function SRS99_AMImage::onFire(%this,%obj,%slot)
{
	%projectile = SRS99_AMTracerProjectile;

	if(vectorLen(%obj.getVelocity()) < 0.1)
	{
		%spread = 0.0;
	}
	else
	{
		%spread = 0.001;
	}
	
	%obj.lastShotTime = getSimTime();
	%shellcount = 1;

	//%obj.playThread(2, plant);
	%shellcount = 1;
	%obj.toolAmmo[%obj.currTool]--;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	
	
	%projectile = "SRS99_AMMuzzleExplosionProjectile";
	
	%vector = %obj.getMuzzleVector(%slot);
	%objectVelocity = %obj.getVelocity();
	%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
	%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	
	%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
	};
	MissionCleanup.add(%p);
	
	return %p;
}


function SRS99_AMImage::onLoadCheck(%this,%obj,%slot)
{
	if(%obj.toolAmmo[%obj.currTool] <= 0)
		%obj.setImageAmmo(%slot,0);
	else
		%obj.setImageAmmo(%slot,1);
}

function SRS99_AMImage::onReloadStart(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool] = 0;
}

function SRS99_AMImage::onReloaded(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool] = 4;
	%obj.setImageAmmo(%slot,1);
}

function SRS99_AMImage::onMount(%this,%obj,%slot)
{
  %obj.hidenode("RHand");
        %obj.hidenode("LHand");
}

function SRS99_AMImage::onUnMount(%this,%obj,%slot)
{
  %obj.unhidenode("RHand");
        %obj.unhidenode("LHand");
}