datablock AudioProfile(Type25_DEPFire1Sound)
{
   filename    = "./fire1.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Type25_DEPFire2Sound)
{
   filename    = "./fire2.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Type25_DEPUseSound)
{
   filename    = "./use.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Type25_DEPChargingSound)
{
   filename    = "./chargeStart.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Type25_DEPChargeLoopSound)
{
   filename    = "./chargeLoop.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Type25_DEPChargeFireSound)
{
   filename    = "./chargedFire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Type25_DEPImpactSound)
{
   filename    = "./plasmaImpact.wav";
   description = AudioClose3d;
   preload = true;
};

//Effects
//Flash
datablock ParticleData(Type25_DEPflashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "./plasmaPistolFlash";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.5 0.5 0.5 0.9";
	colors[1]     = "0.5 0.5 0.5 0.0";
	sizes[0]      = 1.0;
	sizes[1]      = 2.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(Type25_DEPflashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 25;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "Type25_DEPflashParticle";

   uiName = "Type-25 DEP Flash";
};

datablock ParticleData(Type25_DEPchargeParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "./chargeRings";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.5 0.5 0.5 0.0";
	colors[1]     = "0.5 0.5 0.5 0.9";
	colors[2]     = "0.5 0.5 0.5 0.0";
	sizes[0]      = 3.0;
	sizes[1]      = 2.0;
	sizes[2]      = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(Type25_DEPchargeEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 25;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "Type25_DEPflashParticle";

   uiName = "Type-25 DEP Charge Rings";
};

//Cooling Steam
datablock ParticleData(Type25_DEPPlasmaSteamParticle)
{
	dragCoefficient      = 4;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 525;
	lifetimeVarianceMS   = 55;
	textureName          = "./combinedSmoke";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.0 0.5 0.1 0.9";
	colors[1]     = "0.0 0.5 0.1 0.0";
	sizes[0]      = 0.15;
	sizes[1]      = 0.15;

	useInvAlpha = false;
};
datablock ParticleEmitterData(Type25_DEPPlasmaSteamEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "Type25_DEPPlasmaSteamParticle";

   uiName = "Type-25 DEP Vent Steam";
};

datablock ParticleData(Type25_DEPExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 50;
	lifetimeVarianceMS   = 35;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 500.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.0 0.5 0.1 0.9";
	colors[1]     = "0.0 0.5 0.1 0.0";
	sizes[0]      = 2;
	sizes[1]      = 0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(Type25_DEPExplosionRingEmitter)
{
	lifeTimeMS = 50;

   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "Type25_DEPExplosionRingParticle";

   useEmitterColors = true;
   uiName = "Type-25 DEP Plasma Impact";
};



datablock ExplosionData(plasmaPExplosion)
{
   //explosionShape = "";
	soundProfile = Type25_DEPImpactSound;

   lifeTimeMS = 150;

   particleEmitter = Type25_DEPExplosionRingEmitter;
   particleDensity = 5;
   particleRadius = 0.2;

   emitter[0] = Type25_DEPExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 2;
   lightStartColor = "0.0 0.6 0.7";
   lightEndColor = "0 0 0";
};



AddDamageType("Type25_DEP",   '<bitmap:add-ons/Weapon_The_New_Halo_Pack/Type25_DEP/CI_Type25_DEP> %1',    '%2 <bitmap:add-ons/Weapon_The_New_Halo_Pack/Type25_DEP/CI_Type25_DEP> %1',0.2,1);
datablock ProjectileData(Type25_DEPProjectile)
{
   projectileShapeName = "./plasmaBolt.dts";
   directDamage        = 35;
   directDamageType    = $DamageType::Type25_DEP;
   radiusDamageType    = $DamageType::Type25_DEP;

   brickExplosionRadius = 2;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 2;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 20;
   verticalImpulse	  = 0;
   explosion           = plasmaPExplosion;

   muzzleVelocity      = 170;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = true;
   gravityMod = 0.2;

   hasLight    = true;
   lightRadius = 5.0;
   lightColor  = "0 0.5 0";

   uiName = "Type-25 DEP Pulse";
};

//////////
// item //
//////////
datablock ItemData(Type25_DEPItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Type25_DEP_Ground.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Type-25 DEP";
	iconName = "./UI_Type25_DEP";
	doColorShift = true;
	colorShiftColor = "0.5 0.5 0.5 1.000";

	 // Dynamic properties defined by the scripts
	image = Type25_DEPImage;
	canDrop = true;

	maxAmmo = 15;
	canReload = 1;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(Type25_DEPImage)
{
   // Basic Item properties
   shapeFile = "./Type25_DEP.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset =  "0.45 0.9 -0.34"; //"0.45 1.3 -0.4"; -Left +Right, -Back +Front, -Down +Up
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = Type25_DEPItem;
   ammo = " ";
   projectile = Type25_DEPProjectile;
   projectileType = Projectile;

	casing = Type25_DEPCasing;
	shellExitDir        = "2.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 25.0;	
	shellVelocity       = 10.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = Type25_DEPItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.
   // Initial start up state
	stateName[0]                     	= "Activate";
	stateTimeoutValue[0]             	= 0.53;
	stateTransitionOnTimeout[0]       	= "Smoke";
	stateSound[0]				= Type25_DEPUseSound;
	stateSequence[0]			= "use";

	stateName[1]                     	= "Ready";
	stateTransitionOnNoAmmo[1]       	= "Reload";
	stateTransitionOnTriggerDown[1]  	= "preFire";
	stateAllowImageChange[1]         	= true;
	//stateTimeoutValue[1]             	= 0.00;
	//stateTransitionOnTimeout[1]       	= "cooling";
	
	stateName[31]                     	= "cooling";
	stateTransitionOnTimeout[31]       	= "Ready";
	stateScript[31]                  = "onCool";
	stateAllowImageChange[31]         	= true;
	
	stateName[30]                    	= "chargeCheck";
	//stateTransitionOnTriggerUp[30]     	= "preFire";
	stateTransitionOnTriggerDown[30]  	= "charge1";

	stateName[19]="preFire";
	stateTimeoutValue[19]=0;
	stateTransitionOnTimeout[19]="preFire2";
	stateScript[19]                  = "onFire";
	stateEmitter[19]					= Type25_DEPFlashEmitter;
	stateEmitterTime[19]				= 0.01;
	stateEmitterNode[19]				= "muzzleNode";
	stateFire[19]                    = true;
	
	stateName[21]="preFire2";
	stateTransitionOnTimeout[21]="Fire";
	stateScript[21]				= "onLoadCheck";
	
	stateName[18]="Ready2";
	stateTransitionOnTriggerUp[18]="Ready";
	
	stateName[2]                    	= "Fire";
	stateTransitionOnTimeout[2]     	= "Delay";
	stateTimeoutValue[2]            	= 0.00;
	stateAllowImageChange[2]        	= false;
	stateSequence[2]                	= "fire";
	stateWaitForTimeout[2]			= true;
	//stateSound[2]				= Type25_DEPFireSound;
	
	stateName[3]				= "Delay";
	stateTransitionOnTimeout[3]     	= "Smoke";
	stateTimeoutValue[3]            	= 0.17;
	
	stateName[8]				= "LoadCheckA";
	stateScript[8]				= "onLoadCheck";
	stateTimeoutValue[8]			= 0.01;
	stateTransitionOnTimeout[8]		= "LoadCheckB";
	
	stateName[9]				= "LoadCheckB";
	stateTransitionOnAmmo[9]		= "Ready2";
	stateTransitionOnNoAmmo[9]		= "Reload";

	stateName[10]				= "Reload";
	stateTimeoutValue[10]			= 0.66;
	stateScript[10]				= "onReloadStart";
	stateTransitionOnTimeout[10]		= "Wait";
	stateWaitForTimeout[10]			= true;
	//stateSequence[10]			= "clipOut";
	//stateSound[10]				= Type25_DEPclipOutSound;
	
	stateName[11]				= "Wait";
	stateTimeoutValue[11]			= 0.61;
	//stateSound[11]				= Type25_DEPclipInSound;
	stateScript[11]				= "onReloadWait";
	//stateSequence[11]			= "clipIn";
	stateTransitionOnTimeout[11]		= "Reloaded";
	
	stateName[12]				= "FireLoadCheckA";
	stateScript[12]				= "onLoadCheck";
	stateTimeoutValue[12]			= 0.01;
	stateTransitionOnTimeout[12]		= "FireLoadCheckB";
	
	stateName[13]				= "FireLoadCheckB";
	stateTransitionOnAmmo[13]		= "Smoke";
	stateTransitionOnNoAmmo[13]		= "ReloadSmoke";
	
	stateName[14] 				= "Smoke";
	stateTransitionOnTriggerUp[14]		= "Ready";
	//stateTransitionOnTriggerDown[14]	= "preFire";

	stateName[15] 				= "ReloadSmoke";
	stateTimeoutValue[15]			= 0.2;
	stateTransitionOnTimeout[15]		= "Reload";
	
	stateName[22]				= "Reloaded";
	stateTimeoutValue[22]			= 0.01;
	stateScript[22]				= "onReloaded";
	stateTransitionOnTimeout[22]		= "Ready";
	
	
	
	//overcharge states
	
	stateName[23]                    = "Charge1";
	stateTransitionOnTimeout[23]     = "TriggerChargeCheck1";
	stateTimeoutValue[23]            = 0.68;
	stateFire[23]                    = true;
	stateAllowImageChange[23]        = false;
	stateSequence[23]                = "charge1";
	stateWaitForTimeout[23]			= true;
	stateEmitter[23]					= Type25_DEPChargeEmitter;
	stateEmitterTime[23]				= 0.68;
	stateEmitterNode[23]				= "muzzleNode";
	stateSound[23]					= Type25_DEPCharge1Sound;
	stateScript[23] = "onCharge";

	stateName[24]                    = "Charge2";
	stateTransitionOnTimeout[24]     = "TriggerChargeCheck2";
	stateTimeoutValue[24]            = 0.68;
	stateAllowImageChange[24]        = false;
	stateSequence[24]                = "charge2";
	stateWaitForTimeout[24]			= true;
	stateEmitter[24]					= Type25_DEPChargeEmitter;
	stateEmitterTime[24]				= 0.68;
	stateEmitterNode[24]				= "muzzleNode";
	stateSound[24]					= Type25_DEPCharge2Sound;
	stateScript[24] = "onCharge";

	stateName[25]                    = "TriggerChargeCheck1";
	stateTransitionOnTimeout[25]     = "Ready";
	stateTransitionOnTriggerDown[25]  	= "Charge2";
	stateWaitForTimeout[25]			= false;

	stateName[26]                    = "TriggerChargeCheck2";
	stateTransitionOnTimeout[26]     = "Ready";
	stateTransitionOnTriggerDown[26]  	= "Charge3";
	stateWaitForTimeout[26]			= false;
	
	
	
	
	stateName[23]="charge1";
	stateTimeoutValue[23]=0.5;
	stateTransitionOnTriggerDown[23]="charge2";
	stateTransitionOnTriggerUp[23]  	= "preFire";
	stateEmitter[23]					= Type25_DEPchargeEmitter;
	stateEmitterTime[23]				= 0.05;
	stateEmitterNode[23]				= "muzzleNode";
	stateSound[23]				= Type25_DEPChargingSound;
	stateSequence[23]			= "charge1";
	
	stateName[24]="charge2";
	stateTimeoutValue[24]=0.5;
	stateTransitionOnTriggerDown[24]="chargeLoop";
	stateTransitionOnTriggerUp[24]  	= "preFire";
	stateEmitter[24]					= Type25_DEPchargeEmitter;
	stateEmitterTime[24]				= 0.05;
	stateEmitterNode[24]				= "muzzleNode";
	stateSound[24]				= Type25_DEPChargeLoopSound;
	stateSequence[24]			= "charge2";
	stateWaitForTimeout[24]			= true;
	
	stateName[25]="chargeLoop";
	stateTimeoutValue[25]=1;
	stateTransitionOnTriggerDown[25]="chargeLoopRelay";
	stateTransitionOnTriggerUp[25]  	= "preChargedFire";
	stateEmitter[25]					= Type25_DEPFlashEmitter;
	stateEmitterTime[25]				= 0.05;
	stateEmitterNode[25]				= "muzzleNode";
	stateSound[25]				= Type25_DEPChargeLoopSound;
	stateSequence[25]			= "overChargeLoop";
	stateWaitForTimeout[25]			= true;
	
	stateName[26]="chargeLoopRelay";
	stateTransitionOnTimeout[26]="chargeLoop";
	
	stateName[27]="preChargedFire";
	stateTimeoutValue[27]=0;
	stateTransitionOnTimeout[27]="preChargedFire2";
	stateScript[27]                  = "onFire";
	stateEmitter[27]					= Type25_DEPFlashEmitter;
	stateEmitterTime[27]				= 0.05;
	stateEmitterNode[27]				= "muzzleNode";
	stateFire[27]                    = true;
	
	stateName[28]="preChargedFire2";
	stateTransitionOnTimeout[28]="chargedFire";
	stateScript[28]				= "onLoadCheck";
	
	stateName[29]                    	= "chargedFire";
	stateTransitionOnTimeout[29]     	= "Delay";
	stateTimeoutValue[29]            	= 2.00;
	stateAllowImageChange[29]        	= false;
	stateSequence[29]                	= "burstFire";
	stateWaitForTimeout[29]			= true;
	stateSound[29]				= Type25_DEPChargeFireSound;
	
};

function Type25_DEPImage::onFire(%this,%obj,%slot)
{

      %pos = %obj.getTransform();
   %random = getRandom(1,2);
   switch(%random)
   {
      case 1:
         serverplay3d(Type25_DEPFire1Sound,%pos);
      case 2:
         serverplay3d(Type25_DEPFire2Sound,%pos);
      default:
         echo("Error on Type25_DEP");
   }

	%obj.toolAmmo[%obj.currTool]--;
	%obj.AmmoSpent[%obj.currTool]++;

			commandToClient(%obj.client,'bottomPrint',"<just:right><font:ds-digital:64><color:4577ab>" @ %obj.toolAmmo[%obj.currTool] @ "<font:ds-digital:24><color:004080> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
	Parent::onFire(%this,%obj,%slot);
	
}

//function Type25_DEPImage::onCool(%this,%obj,%slot)
//{
//			commandToClient(%obj.client,'bottomPrint',"<just:right><font:ds-digital:64><color:4577ab>" @ %obj.toolAmmo[%obj.currTool] @ "<font:ds-digital:24><color:004080> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
//			if(%obj.toolAmmo[%obj.currTool] <= 0)
//				%obj.toolAmmo[%obj.currTool]++;
//}

function Type25_DEPImage::onReloadWait(%this,%obj,%slot)
{
			commandToClient(%obj.client,'bottomPrint',"<just:right><font:ds-digital:64><color:4577ab>" @ %obj.toolAmmo[%obj.currTool] @ "<font:ds-digital:24><color:004080> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
}

function Type25_DEPImage::onLoadCheck(%this,%obj,%slot)
{
	if(%obj.toolAmmo[%obj.currTool] <= 0)
		%obj.setImageAmmo(%slot,0);
	else
		%obj.setImageAmmo(%slot,1);
}

function Type25_DEPImage::onReloadStart(%this,%obj,%slot)
{
				commandToClient(%obj.client,'bottomPrint',"<just:right><font:ds-digital:64><color:4577ab>" @ %obj.toolAmmo[%obj.currTool] @ "<font:ds-digital:24><color:004080> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
}

function Type25_DEPImage::onReloaded(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool] = %this.item.maxAmmo;
	%obj.AmmoSpent[%obj.currTool] = 0;
	%obj.setImageAmmo(%slot,1);
			commandToClient(%obj.client,'bottomPrint',"<just:right><font:ds-digital:64><color:4577ab>" @ %obj.toolAmmo[%obj.currTool] @ "<font:ds-digital:24><color:004080> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
	return;
}


function Type25_DEPImage::onMount(%this,%obj,%slot)
{
  
  %obj.hidenode("RHand");
        %obj.hidenode("LHand");
		   Parent::onMount(%this,%obj,%slot);
					commandToClient(%obj.client,'bottomPrint',"<just:right><font:ds-digital:64><color:4577ab>" @ %obj.toolAmmo[%obj.currTool] @ "<font:ds-digital:24><color:004080> " @ %this.item.maxAmmo @ "", 1,2,3,4); 

}

function Type25_DEPImage::onUnMount(%this,%obj,%slot)
{
  
  %obj.unhidenode("RHand");
        %obj.unhidenode("LHand");
			%obj.playThread(2, root);
}
