datablock AudioProfile(Type25DERFire1Sound)
{
   filename    = "./fire1.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Type25DERFire2Sound)
{
   filename    = "./fire2.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Type25DERFire3Sound)
{
   filename    = "./fire3.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Type25DERUseSound)
{
   filename    = "./use.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Type25DERCoolSound)
{
   filename    = "./cool.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Type25DERImpactSound)
{
   filename    = "./plasmaImpact.wav";
   description = AudioClose3d;
   preload = true;
};

//Effects
//Flash
datablock ParticleData(Type25DERflashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 1 1 1";
	colors[1]     = "0.0 0.25 0.5 0.9";
	colors[2]     = "0.0 0.25 0.5 0.5";
	colors[3]     = "0.0 0.05 0.35 0.2";
	sizes[0]      = 1.0;
	sizes[1]      = 2.0;
	sizes[2]      = 3.0;
	sizes[3]      = 4.0;
	times[0]      = 0.25;
	times[1]      = 0.50;
	times[2]      = 0.75;
	times[3]      = 1;

	useInvAlpha = false;
};
datablock ParticleEmitterData(Type25DERflashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 25;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "Type25DERflashParticle";

   uiName = "Type-25 DER Flash";
};

//Cooling Steam
datablock ParticleData(plasmaSteamParticle)
{
	dragCoefficient      = 4;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 525;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.0 0.1 0.5 0.9";
	colors[1]     = "0.0 0.1 0.5 0.0";
	sizes[0]      = 0.15;
	sizes[1]      = 0.15;

	useInvAlpha = false;
};
datablock ParticleEmitterData(plasmaSteamEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "Type25DERSteamParticle";

   uiName = "Type-25 DER Vent Steam";
};

datablock ParticleData(Type25DERExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 50;
	lifetimeVarianceMS   = 35;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 500.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0 0.5 0.1 0.9";
	colors[1]     = "0.0 0.5 0.1 0.0";
	sizes[0]      = 2;
	sizes[1]      = 0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(Type25DERExplosionRingEmitter)
{
	lifeTimeMS = 50;

   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "Type25DERExplosionRingParticle";

   useEmitterColors = true;
   uiName = "Type-25 DER Plasma Impact";
};



datablock ExplosionData(plasmaExplosion)
{
   //explosionShape = "";
	soundProfile = Type25DERImpactSound;

   lifeTimeMS = 150;

   particleEmitter = Type25DERExplosionRingEmitter;
   particleDensity = 5;
   particleRadius = 0.2;

   emitter[0] = Type25DERExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 2;
   lightStartColor = "0.0 0.6 0.7";
   lightEndColor = "0 0 0";
};

AddDamageType("Type-25 DER Plasma",   '<bitmap:add-ons/Weapon_Type25DER/CI_Type25DER> %1',    '%2 <bitmap:add-ons/Weapon_Type25DER/CI_Type25DER> %1',0.2,1);
datablock ProjectileData(Type25DERProjectile)
{
   projectileShapeName = "./energyPulse.dts";
   directDamage        = 25;
   directDamageType    = $DamageType::Type25DER;
   radiusDamageType    = $DamageType::Type25DER;

   brickExplosionRadius = 2;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 1;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 25;
   verticalImpulse	  = 0;
   explosion           = plasmaExplosion;

   muzzleVelocity      = 175;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 0.2;

   hasLight    = true;
   lightRadius = 5.0;
   lightColor  = "0.0 0.2 0.5";

   uiName = "Type-25 DER Energy Pulse";
};

//////////
// item //
//////////
datablock ItemData(Type25DERItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Type25DER_Ground.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Type-25 Directed Energy Rifle";
	iconName = "./UI_Type25DER";
	doColorShift = true;
	colorShiftColor = "0.5 0.5 0.5 1.000";

	 // Dynamic properties defined by the scripts
	image = Type25DERImage;
	canDrop = true;

	maxAmmo = 20;
	canReload = 1;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(Type25DERImage)
{
   // Basic Item properties
   shapeFile = "./Type25DER.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5"; -Left +Right, -Back +Front, -Down +Up
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = Type25DERItem;
   ammo = " ";
   projectile = Type25DERProjectile;
   projectileType = Projectile;

	casing = Type25DERCasing;
	shellExitDir        = "2.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 25.0;	
	shellVelocity       = 10.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = Type25DERItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.
   // Initial start up state

//Weapon States
	stateName[0]                     	= "Activate";
	stateTimeoutValue[0]             	= 0.73;
	stateTransitionOnTimeout[0]       	= "Ready";
	stateScript[0] = onReady;
	stateSound[0]				= Type25DERUseSound;
	stateScript[0]                  	= "onCooloff";
	stateSequence[0]			= "use";

	stateName[1]                     	= "Ready";
	stateTransitionOnNoAmmo[1]       	= "Cool";
	stateTransitionOnTriggerDown[1]  	= "Fire";
	stateAllowImageChange[1]         	= true;

	stateName[2]                    	= "Fire";
	stateTransitionOnTimeout[2]     	= "Delay1";
	stateTimeoutValue[2]            	= 0.06;
	stateFire[2]                    	= true;
	stateAllowImageChange[2]        	= false;
	stateSequence[2]                	= "fire1";
	stateScript[2]                  	= "onFire";
	stateEjectShell[2]       	  	= true;
	stateEmitter[2]				= Type25DERFlashEmitter;
	stateEmitterTime[2]			= 0.01;
	stateEmitterNode[2]			= "muzzleNode";
	stateWaitForTimeout[2]			= true;

	stateName[3]				= "Delay1";
	stateTransitionOnTimeout[3]     	= "Fire2";
	stateTimeoutValue[3]            	= 0.01;

	stateName[4]                    	= "Fire2";
	stateTransitionOnTimeout[4]     	= "Delay2";
	stateTimeoutValue[4]            	= 0.06;
	stateFire[4]                    	= true;
	stateAllowImageChange[4]        	= false;
	stateSequence[4]                	= "fire2";
	stateScript[4]                  	= "onFire";
	stateEjectShell[4]       	  	= true;
	stateEmitter[4]				= Type25DERFlashEmitter;
	stateEmitterTime[4]			= 0.01;
	stateEmitterNode[4]			= "muzzleNode";
	stateWaitForTimeout[4]			= true;

	stateName[5]				= "Delay2";
	stateTransitionOnTimeout[5]     	= "heatCheck";
	stateTimeoutValue[5]            	= 0.01;

	stateName[6]				= "heatCheck";
	stateTimeoutValue[6]			= 0.01;
	//stateScript[6]                  	= "HeatCheck";
	stateTransitionOnTimeout[6]		= "Finish";
	stateTransitionOnNoAmmo[6]       	= "Cool";

	stateName[7]			= "Finish";
	stateTransitionOnTimeout[7]     = "Ready";
	stateTimeoutValue[7]            = 0.00001;

	stateName[8]				= "Vent";
	stateTimeoutValue[8]			= 0;
	stateTransitionOnTimeout[8]		= "Cool";
	stateWaitForTimeout[8]			= false;
	stateEmitter[8]			= plasmaSteamEmitter;
	stateEmitterTime[8]			= 0.95;
	stateEmitterNode[8]			= "lVentCover";

	stateName[9]				= "Cool";
	stateTimeoutValue[9]			= 1.5;
	stateTransitionOnTimeout[9]		= "Ready";
	stateWaitForTimeout[9]			= true;
	stateSequence[9]			= "overHeat";
	stateSound[9]				= Type25DERCoolSound;
	stateEmitter[9]			= plasmaSteamEmitter;
	stateEmitterTime[9]			= 0.95;
	stateEmitterNode[9]			= "rVentCover";
	stateScript[9]    = "onCooloff";
};

function Type25DERImage::onCooloff(%this,%obj,%slot)
{

%obj.toolAmmo[%obj.currTool] = 20;

}



//Weapon Functions

function Type25DERImage::onFire(%this,%obj,%slot)
{

   %pos = %obj.getTransform();
   %random = getRandom(1,3);
   switch(%random)
   {
      case 1:
         serverplay3d(Type25DERFire1Sound,%pos);
      case 2:
         serverplay3d(Type25DERFire2Sound,%pos);
      case 3:
         serverplay3d(Type25DERFire3Sound,%pos);
      default:
         echo("Error on Plasma Rifle");
   }


	%projectile = Type25DERProjectile;

	if(vectorLen(%obj.getVelocity()) < 0.1)
	{
		%spread = 0.006;
	}
	else
	{
		%spread = 0.005;
	}
	
	%obj.lastShotTime = getSimTime();
	%shellcount = 1;

	%shellcount = 1;
	%obj.toolAmmo[%obj.currTool]--;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}

function Type25DERImage::onMount(%this,%obj,%slot)
{

  %obj.hidenode("RHand");
        %obj.hidenode("LHand");
}

function Type25DERImage::onUnMount(%this,%obj,%slot)
{

  %obj.unhidenode("RHand");
        %obj.unhidenode("LHand");
}

