datablock AudioProfile(Type25DERFire1Sound)
{
   filename    = "./fire1.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Type25DERFire2Sound)
{
   filename    = "./fire2.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Type25DERFire3Sound)
{
   filename    = "./fire3.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Type25DERUseSound)
{
   filename    = "./use.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Type25DERCoolSound)
{
   filename    = "./cool.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Type25DERImpactSound)
{
   filename    = "./plasmaImpact.wav";
   description = AudioClose3d;
   preload = true;
};

//Effects
//Flash
datablock ParticleData(Type25DERflashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 1 1 1";
	colors[1]     = "0.0 0.25 0.5 0.9";
	colors[2]     = "0.0 0.25 0.5 0.5";
	colors[3]     = "0.0 0.05 0.35 0.2";
	sizes[0]      = 0.2;
	sizes[1]      = 0.5;
	sizes[2]      = 0.7;
	sizes[3]      = 1.0;
	times[0]      = 0.25;
	times[1]      = 0.50;
	times[2]      = 0.75;
	times[3]      = 1;

	useInvAlpha = false;
};
datablock ParticleEmitterData(Type25DERflashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 25;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "Type25DERflashParticle";

   uiName = "Type-25 DER Flash";
};

//Cooling Steam
datablock ParticleData(Type25DERPlasmaSteamParticle)
{
	dragCoefficient      = 4;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 525;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.0 0.1 0.5 0.9";
	colors[1]     = "0.0 0.1 0.5 0.0";
	sizes[0]      = 0.15;
	sizes[1]      = 0.15;

	useInvAlpha = false;
};
datablock ParticleEmitterData(Type25DERPlasmaSteamEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "Type25DERPlasmaSteamParticle";

   uiName = "Type-25 DER Vent Steam";
};

datablock ParticleData(Type25DERExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 50;
	lifetimeVarianceMS   = 35;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 500.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.0 0.1 0.5 0.9";
	colors[1]     = "0.0 0.1 0.5 0.0";
	sizes[0]      = 2;
	sizes[1]      = 0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(Type25DERExplosionRingEmitter)
{
	lifeTimeMS = 50;

   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "Type25DERExplosionRingParticle";

   useEmitterColors = true;
   uiName = "Type-25 DER Plasma Impact";
};



datablock ExplosionData(plasmaExplosion)
{
   //explosionShape = "";
	soundProfile = Type25DERImpactSound;

   lifeTimeMS = 150;

   particleEmitter = Type25DERExplosionRingEmitter;
   particleDensity = 5;
   particleRadius = 0.2;

   emitter[0] = Type25DERExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 2;
   lightStartColor = "0.0 0.6 0.7";
   lightEndColor = "0 0 0";
};

AddDamageType("Type-25 DER Plasma",   '<bitmap:add-ons/Weapon_Type-25_DER/CI_Type25DER> %1',    '%2 <bitmap:add-ons/Weapon_Type-25_DER/CI_Type25DER> %1',0.2,1);
datablock ProjectileData(Type25DERProjectile)
{
   projectileShapeName = "./energyPulse.dts";
   directDamage        = 25;
   directDamageType    = $DamageType::Type25DER;
   radiusDamageType    = $DamageType::Type25DER;

   brickExplosionRadius = 2;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 1;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 25;
   verticalImpulse	  = 0;
   explosion           = plasmaExplosion;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 0;

   hasLight    = true;
   lightRadius = 5.0;
   lightColor  = "0.0 0.2 0.5";

   uiName = "Type-25 DER Energy Pulse";
};

//////////
// item //
//////////
datablock ItemData(Type25DERItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Type25DER_Ground.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Type-25 Directed Energy Rifle";
	iconName = "./UI_Type25DER";
	doColorShift = true;
	colorShiftColor = "0.5 0.5 0.5 1.000";

	 // Dynamic properties defined by the scripts
	image = Type25DERImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(Type25DERImage)
{
   // Basic Item properties
   shapeFile = "./Type25DER.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = Type25DERItem;
   ammo = " ";
   projectile = Type25DERProjectile;
   projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = false;
   colorShiftColor = Type25DERItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.53;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= Type25DERUseSound;
	stateSequence[0]        = "use";

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire1";
	stateTransitionOnTriggerUp[1]     = "Cooldown";
	stateAllowImageChange[1]         = true;

	stateName[2]                    	= "Fire1";
	stateTransitionOnTimeout[2]     	= "Delay1";
	stateTimeoutValue[2]            	= 0.2;
	stateFire[2]                    	= true;
	stateAllowImageChange[2]        	= false;
	stateSequence[2]                	= "fire1";
	stateScript[2]                  	= "onFire";
	stateEjectShell[2]       	  	= false;
	stateEmitter[2]				= Type25DERFlashEmitter;
	stateEmitterTime[2]			= 0.05;
	stateEmitterNode[2]			= "muzzleNode";
	stateWaitForTimeout[2]			= true;

	stateName[7]				= "Delay1";
	stateTimeoutValue[7]            	= 0.5;
	//stateEmitter[7]				= gunSmokeEmitter;
	//stateEmitterTime[7]			= 0.07;
	//stateEmitterNode[7]			= "muzzleNode";
	stateTransitionOnTimeout[2]     	= "Fire2";
	stateWaitForTimeout[2]			= true;
	
	//Nonexistant smoke
	stateName[3] = "Smoke";
	//stateEmitter[3]					= Type25DERSmokeEmitter;
	//stateEmitterTime[3]				= 0.05;
	//stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]            = 0.01;
	stateTransitionOnTimeout[3]     = "Reload";

	stateName[4]			= "Reload";
	stateSequence[4]                = "Reload";
	stateTransitionOnTriggerUp[4]     = "Ready";
	stateTransitionOnTriggerDown[4]     = "Ready";
	stateSequence[4]	= "Ready";
	
	stateName[5] = "Cooldown";
	stateTimeoutValue[5]            = 0.05;
	stateTransitionOnTimeout[5]     = "Ready";
	stateScript[5]                  = "Cooldown";
	
	stateName[17]                    	= "Fire2";
	stateTransitionOnTimeout[17]     	= "Delay2";
	stateTimeoutValue[17]            	= 0.2;
	stateFire[17]                    	= true;
	stateAllowImageChange[17]        	= false;
	stateSequence[17]                	= "fire2";
	stateScript[17]                  	= "onFire";
	stateEjectShell[17]       	  	= false;
	stateEmitter[17]				= Type25DERFlashEmitter;
	stateEmitterTime[17]			= 0.02;
	stateEmitterNode[17]			= "muzzleNode";
	stateWaitForTimeout[17]			= true;
	
	stateName[18]				= "Delay2";
	stateTimeoutValue[18]            	= 0.001;
	stateWaitForTimeout[18]			= true;
	stateTransitionOnTimeout[18]     	= "Ready";
	


};

function Type25DERImage::onFire(%this,%obj,%slot)
{
   %pos = %obj.getTransform();
   %random = getRandom(1,3);
   switch(%random)
   {
      case 1:
         serverplay3d(Type25DERFire1Sound,%pos);
      case 2:
         serverplay3d(Type25DERFire2Sound,%pos);
      case 3:
         serverplay3d(Type25DERFire3Sound,%pos);
      default:
         echo("Error on Type-25 DER");
   }
   
   	if(isObject(%obj.client))
	{
		%per = mCeil(%obj.heat);
		%maxcounters = 20;
		%foo = %maxcounters - %per;
		%char = ")";for(%a =0; %a<%per; %a++){%fchar = %char @ %fchar;}
		%char2 = ")";for(%b =0; %b<%foo; %b++){%ftchar = %char2 @ %ftchar;}
		bottomPrint(%obj.client,"<just:center><color:5d00c1>Core Heat <color:FFFFFF>:" @ (%obj.heat >= 20 ? "<color:ff0000>" : "<color:008cff>") @ %fchar @ "<color:360000>" @ %ftchar,1,1);
	}



		
	//New Code that applies dynamic spread depending on how much is your fire rate. 
	//Little ticks give you a more accurate shot, spraying gives the traditional spread.
	
	%projectile = %this.projectile;
	%spread = 0.00075 * (%obj.heat * 0.1);
	%shellcount = 1;
	
	%obj.maxHeat = 20;
	
	if(%obj.heat < %obj.maxHeat)
		%obj.heat += 1;
		

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}

//Smooth cooldown intended
function Type25DERImage::Cooldown(%this,%obj,%slot)
{
	if (%obj.heat > 0)
	{
	%obj.heat -= %obj.maxHeat*0.05;
	}
	
	if(isObject(%obj.client))
	{
		%per = mCeil(%obj.heat);
		%maxcounters = 20;
		%foo = %maxcounters - %per;
		%char = ")";for(%a =0; %a<%per; %a++){%fchar = %char @ %fchar;}
		%char2 = ")";for(%b =0; %b<%foo; %b++){%ftchar = %char2 @ %ftchar;}
		bottomPrint(%obj.client,"<just:center><color:5d00c1>Core Heat <color:FFFFFF>:<color:008cff>" @ %fchar @ "<color:172835>" @ %ftchar,1,1);
	}

}


function Type25DERImage::onMount(%this,%obj,%slot)
{

  %obj.hidenode("RHand");
        %obj.hidenode("LHand");
}

function Type25DERImage::onUnMount(%this,%obj,%slot)
{

  %obj.unhidenode("RHand");
        %obj.unhidenode("LHand");
}
