datablock AudioProfile(Type25_GLFire1Sound)
{
   filename    = "./fire1.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Type25_GLFire2Sound)
{
   filename    = "./fire2.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Type25_GLFire3Sound)
{
   filename    = "./fire3.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Type25_GLFire4Sound)
{
   filename    = "./fire4.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Type25_GLclipIn1Sound)
{
   filename    = "./clipIn.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Type25_GLclipOut1Sound)
{
   filename    = "./clipOut.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Type25_GLclipIn2Sound)
{
   filename    = "./clipIn2.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Type25_GLclipOut2Sound)
{
   filename    = "./clipOut2.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Type25_GLUse1Sound)
{
   filename    = "./use.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Type25_GLUse2Sound)
{
   filename    = "./use2.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Type25_GLImpactSound)
{
   filename    = "./impact.wav";
   description = AudioClose3d;
   preload = true;
};

//Effects
//Flash
datablock ParticleData(Type25_GLflashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "./bsFlash";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 1 1 1";
	colors[1]     = "1 1 1 0";
	sizes[0]      = 1.0;
	sizes[1]      = 2.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(Type25_GLflashEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 25;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "Type25_GLflashParticle";

   uiName = "Type-25 GL Brute Shot Flash";
};

//POOF Sparks
datablock ParticleData(Type25_GLExplosionChunkParticle)
{
   dragCoefficient      = 2;
   gravityCoefficient   = 2;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 2400;
   lifetimeVarianceMS   = 1300;
   textureName          = "./muzzleSpark";
   spinSpeed		= 5.0;
   spinRandomMin		= -500.0;
   spinRandomMax		= 500.0;
   colors[0]     = "1 1 1 1";
   colors[1]     = "0.6 0.6 0.6 0.2";
   sizes[0]      = 0.05;
   sizes[1]      = 0;
   times[0]		= 0;
   times[1]		= 1;
 
   useInvAlpha = true;
};
datablock ParticleEmitterData(Type25_GLExplosionChunkEmitter)
{
   lifeTimeMS = 25;

   ejectionPeriodMS = 50;
   periodVarianceMS = 10;
   ejectionVelocity = 5;
   velocityVariance = 0.0;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "Type25_GLExplosionChunkParticle";
};

datablock DebrisData(Type25_GLDebris)
{
   emitters = "Type25_GLExplosionChunkEmitter";

	shapeFile = "./empty.dts";
	lifetime = 2.0;
	minSpinSpeed = -500.0;
	maxSpinSpeed = 400.0;
	elasticity = 0.5;
	friction = 0.05;
	numBounces = 5;
	staticOnMaxBounce = false;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};

datablock ExplosionData(Type25_GLMuzzleExplosion)
{

   debris = Type25_GLDebris;
   debrisNum = 5;
   debrisNumVariance = 0;
   debrisPhiMin = 0;
   debrisPhiMax = 360;
   debrisThetaMin = 0;
   debrisThetaMax = 180;
   debrisVelocity = 10;
   debrisVelocityVariance = 10;
   lifeTimeMS = 250;

   //particleEmitter = Type25_GLExplosionChunkEmitter;
   //particleDensity = 5;
   //particleRadius = 0.2;
   
   //emitter[0] = Type25_GLExplosionChunkEmitter;
   //emitter[1] = Type25_GLExplosionChunkEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "5.0 6.0 5.0";
   camShakeAmp = "2.0 6.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 5.0;

   // Dynamic light
   lightStartRadius = 10;
   lightEndRadius = 1;
   lightStartColor = "0.5 0.5 0 1";
   lightEndColor = "0.3 0.1 0.0 1";

   damageRadius = 0;
   radiusDamage = 0;

   impulseRadius = 0;
   impulseForce = 0;
};


datablock ParticleData(Type25_GLExplosionParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 700;
	lifetimeVarianceMS   = 400;
	textureName          = "./combinedSmoke";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.9 0.9 0.9 0.9";
	colors[1]     = "0.5 0.5 0.5 0.0";
	sizes[0]      = 10.0;
	sizes[1]      = 15.0;

	useInvAlpha = true;
};
datablock ParticleEmitterData(Type25_GLExplosionEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 10;
   velocityVariance = 1.0;
   ejectionOffset   = 3.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "Type25_GLExplosionParticle";

   uiName = "Type-25 GL Brute Shot Smoke";
   emitterNode = TenthEmitterNode;
};


datablock ParticleData(Type25_GLExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 10;
	textureName          = "./plasmaRing";
	spinSpeed		= 10.0;
	spinRandomMin		= -100.0;
	spinRandomMax		= 100.0;
	colors[0]     = "1 1 1 0.9";
	colors[1]     = "0.9 0.9 0.9 0.0";
	sizes[0]      = 0;
	sizes[1]      = 15;

	useInvAlpha = false;
};
datablock ParticleEmitterData(Type25_GLExplosionRingEmitter)
{
	lifeTimeMS = 1000;

   ejectionPeriodMS = 100;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 0.0;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "Type25_GLExplosionRingParticle";

   uiName = "Type-25 GL Brute Shot Arcs";
};

datablock ParticleData(Type25_GLExplosionCenterParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 100;
	lifetimeVarianceMS   = 10;
	textureName          = "./impactFlash";
	spinSpeed		= 10.0;
	spinRandomMin		= -250.0;
	spinRandomMax		= 250.0;
	colors[0]     = "1 1 1 1";
	colors[1]     = "0.9 0.9 0.9 0.0";
	sizes[0]      = 5;
	sizes[1]      = 15;

	useInvAlpha = false;
};
datablock ParticleEmitterData(Type25_GLExplosionCenterEmitter)
{
	lifeTimeMS = 200;

   ejectionPeriodMS = 4;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 0.0;
   ejectionOffset   = 2;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "Type25_GLExplosionCenterParticle";

   uiName = "Type-25 GL Brute Shot Inner Flash";
};

datablock ExplosionData(Type25_GLExplosion)
{
   //explosionShape = "";
   explosionShape = "./explosionSphere1.dts";
	soundProfile = Type25_GLImpactSound;

   lifeTimeMS = 150;

   particleEmitter = Type25_GLExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   emitter[0] = Type25_GLExplosionRingEmitter;
   emitter[1] = Type25_GLExplosionCenterEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "3.0 10.0 3.0";
   camShakeDuration = 0.5;
   camShakeRadius = 20.0;

   // Dynamic light
   lightStartRadius = 5;
   lightEndRadius = 20;
   lightStartColor = "1 1 1 1";
   lightEndColor = "0 0 0 0";

   damageRadius = 3;
   radiusDamage = 100;

   impulseRadius = 6;
   impulseForce = 4000;
};


AddDamageType("Type25_GL",   '<bitmap:add-ons/Weapon_The_New_Halo_Pack/Type25_GL/CI_Type25_GL> %1',    '%2 <bitmap:add-ons/Weapon_The_New_Halo_Pack/Type25_GL/CI_Type25_GL> %1',0.2,1);
datablock ProjectileData(Type25_GLProjectile)
{
   projectileShapeName = "./grenadeShot.dts";
   directDamage        = 97;
   radiusDamage		= 63;
   directDamageType    = $DamageType::Type25_GL;
   radiusDamageType    = $DamageType::Type25_GL;

   brickExplosionRadius = 6;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 40;
   brickExplosionMaxVolume = 20;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 40;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 50;
   verticalImpulse	  = 0;
   explosion           = Type25_GLExplosion;

   muzzleVelocity      = 145;
   velInheritFactor    = 1;

   armingDelay         = 20;
   lifetime            = 2500;
   fadeDelay           = 2500;
   bounceAngle         = 0;
   bounceElasticity    = 0.3;
   bounceFriction      = 0.1;
   isBallistic         = true;
   gravityMod = 3;
   explodeOnDeath = true;

   hasLight    = false;
   lightRadius = 5.0;
   lightColor  = "0.5 0.5 0";

   uiName = "Type-25 GL Brute Shot Grenade";
};

datablock ProjectileData(Type25_GLMuzzleExplosionProjectile)
{
   projectileShapeName = "./empty.dts";
   directDamage        = 0;
   directDamageType    = $DamageType::Type25_GL;
   radiusDamageType    = $DamageType::Type25_GL;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 0;
   brickExplosionMaxVolume = 0;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 0;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 0;
   verticalImpulse	  = 0;
   explosion           = Type25_GLMuzzleExplosion;

   muzzleVelocity      = 0;
   velInheritFactor    = 1;
   explodeOnDeath = true;

   armingDelay         = 00;
   lifetime            = 0;
   fadeDelay           = 0;
   bounceElasticity    = 5;
   bounceFriction      = 0;
   isBallistic         = true;
   gravityMod = 0;

   hasLight    = true;
   lightRadius = 1.0;
   lightColor  = "0.5 0.5 0";

   uiName = "Type-25 GL Brute Shot Muzzle Explosion Projectile";
};

//////////
// item //
//////////
datablock ItemData(Type25_GLItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Type25_GL_Ground.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Type-25 GL Brute Shot";
	iconName = "./UI_Type25_GL";
	doColorShift = true;
	colorShiftColor = "0.5 0.5 0.5 1.000";

	 // Dynamic properties defined by the scripts
	image = Type25_GLImage;
	canDrop = true;

	maxAmmo = 6;
	canReload = 1;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(Type25_GLImage)
{
   // Basic Item properties
   shapeFile = "./Type25_GL.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   
   offset = "0.2 -0.27 -0.5"; // -Left +Right, -Back +Front, -Down +Up
   
   eyeOffset = "0.35 0.9 -0.60"; //"0.5 1.3 -0.3"; -Left +Right, -Back +Front, -Down +Up
   
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = Type25_GLItem;
   ammo = " ";
   projectile = Type25_GLProjectile;
   projectileType = Projectile;

	casing = Type25_GLCasing;
	shellExitDir        = "2.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 25.0;	
	shellVelocity       = 10.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = Type25_GLItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.
   // Initial start up state
	stateName[0]                     	= "Activate";
	stateTimeoutValue[0]             	= 0.53;
	stateTransitionOnTimeout[0]       	= "LoadCheckA";
	stateSound[0]				= Type25_GLUse2Sound;
	stateSequence[0]			= "use";

	stateName[1]                     	= "Ready";
	stateTransitionOnNoAmmo[1]       	= "Reload";
	stateTransitionOnTriggerDown[1]  	= "preFire";
	stateAllowImageChange[1]         	= true;

	stateName[19]="preFire";
	stateTimeoutValue[19]=0;
	stateTransitionOnTimeout[19]="preFire2";
	stateScript[19]                  = "onFire";
	stateEjectShell[19]       	  = true;
	stateEmitter[19]					= Type25_GLFlashEmitter;
	stateEmitterTime[19]				= 0.05;
	stateEmitterNode[19]				= "muzzleNode";
	stateFire[19]                    = true;
	
	stateName[21]="preFire2";
	stateTransitionOnTimeout[21]="preFire3";
	stateScript[21]				= "onLoadCheck";
	
	//Hinge State between E-Reload and Normal Reload, and Bolt Holding
	stateName[20]="preFire3";
	stateTransitionOnNoAmmo[20]="Fire";
	stateTransitionOnAmmo[20]="Fire";
	
	stateName[18]="Ready2";
	stateTransitionOnTriggerUp[18]="Ready";
	
	stateName[2]                    	= "Fire";
	stateTransitionOnTimeout[2]     	= "Delay";
	stateTimeoutValue[2]            	= 0.00;
	stateAllowImageChange[2]        	= false;
	stateSequence[2]                	= "fire";
	stateWaitForTimeout[2]			= true;
	//stateSound[2]				= Type25_GLFireSound;

	stateName[7]				= "Delay";
	stateTransitionOnTimeout[7]     	= "FireLoadCheckA";
	stateTimeoutValue[7]            	= 0.17;
	
	stateName[8]				= "LoadCheckA";
	stateScript[8]				= "onLoadCheck";
	stateTimeoutValue[8]			= 0.01;
	stateTransitionOnTimeout[8]		= "LoadCheckB";
	
	stateName[9]				= "LoadCheckB";
	stateTransitionOnAmmo[9]		= "Ready2";
	stateTransitionOnNoAmmo[9]		= "Reload";

	stateName[10]				= "Reload";
	stateTimeoutValue[10]			= 0.57;
	stateScript[10]				= "onReloadStart";
	stateTransitionOnTimeout[10]		= "Wait";
	stateWaitForTimeout[10]			= true;
	stateSequence[10]			= "clipOut";
	stateSound[10]				= Type25_GLclipOut2Sound;
	
	stateName[11]				= "Wait";
	stateTimeoutValue[11]			= 1.75;
	stateSound[11]				= Type25_GLclipIn2Sound;
	stateScript[11]				= "onReloadWait";
	stateSequence[11]			= "clipIn";
	stateTransitionOnTimeout[11]		= "Reloaded";
	
	stateName[12]				= "FireLoadCheckA";
	stateScript[12]				= "onLoadCheck";
	stateTimeoutValue[12]			= 0.01;
	stateTransitionOnTimeout[12]		= "FireLoadCheckB";
	
	stateName[13]				= "FireLoadCheckB";
	stateTransitionOnAmmo[13]		= "Smoke";
	stateTransitionOnNoAmmo[13]		= "ReloadSmoke";
	
	stateName[14] 				= "Smoke";
	stateTimeoutValue[14]			= 0.0001;
	stateTransitionOnTimeout[14]		= "Ready2";
	//stateTransitionOnTriggerDown[14]	= "Fire";
	
	stateName[15] 				= "ReloadSmoke";
	stateTimeoutValue[15]			= 0.01;
	stateTransitionOnTimeout[15]		= "Reload";
	
	stateName[22]				= "Reloaded";
	stateTimeoutValue[22]			= 0.01;
	stateScript[22]				= "onReloaded";
	stateTransitionOnTimeout[22]		= "Ready";
	
	
};

function Type25_GLImage::onFire(%this,%obj,%slot)
{

%pos = %obj.getTransform();
   %random = getRandom(1,4);
   switch(%random)
   {
      case 1:
         serverplay3d(Type25_GLFire1Sound,%pos);
      case 2:
         serverplay3d(Type25_GLFire2Sound,%pos);
      case 3:
         serverplay3d(Type25_GLFire3Sound,%pos);
	  case 4:
         serverplay3d(Type25_GLFire4Sound,%pos);
      default:
         echo("Error on Type-25 GL Brute Shot");
   }
   
   
   	%obj.toolAmmo[%obj.currTool]--;
	%obj.AmmoSpent[%obj.currTool]++;

			commandToClient(%obj.client,'bottomPrint',"<just:right><font:ds-digital:64><color:4577ab>" @ %obj.toolAmmo[%obj.currTool] @ "<font:ds-digital:24><color:004080> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
	Parent::onFire(%this,%obj,%slot);
	
   
	
	%projectile = "Type25_GLMuzzleExplosionProjectile";
	
	%vector = %obj.getMuzzleVector(%slot);
	%objectVelocity = %obj.getVelocity();
	%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
	%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	
	%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
	};
	MissionCleanup.add(%p);
	return %p;
}

function Type25_GLImage::onReloadWait(%this,%obj,%slot)
{
			commandToClient(%obj.client,'bottomPrint',"<just:right><font:ds-digital:64><color:4577ab>" @ %obj.toolAmmo[%obj.currTool] @ "<font:ds-digital:24><color:004080> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
}

function Type25_GLImage::onLoadCheck(%this,%obj,%slot)
{
	if(%obj.toolAmmo[%obj.currTool] <= 0)
		%obj.setImageAmmo(%slot,0);
	else
		%obj.setImageAmmo(%slot,1);
}

function Type25_GLImage::onReloadStart(%this,%obj,%slot)
{
				commandToClient(%obj.client,'bottomPrint',"<just:right><font:ds-digital:64><color:4577ab>" @ %obj.toolAmmo[%obj.currTool] @ "<font:ds-digital:24><color:004080> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
}

function Type25_GLImage::onReloaded(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool] = %this.item.maxAmmo;
	%obj.AmmoSpent[%obj.currTool] = 0;
	%obj.setImageAmmo(%slot,1);
			commandToClient(%obj.client,'bottomPrint',"<just:right><font:ds-digital:64><color:4577ab>" @ %obj.toolAmmo[%obj.currTool] @ "<font:ds-digital:24><color:004080> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
	return;
}

function Type25_GLProjectile::onCollision(%this, %obj, %col, %fade, %pos, %normal)
{
	Parent::onCollision(%this, %obj, %col, %fade, %pos, %normal);
	%random = getRandom(1,1);
	switch(%random)
	{
		case 1:
			serverplay3d(Type25_GLImpactSound,%pos);
		default:
			echo("Error on Type25_GL");
	}
}


function Type25_GLImage::onMount(%this,%obj,%slot)
{
  
  %obj.hidenode("RHand");
        %obj.hidenode("LHand");
		   Parent::onMount(%this,%obj,%slot);
					commandToClient(%obj.client,'bottomPrint',"<just:right><font:ds-digital:64><color:4577ab>" @ %obj.toolAmmo[%obj.currTool] @ "<font:ds-digital:24><color:004080> " @ %this.item.maxAmmo @ "", 1,2,3,4); 

}

function Type25_GLImage::onUnMount(%this,%obj,%slot)
{
  
  %obj.unhidenode("RHand");
        %obj.unhidenode("LHand");
		%obj.playThread(2, root);
}
