datablock AudioProfile(Type33_GMLFire1Sound)
{
   filename    = "./fire1.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Type33_GMLFire2Sound)
{
   filename    = "./fire2.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Type33_GMLFire3Sound)
{
   filename    = "./fire3.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Type33_GMLclipInSound)
{
   filename    = "./clipIn.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Type33_GMLclipOutSound)
{
   filename    = "./clipOut.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Type33_GMLUseSound)
{
   filename    = "./use.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Type33_GMLImpact1Sound)
{
   filename    = "./impact1.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Type33_GMLImpact2Sound)
{
   filename    = "./impact2.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Type33_GMLImpact3Sound)
{
   filename    = "./impact3.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Type33_GMLExplode1Sound)
{
   filename    = "./expl1.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Type33_GMLExplode2Sound)
{
   filename    = "./expl2.wav";
   description = AudioClose3d;
   preload = true;
};

//Effects
//Flash
datablock ParticleData(Type33_GMLflashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "./needleMFlash";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.5 0.5 0.5 0.9";
	colors[1]     = "0.5 0.5 0.5 0.0";
	sizes[0]      = 2.0;
	sizes[1]      = 3.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(Type33_GMLflashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 25;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "Type33_GMLflashParticle";

   uiName = "Type-33 GML Needler Flash";
};

datablock ParticleData(Type33_GMLExplosionChunkParticle)
{
   dragCoefficient      = 2;
   gravityCoefficient   = 2;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 2400;
   lifetimeVarianceMS   = 1300;
   textureName          = "./muzzleSpark";
   spinSpeed		= 5.0;
   spinRandomMin		= -500.0;
   spinRandomMax		= 500.0;
   colors[0]     = "1 1 1 1";
   colors[1]     = "0.6 0.6 0.6 0.2";
   sizes[0]      = 0.05;
   sizes[1]      = 0;
   times[0]		= 0;
   times[1]		= 1;
 
   useInvAlpha = true;
};
datablock ParticleEmitterData(Type33_GMLExplosionChunkEmitter)
{
   lifeTimeMS = 25;

   ejectionPeriodMS = 50;
   periodVarianceMS = 10;
   ejectionVelocity = 5;
   velocityVariance = 0.0;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "Type33_GMLExplosionChunkParticle";
};

datablock DebrisData(Type33_GMLDebris)
{
   emitters = "Type33_GMLExplosionChunkEmitter";

	shapeFile = "./blamiteShard.dts";
	lifetime = 2.0;
	minSpinSpeed = -500.0;
	maxSpinSpeed = 400.0;
	elasticity = 0.5;
	friction = 0.05;
	numBounces = 5;
	staticOnMaxBounce = false;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};

datablock ExplosionData(Type33_GMLMuzzleExplosion)
{

   debris = "";
   debrisNum = 3;
   debrisNumVariance = 2;
   debrisPhiMin = 0;
   debrisPhiMax = 360;
   debrisThetaMin = 0;
   debrisThetaMax = 180;
   debrisVelocity = 10;
   debrisVelocityVariance = 10;
   lifeTimeMS = 250;

   particleEmitter = Type33_GMLExplosionChunkEmitter;
   particleDensity = 5;
   particleRadius = 0.2;
   
   //emitter[0] = Type33_GMLExplosionChunkEmitter;
   //emitter[1] = Type33_GMLExplosionChunkEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "4.0 5.0 4.0";
   camShakeAmp = "1.0 3.0 0.5";
   camShakeDuration = 0.5;
   camShakeRadius = 2.5;

   // Dynamic light
   lightStartRadius = 10;
   lightEndRadius = 1;
   lightStartColor = "0.9 0 3 1";
   lightEndColor = "0.3 0.1 0.0 1";

   impulseRadius = 0;
   impulseForce = 0;
};


datablock ParticleData(Type33_GMLExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 700;
	lifetimeVarianceMS   = 400;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.9 0.1 0.1 0.3";
	colors[1]     = "0.9 0.1 0.1 0.0";
	sizes[0]      = 0.25;
	sizes[1]      = 0.75;

	useInvAlpha = true;
};
datablock ParticleEmitterData(Type33_GMLExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 2;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "Type33_GMLExplosionParticle";

   useEmitterColors = true;
   uiName = "Type-33 GML Needler Hit Dust";
};


datablock ParticleData(Type33_GMLExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 50;
	lifetimeVarianceMS   = 35;
	textureName          = "./needleFlash";
	spinSpeed		= 500.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.5 0.5 0.5 0.9";
	colors[1]     = "0.5 0.5 0.5 0.0";
	sizes[0]      = 1;
	sizes[1]      = 0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(Type33_GMLExplosionRingEmitter)
{
	lifeTimeMS = 50;

   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "Type33_GMLExplosionRingParticle";

   useEmitterColors = true;
   uiName = "Type-33 GML Needler Hit Flash";
};

//bullet trail effects
datablock ParticleData(Type33_GMLTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 3000;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= false;
	animateTexture		= false;
	//framesPerSec		= 1;
	textureName		= "base/data/particles/dot";
	colors[0]     = "0.9 0 3 1";
	colors[1]     = "0.2 0 0.04 0";
	sizes[0]	= 0.05;
	sizes[1]	= 0.0;
	times[0]	= 0.0;
	times[1]	= 1.0;
};
datablock ParticleEmitterData(Type33_GMLTrailEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = Type33_GMLTrailParticle;

   useEmitterColors = true;
   uiName = "";
};

datablock ExplosionData(Type33_GMLExplosion)
{
   debris = Type33_GMLDebris;
   debrisNum = 5;
   debrisNumVariance = 2;
   debrisPhiMin = 0;
   debrisPhiMax = 360;
   debrisThetaMin = 0;
   debrisThetaMax = 180;
   debrisVelocity = 12;
   debrisVelocityVariance = 10;
   lifeTimeMS = 250;
   //explosionShape = "";
	soundProfile = Type33_GMLExplode1Sound;

   lifeTimeMS = 150;

   particleEmitter = Type33_GMLExplosionEmitter;
   particleDensity = 5;
   particleRadius = 0.2;

   emitter[0] = Type33_GMLExplosionRingEmitter;
   emitter[1] = Type33_GMLExplosionChunkEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 1.3;
   lightStartColor = "0.9 0 3";
   lightEndColor = "0 0 0";
   
    damageRadius = 3;
   radiusDamage = 10;
   
};

datablock ExplosionData(Type33_GMLStickExplosion)
{
   //explosionShape = "";

   lifeTimeMS = 150;

   particleEmitter = Type33_GMLStickExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   emitter[0] = "";

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 1;
   lightStartColor = "0.9 0 3";
   lightEndColor = "0 0 0";
};


AddDamageType("Type33_GML",   '<bitmap:add-ons/Weapon_The_New_Halo_Pack/Type33_GML/CI_Type33_GML> %1',    '%2 <bitmap:add-ons/Weapon_The_New_Halo_Pack/Type33_GML/CI_Type33_GML> %1',0.2,1);
datablock ProjectileData(Type33_GMLProjectile)
{
   projectileShapeName = "./blamiteNeedle.dts";

   directDamage        = 7;
   directDamageType    = $DamageType::Type33_GMLDirect;

   radiusDamage        = 0;
   damageRadius        = 0;
   radiusDamageType    = $DamageType::Type33_GMLDirect;

   explosion             = Type33_GMLExplosion;
   stickExplosion        = Type33_GMLStickExplosion;
   bloodExplosion        = Type33_GMLStickExplosion;
   particleEmitter       = Type33_GMLTrailEmitter;
   explodeOnPlayerImpact = false;
   explodeOnDeath        = true;  

   armingDelay         = 3000; //3000
   lifetime            = 3000; //3000
   fadeDelay           = 3000; //3000

   isBallistic         = true;
   bounceAngle         = 170;
   minStickVelocity    = 10;
   bounceElasticity    = 0.3;
   bounceFriction      = 0;   
   gravityMod = 0;

   hasLight    = true;
   lightRadius = 3.0;
   lightColor  = "0.9 0 3";

   muzzleVelocity      = 54;
   velInheritFactor    = 1;
   
   //HomingProjectile Support
   homing = 1;
   homingPredict = 0;		//Makes the homing much more accurate at the cost of taking a bit longer. USAGE WITH SPAMMABLE WEAPONS NOT ADVISED
   homingStartDelay = 100;	//How long it takes before the projectile starts homing after being shot in miliseconds.
   homingDelay = 100;		//Delay between every homing loop
   homingMaxDistance = 30;	//Maximum distance between projectile and target after which it loses it's target.
   homingSearchRadius = 50;	//Maximum distance the projectile starts looking around him. (advisable to set it a slight bit above the maxDistance)
   homingTurn = 0.25;		//How much the projectile is able to turn
   //Following are not yet implemented
   //homingAcceptedTypes = $TypeMasks::PlayerObjectType;
   //homingFriendlyFire = 0;
   //homingFriendOnly = 0;
   
   

   uiName = "Type-33 GML Needler Blamite Shard";
};

datablock ProjectileData(Type33_GMLMuzzleExplosionProjectile)
{
   projectileShapeName = "./empty.dts";
   directDamage        = 0;
   directDamageType    = $DamageType::Type33_GML;
   radiusDamageType    = $DamageType::Type33_GML;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 0;
   brickExplosionMaxVolume = 0;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 0;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 0;
   verticalImpulse	  = 0;
   explosion           = Type33_GMLMuzzleExplosion;

   muzzleVelocity      = 0;
   velInheritFactor    = 1;
   explodeOnDeath = true;

   armingDelay         = 00;
   lifetime            = 0;
   fadeDelay           = 0;
   bounceElasticity    = 5;
   bounceFriction      = 0;
   isBallistic         = true;
   gravityMod = 0;

   hasLight    = true;
   lightRadius = 5.0;
   lightColor  = "0.5 0.5 0";

   uiName = "Type-33 GML Needler Muzzle Explosion Projectile";
};

//////////
// item //
//////////
datablock ItemData(Type33_GMLItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Type33_GML_Ground.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Type-33 GML Needler";
	iconName = "./UI_Type33_GML";
	doColorShift = true;
	colorShiftColor = "0.5 0.5 0.5 1.000";

	 // Dynamic properties defined by the scripts
	image = Type33_GMLImage;
	canDrop = true;

	maxAmmo = 20;
	canReload = 1;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(Type33_GMLImage)
{
   // Basic Item properties
   shapeFile = "./Type33_GML.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5"; -Left +Right, -Back +Front, -Down +Up
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = Type33_GMLItem;
   ammo = " ";
   projectile = Type33_GMLProjectile;
   projectileType = Projectile;

	casing = Type33_GMLCasing;
	shellExitDir        = "2.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 25.0;	
	shellVelocity       = 10.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = Type33_GMLItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.
   // Initial start up state
	stateName[0]                     	= "Activate";
	stateTimeoutValue[0]             	= 0.5;
	stateTransitionOnTimeout[0]       	= "LoadCheckA";
	stateSound[0]				= Type33_GMLUseSound;
	stateSequence[0]			= "use";

	stateName[1]                     	= "Ready";
	stateTransitionOnNoAmmo[1]       	= "Reload";
	stateTransitionOnTriggerDown[1]  	= "Fire";
	stateAllowImageChange[1]         	= true;

	stateName[2]                    	= "Fire";
	stateTransitionOnTimeout[2]     	= "Delay";
	stateTimeoutValue[2]            	= 0.06;
	stateFire[2]                    	= true;
	stateAllowImageChange[2]        	= false;
	stateSequence[2]                	= "fire";
	stateScript[2]                  	= "onFire";
	stateEjectShell[2]       	  	= true;
	stateEmitter[2]				= Type33_GMLFlashEmitter;
	stateEmitterTime[2]			= 0.04;
	stateEmitterNode[2]			= "muzzleNode";
	stateWaitForTimeout[2]			= true;
	//stateSound[2]				= Type33_GMLFireSound;

	stateName[7]				= "Delay";
	stateTransitionOnTimeout[7]     	= "FireLoadCheckA";
	stateTimeoutValue[7]            	= 0.001;
	stateEmitter[7]				= gunSmokeEmitter;
	stateEmitterTime[7]			= 0.001;
	stateEmitterNode[7]			= "muzzleNode";
	
	stateName[8]				= "LoadCheckA";
	stateScript[8]				= "onLoadCheck";
	stateTimeoutValue[8]			= 0.01;
	stateTransitionOnTimeout[8]		= "LoadCheckB";
	
	stateName[9]				= "LoadCheckB";
	stateTransitionOnAmmo[9]		= "Ready";
	stateTransitionOnNoAmmo[9]		= "Reload";

	stateName[10]				= "Reload";
	stateTimeoutValue[10]			= 0.4;
	stateScript[10]				= "onReloadStart";
	stateTransitionOnTimeout[10]		= "Wait";
	stateWaitForTimeout[10]			= true;
	stateSequence[10]			= "clipOut";
	stateSound[10]				= Type33_GMLclipOutSound;
	
	stateName[11]				= "Wait";
	stateTimeoutValue[11]			= 1.55;
	stateSound[11]				= Type33_GMLclipInSound;
	stateScript[11]				= "onReloadWait";
	stateSequence[11]			= "clipIn";
	stateTransitionOnTimeout[11]		= "Reloaded";
	
	stateName[12]				= "FireLoadCheckA";
	stateScript[12]				= "onLoadCheck";
	stateTimeoutValue[12]			= 0.01;
	stateTransitionOnTimeout[12]		= "FireLoadCheckB";
	
	stateName[13]				= "FireLoadCheckB";
	stateTransitionOnAmmo[13]		= "Smoke";
	stateTransitionOnNoAmmo[13]		= "ReloadSmoke";
	
	stateName[14] 				= "Smoke";
	stateEmitter[14]			= gunSmokeEmitter;
	stateEmitterTime[14]			= 0.001;
	stateEmitterNode[14]			= "muzzleNode";
	stateTimeoutValue[14]			= 0.001;
	stateTransitionOnTimeout[14]		= "Ready";
	stateTransitionOnTriggerDown[14]	= "Fire";
	
	stateName[15] 				= "ReloadSmoke";
	stateEmitter[15]			= gunSmokeEmitter;
	stateEmitterTime[15]			= 0.001;
	stateEmitterNode[15]			= "muzzleNode";
	stateTimeoutValue[15]			= 0.001;
	stateTransitionOnTimeout[15]		= "Reload";
	
	stateName[16]				= "Reloaded";
	stateTimeoutValue[16]			= 0.01;
	stateScript[16]				= "onReloaded";
	stateTransitionOnTimeout[16]		= "Ready";
};

function Type33_GMLImage::onFire(%this,%obj,%slot)
{
   	
   %pos = %obj.getTransform();
   %random = getRandom(1,3);
   switch(%random)
   {
      case 1:
         serverplay3d(Type33_GMLFire1Sound,%pos);
      case 2:
         serverplay3d(Type33_GMLFire2Sound,%pos);
      case 3:
         serverplay3d(Type33_GMLFire3Sound,%pos);
      default:
         echo("Error on Type33_GML");
   }
   
   
	%projectile = Type33_GMLProjectile;

	if(vectorLen(%obj.getVelocity()) < 0.1)
	{
		%spread = 0.004;
	}
	else
	{
		%spread = 0.002;
	}
	
	%obj.lastShotTime = getSimTime();
	%shellcount = 1;

	%shellcount = 1;
	%obj.toolAmmo[%obj.currTool]--;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	
	%projectile = "Type33_GMLMuzzleExplosionProjectile";
	
	%vector = %obj.getMuzzleVector(%slot);
	%objectVelocity = %obj.getVelocity();
	%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
	%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	
	%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
	};
	MissionCleanup.add(%p);
	return %p;
}

function Type33_GMLProjectile::onCollision(%this, %obj, %col, %fade, %pos, %normal)
{
	Parent::onCollision(%this, %obj, %col, %fade, %pos, %normal);
	%random = getRandom(1,3);
	switch(%random)
	{
		case 1:
			serverplay3d(Type33_GMLImpact1Sound,%pos);
		case 2:
			serverplay3d(Type33_GMLImpact2Sound,%pos);
		case 3:
			serverplay3d(Type33_GMLImpact3Sound,%pos);
		default:
			echo("Error on Type33_GML");
	}
}

datablock ShapeBaseImageData(GMLStickyImage)
{
  shapeFile = "./blamiteNeedle.dts";
  emap = true;
  mountPoint = 7;
  offset = "0 0.35 0.8";
  eyeOffset = "0 0 0";
  rotation = eulerToMatrix("0 0 0");
  scale = "1 1 1";
  correctMuzzleVector = true;
  doColorShift = true;
  colorShiftColor = "1 0.7 1 0.5";

  stateName[0] = "Activate";
  stateTimeoutValue[0] = 0.1;
  stateTransitionOnTimeout[0] = "Idle";
  stateSound[0] = Type33_GMLImpact1Sound;

  stateName[1] = "Idle";
  stateAllowImageChange[1] = true;
};

function Type33_GMLProjectile::damage(%this,%obj,%col,%fade,%pos,%normal)
{
	Parent::damage(%this,%obj,%col,%fade,%pos,%normal);
	if (%col.getMountedImage(2) < 1)
	{
		//No image on there
		%col.mountImage(GMLStickyImage, 2);
	}
	%obj.delete();
	%col.stickies++;
	if (%col.stickies == 7)
	{
		//They all explode
		%col.stickies = 0;
		%scale = getWord(%col.getScale(),2);
		%col.spawnExplosion(Type33_GMLProjectile, %scale);
		//%col.damage(%obj.sourceObject,%pos, 30, $DamageType::Generic); //Additional Damage if need be
		%random = getRandom(1,3);
		switch(%random)
		{
			case 1:
				serverplay3d(Type33_GMLExplode1Sound,%pos);
			case 2:
				serverplay3d(Type33_GMLExplode2Sound,%pos);
			case 3:
				serverplay3d(Type33_GMLExplode3Sound,%pos);
			default:
				echo("Error on Type33_GML");
		}
		if (%col.getMountedImage(2) == GMLStickyImage.getID())
			%col.unmountImage(2);
	}
}

function Type33_GMLProjectile::onDeath(%this, %obj, %col, %fade, %pos, %normal)
{
	Parent::onDeath(%this, %obj, %col, %fade, %pos, %normal);
	%random = getRandom(1,3);
	switch(%random)
	{
		case 1:
			serverplay3d(Type33_GMLExplode1Sound,%pos);
		case 2:
			serverplay3d(Type33_GMLExplode2Sound,%pos);
		case 3:
			serverplay3d(Type33_GMLExplode3Sound,%pos);
		default:
			echo("Error on Type33_GML");
	}
}

function Type33_GMLImage::onLoadCheck(%this,%obj,%slot)
{
	if(%obj.toolAmmo[%obj.currTool] <= 0)
		%obj.setImageAmmo(%slot,0);
	else
		%obj.setImageAmmo(%slot,1);
}

function Type33_GMLImage::onReloadStart(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool] = 0;
}

function Type33_GMLImage::onReloaded(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool] = 20;
	%obj.setImageAmmo(%slot,1);
}



function Type33_GMLImage::onMount(%this,%obj,%slot)
{ 
  %obj.hidenode("RHand");
        %obj.hidenode("LHand");
}

function Type33_GMLImage::onUnMount(%this,%obj,%slot)
{
  %obj.unhidenode("RHand");
        %obj.unhidenode("LHand");
}









