datablock AudioProfile(Type33_LAAWFire1Sound)
{
   filename    = "./fire1.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Type33_LAAWFire2Sound)
{
   filename    = "./fire2.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Type33_LAAWclipInSound)
{
   filename    = "./clipIn.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Type33_LAAWclipOutSound)
{
   filename    = "./clipOut.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Type33_LAAWUseSound)
{
   filename    = "./use.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Type33_LAAWImpactSound)
{
   filename    = "./impact.wav";
   description = AudioClose3d;
   preload = true;
};

//Effects
//Flash
datablock ParticleData(Type33_LAAWflashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "./fuelRodMFlash";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.5 0.5 0.5 0.9";
	colors[1]     = "0.5 0.5 0.5 0.0";
	sizes[0]      = 2.0;
	sizes[1]      = 3.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(Type33_LAAWflashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 25;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "Type33_LAAWflashParticle";

   uiName = "Type-33 LAAW Flash";
};

datablock ParticleData(Type33_LAAWExplosionChunkParticle)
{
   dragCoefficient      = 2;
   gravityCoefficient   = 2;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 2400;
   lifetimeVarianceMS   = 1300;
   textureName          = "./muzzleSpark";
   spinSpeed		= 5.0;
   spinRandomMin		= -500.0;
   spinRandomMax		= 500.0;
   colors[0]     = "1 1 1 1";
   colors[1]     = "0.6 0.6 0.6 0.2";
   sizes[0]      = 0.05;
   sizes[1]      = 0;
   times[0]		= 0;
   times[1]		= 1;
 
   useInvAlpha = true;
};
datablock ParticleEmitterData(Type33_LAAWExplosionChunkEmitter)
{
   lifeTimeMS = 25;

   ejectionPeriodMS = 50;
   periodVarianceMS = 10;
   ejectionVelocity = 5;
   velocityVariance = 0.0;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "Type33_LAAWExplosionChunkParticle";
};


datablock ParticleData(Type33_LAAWSparkParticle)
{
   dragCoefficient      = 2;
   gravityCoefficient   = 2;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 1000;
   lifetimeVarianceMS   = 1300;
   textureName          = "./muzzleSpark";
   spinSpeed		= 5.0;
   spinRandomMin		= -500.0;
   spinRandomMax		= 500.0;
   colors[0]     = "1 1 1 1";
   colors[1]     = "0.6 0.6 0.6 0.2";
   sizes[0]      = 0.05;
   sizes[1]      = 0;
   times[0]		= 0;
   times[1]		= 1;
 
   useInvAlpha = true;
};
datablock ParticleEmitterData(Type33_LAAWSparkEmitter)
{
   lifeTimeMS = 4500;

   ejectionPeriodMS = 50;
   periodVarianceMS = 10;
   ejectionVelocity = 5;
   velocityVariance = 0.0;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "Type33_LAAWSparkParticle";
   uiName = "Type-33 LAAW Projectile Sparks";
};


datablock DebrisData(Type33_LAAWDebris)
{
   emitters = "Type33_LAAWExplosionChunkEmitter";

	shapeFile = "./blamiteShard.dts";
	lifetime = 2.0;
	minSpinSpeed = -500.0;
	maxSpinSpeed = 400.0;
	elasticity = 0.5;
	friction = 0.05;
	numBounces = 5;
	staticOnMaxBounce = false;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};

datablock ExplosionData(Type33_LAAWMuzzleExplosion)
{

   debris = "";
   debrisNum = 3;
   debrisNumVariance = 2;
   debrisPhiMin = 0;
   debrisPhiMax = 360;
   debrisThetaMin = 0;
   debrisThetaMax = 180;
   debrisVelocity = 10;
   debrisVelocityVariance = 10;
   lifeTimeMS = 250;

   particleEmitter = "";
   particleDensity = 5;
   particleRadius = 0.2;
   
   //emitter[0] = Type33_LAAWExplosionChunkEmitter;
   //emitter[1] = Type33_LAAWExplosionChunkEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "4.0 5.0 4.0";
   camShakeAmp = "1.0 3.0 0.5";
   camShakeDuration = 0.5;
   camShakeRadius = 2.5;

   // Dynamic light
   lightStartRadius = 10;
   lightEndRadius = 1;
   lightStartColor = "0.3 1 0 1";
   lightEndColor = "0.01 0.1 0.0 1";

   impulseRadius = 0;
   impulseForce = 0;
};

//bullet trail effects
datablock ParticleData(Type33_LAAWTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 2500;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= false;
	animateTexture		= false;
	//framesPerSec		= 1;
	textureName		= "./trailRing";
	colors[0]     = "10 10 10 1";
	colors[1]     = "0.3 1 0 0.2";
	colors[2]     = "0 0 0 0";
	sizes[0]	= 0.1;
	sizes[1]	= 1;
	sizes[2]	= 3;
	times[0]	= 0.0;
	times[1]	= 0.1;
	times[2]	= 1.0;
};
datablock ParticleEmitterData(Type33_LAAWTrailEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = Type33_LAAWTrailParticle;

   useEmitterColors = true;
   uiName = "";
};


datablock ParticleData(Type33_LAAWExplosionParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 700;
	lifetimeVarianceMS   = 400;
	textureName          = "./combinedSmoke";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.9 0.9 0.9 0.9";
	colors[1]     = "0.5 0.5 0.5 0.0";
	sizes[0]      = 10.0;
	sizes[1]      = 15.0;

	useInvAlpha = true;
};
datablock ParticleEmitterData(Type33_LAAWExplosionEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 10;
   velocityVariance = 1.0;
   ejectionOffset   = 3.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "Type33_LAAWExplosionParticle";

   uiName = "Type-33 LAAW Smoke";
   emitterNode = TenthEmitterNode;
};


datablock ParticleData(Type33_LAAWExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 10;
	textureName          = "./plasmaRing";
	spinSpeed		= 10.0;
	spinRandomMin		= -100.0;
	spinRandomMax		= 100.0;
	colors[0]     = "1 1 1 0.9";
	colors[1]     = "0.9 0.9 0.9 0.0";
	sizes[0]      = 0;
	sizes[1]      = 15;

	useInvAlpha = false;
};
datablock ParticleEmitterData(Type33_LAAWExplosionRingEmitter)
{
	lifeTimeMS = 1000;

   ejectionPeriodMS = 10;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 0.0;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "Type33_LAAWExplosionRingParticle";

   uiName = "Type-33 LAAW Arcs";
};

datablock ParticleData(Type33_LAAWExplosionCenterParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 100;
	lifetimeVarianceMS   = 10;
	textureName          = "./impactFlash";
	spinSpeed		= 10.0;
	spinRandomMin		= -250.0;
	spinRandomMax		= 250.0;
	colors[0]     = "1 1 1 1";
	colors[1]     = "0.9 0.9 0.9 0.0";
	sizes[0]      = 5;
	sizes[1]      = 15;

	useInvAlpha = false;
};
datablock ParticleEmitterData(Type33_LAAWExplosionCenterEmitter)
{
	lifeTimeMS = 200;

   ejectionPeriodMS = 4;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 0.0;
   ejectionOffset   = 2;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "Type33_LAAWExplosionCenterParticle";

   uiName = "Type-33 LAAW InnerFlash";
};

datablock ExplosionData(Type33_LAAWExplosion)
{
   //explosionShape = "";
   explosionShape = "./explosionSphere1.dts";
	soundProfile = Type33_LAAWImpactSound;

   lifeTimeMS = 150;

   particleEmitter = Type33_LAAWExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   emitter[0] = Type33_LAAWExplosionRingEmitter;
   emitter[1] = Type33_LAAWExplosionCenterEmitter;
   emitter[2] = Type33_LAAWExplosionChunkEmitter;
   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "3.0 10.0 3.0";
   camShakeDuration = 0.5;
   camShakeRadius = 20.0;

   // Dynamic light
   lightStartRadius = 5;
   lightEndRadius = 20;
   lightStartColor = "0.3 1 0 1";
   lightEndColor = "0 0 0 0";

   damageRadius = 3;
   radiusDamage = 100;

   impulseRadius = 6;
   impulseForce = 4000;
};


AddDamageType("Type33_LAAW",   '<bitmap:add-ons/Weapon_The_New_Halo_Pack/Type33_LAAW/CI_Type33_LAAW> %1',    '%2 <bitmap:add-ons/Weapon_The_New_Halo_Pack/Type33_LAAW/CI_Type33_LAAW> %1',0.2,1);
datablock ProjectileData(Type33_LAAWProjectile)
{
   projectileShapeName = "./fuelRod.dts";
   directDamage        = 150;
   radiusDamage		= 100;
   directDamageType    = $DamageType::Type33_LAAW;
   radiusDamageType    = $DamageType::Type33_LAAW;

   brickExplosionRadius = 6;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 40;
   brickExplosionMaxVolume = 20;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 40;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 25;
   verticalImpulse	  = 0;
   explosion           = Type33_LAAWExplosion;
   particleEmitter     = Type33_LAAWTrailEmitter;
   
   emitter[0] = Type33_LAAWSparkEmitter;

   muzzleVelocity      = 85;
   velInheritFactor    = 1;

   armingDelay         = 100;
   lifetime            = 4500;
   fadeDelay           = 4500;

   isBallistic         = true;
   bounceAngle         = 0;
   bounceElasticity    = 0.3;
   bounceFriction      = 0;   
   gravityMod = 0;
   explodeOnDeath = true;

   hasLight    = true;
   lightRadius = 5.0;
   lightColor  = "0.3 1 0";

   uiName = "Type-33 LAAW Fuel Rod";
};

datablock ProjectileData(Type33_LAAWMuzzleExplosionProjectile)
{
   projectileShapeName = "./empty.dts";
   directDamage        = 0;
   directDamageType    = $DamageType::Type33_LAAW;
   radiusDamageType    = $DamageType::Type33_LAAW;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 0;
   brickExplosionMaxVolume = 0;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 0;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 0;
   verticalImpulse	  = 0;
   explosion           = Type33_LAAWMuzzleExplosion;

   muzzleVelocity      = 0;
   velInheritFactor    = 1;
   explodeOnDeath = true;

   armingDelay         = 00;
   lifetime            = 0;
   fadeDelay           = 0;
   bounceElasticity    = 5;
   bounceFriction      = 0;
   isBallistic         = true;
   gravityMod = 0;

   hasLight    = true;
   lightRadius = 5.0;
   lightColor  = "0.3 1 0";

   uiName = "Type-33 LAAW Muzzle Explosion Projectile";
};

//////////
// item //
//////////
datablock ItemData(Type33_LAAWItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Type33_LAAW_Ground.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Type-33 LAAW Fuel Rod Cannon";
	iconName = "./UI_Type33_LAAW";
	doColorShift = true;
	colorShiftColor = "0.5 0.5 0.5 1.000";

	 // Dynamic properties defined by the scripts
	image = Type33_LAAWImage;
	canDrop = true;

	maxAmmo = 5;
	canReload = 1;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(Type33_LAAWImage)
{
   // Basic Item properties
   shapeFile = "./Type33_LAAW.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = "0.6 1.0 0"; //"0.7 1.2 -0.5"; -Left +Right, -Back +Front, -Down +Up
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = Type33_LAAWItem;
   ammo = " ";
   projectile = Type33_LAAWProjectile;
   projectileType = Projectile;

	casing = Type33_LAAWCasing;
	shellExitDir        = "2.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 25.0;	
	shellVelocity       = 10.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = Type33_LAAWItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.
   // Initial start up state
	stateName[0]                     	= "Activate";
	stateTimeoutValue[0]             	= 0.4;
	stateTransitionOnTimeout[0]       	= "LoadCheckA";
	stateSound[0]				= Type33_LAAWUseSound;
	stateSequence[0]			= "use";

	stateName[1]                     	= "Ready";
	stateTransitionOnNoAmmo[1]       	= "Reload";
	stateTransitionOnTriggerDown[1]  	= "preFire";
	stateAllowImageChange[1]         	= true;

	stateName[19]="preFire";
	stateTimeoutValue[19]=0;
	stateTransitionOnTimeout[19]="preFire2";
	stateScript[19]                  = "onFire";
	stateEjectShell[19]       	  = true;
	stateEmitter[19]					= Type33_LAAWFlashEmitter;
	stateEmitterTime[19]				= 0.05;
	stateEmitterNode[19]				= "muzzleNode";
	stateFire[19]                    = true;
	
	stateName[21]="preFire2";
	stateTransitionOnTimeout[21]="preFire3";
	stateScript[21]				= "onLoadCheck";
	
	stateName[20]="preFire3";
	stateTransitionOnNoAmmo[20]="Fire";
	stateTransitionOnAmmo[20]="Fire";
	
	stateName[18]="Ready2";
	stateTransitionOnTriggerUp[18]="Ready";
	
	stateName[2]                    	= "Fire";
	stateTransitionOnTimeout[2]     	= "Delay";
	stateTimeoutValue[2]            	= 0.00;
	stateAllowImageChange[2]        	= false;
	stateSequence[2]                	= "fire";
	stateWaitForTimeout[2]			= true;
	
	stateName[7]				= "Delay";
	stateTransitionOnTimeout[7]     	= "FireLoadCheckA";
	stateTimeoutValue[7]            	= 0.3;
	
	stateName[8]				= "LoadCheckA";
	stateScript[8]				= "onLoadCheck";
	stateTimeoutValue[8]			= 0.01;
	stateTransitionOnTimeout[8]		= "LoadCheckB";
	
	stateName[9]				= "LoadCheckB";
	stateTransitionOnAmmo[9]		= "Ready2";
	stateTransitionOnNoAmmo[9]		= "Reload";

	stateName[10]				= "Reload";
	stateTimeoutValue[10]			= 0.4;
	stateScript[10]				= "onReloadStart";
	stateTransitionOnTimeout[10]		= "Wait";
	stateWaitForTimeout[10]			= true;
	stateSequence[10]			= "clipOut";
	stateSound[10]				= Type33_LAAWclipOutSound;
	
	stateName[11]				= "Wait";
	stateTimeoutValue[11]			= 1.55;
	stateSound[11]				= Type33_LAAWclipInSound;
	stateScript[11]				= "onReloadWait";
	stateSequence[11]			= "clipIn";
	stateTransitionOnTimeout[11]		= "Reloaded";
	
	stateName[12]				= "FireLoadCheckA";
	stateScript[12]				= "onLoadCheck";
	stateTimeoutValue[12]			= 0.01;
	stateTransitionOnTimeout[12]		= "FireLoadCheckB";
	
	stateName[13]				= "FireLoadCheckB";
	stateTransitionOnAmmo[13]		= "Smoke";
	stateTransitionOnNoAmmo[13]		= "ReloadSmoke";
	
	stateName[14] 				= "Smoke";
	stateTransitionOnTimeout[14]		= "Ready2";
	
	stateName[15] 				= "ReloadSmoke";
	stateTimeoutValue[15]			= 0.01;
	stateTransitionOnTimeout[15]		= "Reload";
	
	stateName[16]				= "Reloaded";
	stateTimeoutValue[16]			= 0.01;
	stateScript[16]				= "onReloaded";
	stateTransitionOnTimeout[16]		= "Ready";
};

function Type33_LAAWImage::onFire(%this,%obj,%slot)
{
   	
   %pos = %obj.getTransform();
   %random = getRandom(1,2);
   switch(%random)
   {
      case 1:
         serverplay3d(Type33_LAAWFire1Sound,%pos);
      case 2:
         serverplay3d(Type33_LAAWFire2Sound,%pos);
		 
      default:
         echo("Error on Fuel Rod");
   }
   
   
 	%obj.toolAmmo[%obj.currTool]--;
	%obj.AmmoSpent[%obj.currTool]++;

			commandToClient(%obj.client,'bottomPrint',"<just:right><font:ds-digital:64><color:4577ab>" @ %obj.toolAmmo[%obj.currTool] @ "<font:ds-digital:24><color:004080> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
	Parent::onFire(%this,%obj,%slot);

	
	%projectile = "Type33_LAAWMuzzleExplosionProjectile";
	
	%vector = %obj.getMuzzleVector(%slot);
	%objectVelocity = %obj.getVelocity();
	%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
	%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	
	%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
	};
	MissionCleanup.add(%p);
	return %p;
}

function Type33_LAAWProjectile::onCollision(%this, %obj, %col, %fade, %pos, %normal)
{
	Parent::onCollision(%this, %obj, %col, %fade, %pos, %normal);
	%random = getRandom(1,1);
	switch(%random)
	{
		case 1:
			serverplay3d(Type33_LAAWImpactSound,%pos);
		default:
			echo("Error on Type33_LAAW");
	}
}

function Type33_LAAWProjectile::onDeath(%this, %obj, %col, %fade, %pos, %normal)
{
	Parent::onCollision(%this, %obj, %col, %fade, %pos, %normal);
	%random = getRandom(1,1);
	switch(%random)
	{
		case 1:
			serverplay3d(Type33_LAAWExplodeSound,%pos);
		default:
			echo("Error on Type33_LAAW");
	}
}

function Type33_LAAWImage::onReloadWait(%this,%obj,%slot)
{
			commandToClient(%obj.client,'bottomPrint',"<just:right><font:ds-digital:64><color:4577ab>" @ %obj.toolAmmo[%obj.currTool] @ "<font:ds-digital:24><color:004080> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
}

function Type33_LAAWImage::onLoadCheck(%this,%obj,%slot)
{
	if(%obj.toolAmmo[%obj.currTool] <= 0)
		%obj.setImageAmmo(%slot,0);
	else
		%obj.setImageAmmo(%slot,1);
}

function Type33_LAAWImage::onReloadStart(%this,%obj,%slot)
{
				commandToClient(%obj.client,'bottomPrint',"<just:right><font:ds-digital:64><color:4577ab>" @ %obj.toolAmmo[%obj.currTool] @ "<font:ds-digital:24><color:004080> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
}

function Type33_LAAWImage::onReloaded(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool] = %this.item.maxAmmo;
	%obj.AmmoSpent[%obj.currTool] = 0;
	%obj.setImageAmmo(%slot,1);
			commandToClient(%obj.client,'bottomPrint',"<just:right><font:ds-digital:64><color:4577ab>" @ %obj.toolAmmo[%obj.currTool] @ "<font:ds-digital:24><color:004080> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
	return;
}


function Type33_LAAWImage::onMount(%this,%obj,%slot)
{
  %obj.hidenode("RHand");
        %obj.hidenode("LHand");
		   Parent::onMount(%this,%obj,%slot);
					commandToClient(%obj.client,'bottomPrint',"<just:right><font:ds-digital:64><color:4577ab>" @ %obj.toolAmmo[%obj.currTool] @ "<font:ds-digital:24><color:004080> " @ %this.item.maxAmmo @ "", 1,2,3,4); 

}

function Type33_LAAWImage::onUnMount(%this,%obj,%slot)
{
  %obj.unhidenode("RHand");
        %obj.unhidenode("LHand");
		%obj.playThread(2, root);
}

