datablock AudioProfile(Z750_SASRFire1Sound)
{
   filename    = "./fire1.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Z750_SASRFire2Sound)
{
   filename    = "./fire2.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Z750_SASRClipInSound)
{
   filename    = "./clipIn.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Z750_SASRClipOutSound)
{
   filename    = "./clipOut.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Z750_SASRClipOut_eSound)
{
   filename    = "./clipOut_e.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Z750_SASRClipIn_eSound)
{
   filename    = "./clipIn_e.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Z750_SASRUseSound)
{
   filename    = "./use.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(Z750_SASRImpactSound)
{
   filename    = "./bImpact.wav";
   description = AudioClose3d;
   preload = true;
};

//shell
datablock DebrisData(Z750_SASRCasing)
{
	shapeFile = "./empty.dts";
	lifetime = 2.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};

//Effects
//Flash
datablock ParticleData(Z750_SASRflashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "./BinaryMuzFlash";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 1 1 0.9";
	colors[1]     = "1 1 1 0.0";
	sizes[0]      = 2.0;
	sizes[1]      = 3.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(Z750_SASRflashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 25;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "Z750_SASRflashParticle";

   uiName = "Z-750 SASR Flash";
};

datablock ParticleData(Z750_SASRExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 50;
	lifetimeVarianceMS   = 35;
	textureName          = "./BinaryFlash";
	spinSpeed		= 500.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 1 1 0.9";
	colors[1]     = "1 1 1 0.0";
	sizes[0]      = 2;
	sizes[1]      = 0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(Z750_SASRExplosionRingEmitter)
{
	lifeTimeMS = 50;

   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "Z750_SASRExplosionRingParticle";

   useEmitterColors = true;
   uiName = "Z-750 SASR Plasma Impact";
};



datablock ExplosionData(Z750_SASRMuzzleExplosion)
{

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "3.0 10.0 3.0";
   camShakeDuration = 0.5;
   camShakeRadius = 5.0;

   // Dynamic light
   lightStartRadius = 10;
   lightEndRadius = 1;
   lightStartColor = "0.5 0.5 0 1";
   lightEndColor = "0.3 0.1 0.0 1";

   damageRadius = 0;
   radiusDamage = 0;

   impulseRadius = 0;
   impulseForce = 0;
};

datablock ExplosionData(Z750_SASRExplosion)
{
   //explosionShape = "";
	soundProfile = Z750_SASRImpactSound;

   lifeTimeMS = 150;

   particleEmitter = Z750_SASRExplosionRingEmitter;
   particleDensity = 5;
   particleRadius = 0.2;

   emitter[0] = Z750_SASRExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 2;
   lightStartColor = "0.0 0.6 0.7";
   lightEndColor = "0 0 0";
};

AddDamageType("Z750_SASR",   '<bitmap:add-ons/Weapon_The_New_Halo_Pack/Z750_SASR/CI_Z750_SASR> %1',    '%2 <bitmap:add-ons/Weapon_The_New_Halo_Pack/Z750_SASR/CI_Z750_SASR> %1',0.2,1);
datablock ProjectileData(Z750_SASRProjectile)
{
   projectileShapeName = "./empty.dts";
   directDamage        = 9999;
   directDamageType    = $DamageType::Z750_SASR;
   radiusDamageType    = $DamageType::Z750_SASR;

   brickExplosionRadius = 2;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 5;
   brickExplosionMaxVolume = 10;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 15;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 25;
   verticalImpulse	  = 0;
   explosion           = Z750_SASRExplosion;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0;
   bounceFriction      = 0.01;
   isBallistic         = true;
   bounceAngle         = 0; 
   minStickVelocity    = 1000;
   gravityMod = 0;

   hasLight    = true;
   lightRadius = 5.0;
   lightColor  = "0.5 0.15 0";

   uiName = "Z-750 SASR Beam";
};

datablock ProjectileData(Z750_SASRTracerProjectile)
{
   projectileShapeName = "./BinaryBlast.dts"; //was tagLaser.dts, but it was visible ingame
   
   impactImpulse	     = 0;
   verticalImpulse	  = 0;

   muzzleVelocity      = 0.1;
   velInheritFactor    = 0;

   armingDelay         = 00;
   lifetime            = 400;
   fadeDelay           = 400;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = true;
   lightRadius = 3.0;
   lightColor  = "1 0 0";

   uiName = "Z-750 SASR Laser Flash";
};

//////////
// item //
//////////
datablock ItemData(Z750_SASRItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Z750_SASR_Ground.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Z-750 SASR Binary Rifle";
	iconName = "./UI_Z750_SASR";
	doColorShift = true;
	colorShiftColor = "0.5 0.5 0.5 1.000";

	 // Dynamic properties defined by the scripts
	image = Z750_SASRImage;
	canDrop = true;

	maxAmmo = 2;
	canReload = 1;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(Z750_SASRImage)
{
   // Basic Item properties
   shapeFile = "./Z750_SASR.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = "0.4 1.0 -0.3"; //0 -Left +Right, -Back +Front, -Down +Up
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = Z750_SASRItem;
   ammo = " ";
   projectile = Z750_SASRProjectile;
   projectileType = Projectile;

	casing = Z750_SASRCasing;
	shellExitDir        = "2.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 25.0;	
	shellVelocity       = 10.0;
	
	   raycastWeaponRange = 5000;
   raycastWeaponTargets = $TypeMasks::FxBrickObjectType |	//Targets the weapon can hit: Raycasting Bricks
   				$TypeMasks::PlayerObjectType |	//AI/Players
   				$TypeMasks::StaticObjectType |	//Static Shapes
   				$TypeMasks::TerrainObjectType |	//Terrain
   				$TypeMasks::VehicleObjectType;	//Vehicles
   raycastWeaponPierceTargets = "";				//Gun cannot pierce
   raycastExplosionPlayerSound = Z750_SASRImpactSound;
   raycastExplosionBrickSound = Z750_SASRImpactSound;
   raycastExplosionProjectile = Z750_SASRProjectile;
   raycastExplosionSound = ""; //sound played by exploding gunprojectile
   raycastDirectDamage = 9999;
   raycastDirectDamageType = $DamageType::Z750_SASR;
   //raycastCritDirectDamageType = $DamageType::Z750_SASRCRIT;
   raycastSpreadCount = 1;
   raycastSpreadAmt = 0;
   raycastTracerProjectile = Z750_SASRTracerProjectile;
   raycastFromMuzzle = true;


   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = Z750_SASRItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.
   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.7;
	stateSequence[0] = "use";
	stateTransitionOnTimeout[0]       = "LoadCheckA";
	stateSound[0]					= Z750_SASRUseSound;

	stateName[1]                     = "Ready";
	stateTransitionOnNoAmmo[1]       = "Reload";
	stateTransitionOnTriggerDown[1]  = "preFire";
	stateAllowImageChange[1]         = true;
	
	stateName[19]="preFire";
	stateTimeoutValue[19]=0;
	stateTransitionOnTimeout[19]="preFire2";
	stateScript[19]                  = "onFire";
	stateEjectShell[19]       	  = true;
	stateEmitter[19]					= Z750_SASRFlashEmitter;
	stateEmitterTime[19]				= 0.2;
	stateEmitterNode[19]				= "muzzleNode";
	stateFire[19]                    = true;
	
	stateName[21]="preFire2";
	stateTransitionOnTimeout[21]="preFire3";
	stateScript[21]				= "onLoadCheck";
	
	stateName[20]="preFire3";
	stateTransitionOnNoAmmo[20]="Fire";
	stateTransitionOnAmmo[20]="Fire";
	
	stateName[18]="Ready2";
	stateTransitionOnTriggerUp[18]="Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Delay";
	stateTimeoutValue[2]            = 0.00;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateWaitForTimeout[2]			= true;
	//stateSound[2]					= Z750_SASRFireSound;
	
	stateName[16]                    = "Fire2";
	stateTransitionOnTimeout[16]     = "Delay";
	stateTimeoutValue[16]            = 0.00;
	stateAllowImageChange[16]        = false;
	stateSequence[16]                = "Fire";
	stateWaitForTimeout[16]			= true;
	//stateSound[16]					= Z750_SASRFireSound;

	stateName[3]			= "Delay";
	stateTransitionOnTimeout[3]     = "FireLoadCheckA";
	stateTimeoutValue[3]            = 1;
	
	stateName[4]				= "LoadCheckA";
	stateScript[4]				= "onLoadCheck";
	stateTimeoutValue[4]			= 0.01;
	stateTransitionOnTimeout[4]		= "LoadCheckB";
	
	stateName[5]				= "LoadCheckB";
	stateTransitionOnAmmo[5]		= "Ready2";
	stateTransitionOnNoAmmo[5]		= "ReloadE";

	stateName[6]				= "Reload";
	stateTimeoutValue[6]			= 0.9;
	stateScript[6]				= "onReloadStart";
	stateTransitionOnTimeout[6]		= "Wait";
	stateWaitForTimeout[6]			= true;
	stateSequence[6]			= "clipOut";
	stateSound[6]				= Z750_SASRclipOutSound;
	
	stateName[7]				= "Wait";
	stateTimeoutValue[7]			= 1.2;
	stateSound[7]				= Z750_SASRclipInSound;
	stateScript[7]				= "onReloadWait";
	stateSequence[7]			= "clipIn";
	stateTransitionOnTimeout[7]		= "Reloaded";
	
	stateName[8]				= "FireLoadCheckA";
	stateScript[8]				= "onLoadCheck";
	stateTimeoutValue[8]			= 0.01;
	stateTransitionOnTimeout[8]		= "FireLoadCheckB";
	
	stateName[9]				= "FireLoadCheckB";
	stateTransitionOnAmmo[9]		= "Smoke";
	stateTransitionOnNoAmmo[9]		= "ReloadSmoke";
	
	stateName[10] 				= "Smoke";
	//stateTimeoutValue[10]			= 0.2;
	stateTransitionOnTimeout[10]		= "Ready2";
	stateTransitionOnTriggerDown[10]	= "preFire";
	
	stateName[11] 				= "ReloadSmoke";
	stateTimeoutValue[11]			= 0.2;
	stateTransitionOnTimeout[11]		= "ReloadE";
	
	stateName[12]				= "Reloaded";
	stateTimeoutValue[12]			= 0.01;
	stateScript[12]				= "onReloaded";
	stateTransitionOnTimeout[12]		= "Ready";
	
//empty reload states
	stateName[24]				= "ReloadE";
	stateTimeoutValue[24]			= 0.86;
	stateScript[24]				= "onReloadStart";
	stateTransitionOnTimeout[24]		= "WaitE";
	stateWaitForTimeout[24]			= true;
	stateSequence[24]			= "clipOut";
	stateSound[24]				= Z750_SASRClipOut_eSound;
	
	stateName[22]				= "WaitE";
	stateTimeoutValue[22]			= 1.7;
	stateSound[22]				= Z750_SASRclipIn_eSound;
	stateScript[22]				= "onReloadWait";
	stateSequence[22]			= "clipIn_e";
	stateTransitionOnTimeout[22]		= "Reloaded";
	
	stateName[23]				= "ReloadedE";
	stateTimeoutValue[23]			= 0.01;
	stateScript[23]				= "onReloaded";
	stateTransitionOnTimeout[23]		= "Ready";
};

function Z750_SASRImage::onFire(%this,%obj,%slot)
{

%pos = %obj.getTransform();
   %random = getRandom(1,2);
   switch(%random)
   {
      case 1:
         serverplay3d(Z750_SASRFire1Sound,%pos);
      case 2:
         serverplay3d(Z750_SASRFire2Sound,%pos);
      default:
         echo("Error on Z-750 SASR");
   }

	%projectile = Z750_SASRProjectile;

	if(vectorLen(%obj.getVelocity()) < 0.1)
	{
		%spread = 0.0;
	}
	else
	{
		%spread = 0.001;
	}
	
	%obj.lastShotTime = getSimTime();
	%shellcount = 1;
	%obj.toolAmmo[%obj.currTool]--;
	%obj.AmmoSpent[%obj.currTool]++;

			commandToClient(%obj.client,'bottomPrint',"<just:right><font:ds-digital:64><color:4577ab>" @ %obj.toolAmmo[%obj.currTool] @ "<font:ds-digital:24><color:004080> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
	Parent::onFire(%this,%obj,%slot);
	
	%projectile = "Z750_SASRTracerProjectile";
	
	%vector = %obj.getMuzzleVector(%slot);
	%objectVelocity = %obj.getVelocity();
	%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
	%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	
	%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
	};
	
	MissionCleanup.add(%p);
	return %p;
}


function Z750_SASRImage::onLoadCheck(%this,%obj,%slot)
{
	if(%obj.toolAmmo[%obj.currTool] <= 0)
		%obj.setImageAmmo(%slot,0);
	else
		%obj.setImageAmmo(%slot,1);
}

function Z750_SASRImage::onReloadStart(%this,%obj,%slot)
{
				commandToClient(%obj.client,'bottomPrint',"<just:right><font:ds-digital:64><color:4577ab>" @ %obj.toolAmmo[%obj.currTool] @ "<font:ds-digital:24><color:004080> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
}

function Z750_SASRImage::onReloaded(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool] = %this.item.maxAmmo;
	%obj.AmmoSpent[%obj.currTool] = 0;
	%obj.setImageAmmo(%slot,1);
			commandToClient(%obj.client,'bottomPrint',"<just:right><font:ds-digital:64><color:4577ab>" @ %obj.toolAmmo[%obj.currTool] @ "<font:ds-digital:24><color:004080> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
	return;
}

function Z750_SASRImage::onMount(%this,%obj,%slot)
{
  %obj.hidenode("RHand");
        %obj.hidenode("LHand");
		   Parent::onMount(%this,%obj,%slot);
					commandToClient(%obj.client,'bottomPrint',"<just:right><font:ds-digital:64><color:4577ab>" @ %obj.toolAmmo[%obj.currTool] @ "<font:ds-digital:24><color:004080> " @ %this.item.maxAmmo @ "", 1,2,3,4); 

}

function Z750_SASRImage::onUnMount(%this,%obj,%slot)
{
  %obj.unhidenode("RHand");
        %obj.unhidenode("LHand");
		%obj.playThread(2, root);
}